--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")

local order = {Serialize[60012],Serialize[60013],Serialize[60014],Serialize[60015],Serialize[60016],Serialize[60097],Serialize[60018],Serialize[60019],Serialize[60020],Serialize[60021]}

function This:initNode(achieve)
	self.m_achieve = achieve
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ChapterBefore.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setPosition(cc.visible.center.x,cc.visible.center.y)

	local title = achieve:getChapterTitle()
	for i = 1, 4 do
		local char = GameUtil:getChar(title,i)
		self.m_csNode.content["char"..i]:setString(char)
	end
end

function This:initTouchEvent()
end

function This:onEnter()
	super.onEnter(self)
	self.m_csNode:playCSAnimation(nil,false,function()
		self:close()
	end)
	local zorder = g_scene:getMaxLocalZOrder() + 1
	self:setLocalZOrder(zorder)
end





--endregion
