-- @Author: zheng
-- @Date:   2018-12-10 16:21:37
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-12 17:32:43
-- @File Name: CrusadeHeroSelectionItemView.lua

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")

This.fileName = "MenuScene/NodeUI/TaskCrusadeHeroItemSelection.csb"

function This:initNode(info)
    local w,h = self.iconbg:getContentSize()
    self:setContentSize(w,h)
    self.m_hero = info.hero
    self.m_btnCallBack = info.btnCallBack
    self:refresh()
end

function This:refresh()
    local heroId = self.m_hero:getId()
    self.hero:setImage(GameUtil:getItemIcon(heroId))
    self.iconbg:setImage(GameUtil:getItemIcon(heroId))
end

function This:initTouchEvent()
    self.cha:setTouchEnded(function()
        if self.m_btnCallBack then
            self.m_btnCallBack(self.m_hero:getId())
        end
    end)
end