-- @Author: zheng
-- @Date:   2018-11-01 15:58:00
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-22 11:27:48
-- @File Name: JunTuanAchievePanel.lua
local AchieveManager = require("Achieve.AchieveManager")
local JunTuanAchieveView = require("Achieve.JunTuanAchieveView")

local This , super = class(...,"Achieve.TianXiaAchievePanel")

function This:getData()
	self.m_panelTitle = Serialize["achieve_JunTuan_1"]
	self.m_uiType = AchieveType.kJunTuanDaShi
end
function This:createItem(achieve)
	return JunTuanAchieveView:create(achieve)
end

function This:onGetAchieveReward(achieve)
	AchieveManager:onGetAchieveInfoRequest(self.m_uiType)
	if achieve:getType() == self.m_uiType then
		local itemList = achieve:getRewardList()
		g_scene:showReward(itemList)
		achieve:setState(AchieveState.kHaseReward)
	end
end