--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local AchieveManager = require("Achieve.AchieveManager")
local ItemNode = require("UI.ItemNode")
local ViewUtil = require("UI.ViewUtil")

function This:init(achieve)
	self.m_achieve = achieve
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RoleMissionMainItem.csb")
	self:addChild(self.m_csNode)
	self:refresh()
end

function This:refresh()
	if self.m_achieve then
		self.m_csNode:setVisible(true)
		if self.m_achieve:getAchieveTypeId() > 0 then
			if self.m_achieve:getState() == AchieveState.kHaseFinish then
				self.m_csNode.title:setStringWithColor("<New5>" .. self.m_achieve:getName().. Serialize[60142],(not AppText:isChinese() and 250 or nil))
			else
				self.m_csNode.title:setStringWithColor("<New5>" .. self.m_achieve:getName(),(not AppText:isChinese() and 250 or nil))
			end
		else
			if self.m_achieve:getState() == AchieveState.kHaseFinish then
				self.m_csNode.title:setStringWithColor("<New7>" .. self.m_achieve:getName().. Serialize[60142],(not AppText:isChinese() and 250 or nil))
			else
				self.m_csNode.title:setStringWithColor("<New7>" .. self.m_achieve:getName(),(not AppText:isChinese() and 250 or nil))
			end
		end
	else
		self.m_csNode:setVisible(false)
		self.m_csNode.choose:setVisible(false)
	end
end

function This:setSelectHandler(handler)
	self.m_handler = handler
end

function This:setIsSelected(isSelect)
	self.m_csNode.choose:setVisible(isSelect)
end

function This:isSelected()
	return self.m_achieve and self.m_csNode.choose:isVisible()
end

function This:initTouchEvent()
	self.m_csNode.bg22:setTouchEnded(function()
		if self.m_handler then
			self.m_handler()
		end
	end)
end

function This:getModel()
	return self.m_achieve
end

function This:setModel(achieve)
	if self.m_achieve ~= achieve then
		self.m_achieve = achieve
		self:refresh()
	end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end


--endregion
