-- @Author: zheng
-- @Date:   2018-11-02 15:08:39
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-16 15:27:32
-- @File Name: WeiWangAchieve.lua

local This , super = class(...,"Achieve.MainAchieve")
local LegionWarPrestigeMissionConfig = require("Metadatas.LegionWarPrestigeMissionConfig")

function This:init(info)
	self.m_id = info.id
	self.m_type = info.type or 0
	self.m_config = LegionWarPrestigeMissionConfig[self.m_id]
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
end

function This:getNextConfig()
	local key = self.m_config.next_id
	return LegionWarPrestigeMissionConfig[key]
end

function This:getGongXun()
	return self.m_config.gongxun_num
end

--槽位
function This:getSlotNum()
	return self.m_config.solt
end


--endregion
