-- @Author: superm
-- @Date:   2017-12-29 16:01:48
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-23 14:30:32
-- @File Name: ActFamilyQueueModel.lua
-- @Description: 


local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActFamilyModel = class( This._NAME .. ".ActFamilyModel", "Activity.ActivityBaseModel")

function This:isInited()
    return true
end

function This:isDirty()
    return false
end

function This:isAllwaysDirty()
    return false
end

function This:initBaseData( info )
	if info then
		super.initBaseData(self, info)
	end
    self.m_allObejectState = false
end

function This:initBeforeUpdateState(info, createHandler)
    if info.initing then
        self.m_groupConfigList = {}
        local config = require("Metadatas.RewardConfig")
        if config then
            for index, info in ipairs(config) do
                local rewardid = info.rewardid
                if rewardid < 3 then
                    if not self.m_groupConfigList[rewardid] then
                        self.m_groupConfigList[rewardid] = {}
                    end
                    table.insert(self.m_groupConfigList[rewardid], info)
                end
            end
        end
    end
end

function This:getConfigList()
    return self.m_groupConfigList
end

function This:needBuy()
	return false
end

function This:getAllObjectState(update)
    return nil
end

function This:getUITypeName()
    return "Activity.ActivityFamilyUI"
end