-- @Author: zheng
-- @Date:   2019-02-28 15:15:49
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-02-28 15:54:26
-- @File Name: ActivityBingFaPanel.lua


local ActivityHappyTurnTabNode = require("NewActivity.ActivityHappyTurnTabNode")

local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/ActivityBingFa.csb"
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    local args ={csNode = self.m_csNode, activityType = NewActivityType.kBingFaRoulette}
    self.m_happyTurnTab = ActivityHappyTurnTabNode:create(args)
    self:addChild(self.m_happyTurnTab)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end
