-- @Author: superm
-- @Date:   2018-03-19 13:15:43
-- @Last Modified by:   superm
-- @Last Modified time: 2018-06-14 14:39:14
-- @File Name: ActivityOneGroupUI.lua
-- @Description: 

local This, super = class(..., "Activity.ActivityBaseUI")

function This:refreshListView()
	local count = self.m_activity:getGroupListCount()
	if count > 0 then
		self.m_curTabIndex = tonumber(self.m_activity:getDefaultGroup())
		self:refreshItemList( self.m_curTabIndex )
	else
		super.refreshListView(self)
	end
end

function This:refreshItemList( index )
	local count = self.m_activity:getGroupListCount()
	if count > 0 then
		if self.m_curTabIndex == nil then
			return 
		end
	    local groupList = self.m_activity:getGroupListBy( index )
	    self:refreshItemListByData(groupList)
    else
		super.refreshItemList(self, index)
   	end
		
end