-- @Author: superm
-- @Date:   2018-03-07 10:52:15
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:18:39
-- @File Name: ActivityTimerUI.lua
-- @Description: 带倒计时的活动页面

local This, super = class(..., "Activity.ActivityBaseUI")
This.csfileName = "MenuScene/NodeUI/ActivityRankBg.csb"

local ActivityItemView = require("Activity.ActivityItemView")
local GameUtil = require("Util.GameUtil")

function This:initNode()
	local cacheId = self.m_activity:getId() * 10000 + (self.m_curSelection or 1)
	self.m_curViews = ActivityItemView.getAllViews(cacheId)
	
    local csNode = self.m_csNode
    csNode.act_title:setVisible(true)
	csNode.act_title:setImage("MenuScene/act_title_" .. tostring(self.m_activity:getTitleType()) .. ".jpg")

	if csNode.time then
		csNode.time:setVisible(self.m_activity:showTimer())
		csNode.timedi_7:setVisible(self.m_activity:showTimer())
		csNode.time:setString(Serialize[60212] .. GameUtil:formatTime(Serialize["activity_BaseTabs_1_c"], self.m_activity:getLeftTime()))
	end
    self:refreshListView()
end