--local screenSize = {width = 1827, height = 843.75}
--local screenSize = {width = 960, height = 540}
--local screenSize = {width = 1024, height = 768}
--local screenSize = {width = 1280, height = 720}
local screenSize = {width = 1136, height = 640}
local designSize = {width = 960, height = 540}
local widthScale = screenSize.width / designSize.width
local heightScale = screenSize.height / designSize.height

return {
	name = "Cocos2dx",
	screenSize = {screenSize.width,screenSize.height},
	designSize = {designSize.width,designSize.height},
	resolutionPolicy = "FixedHeight",
	--resolutionPolicy = "ShowAll",
	projection = "2D",
	minScale = widthScale > heightScale and heightScale or widthScale,
	maxScale = widthScale > heightScale and widthScale or heightScale,
	widthScale = widthScale,
	heightScale = heightScale,
}
