-- @Author: superm
-- @Date:   2018-05-08 17:20:56
-- @Last Modified by:   superm
-- @Last Modified time: 2018-05-08 17:52:18
-- @File Name: ArenaRankUpReawrdPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local MenuScene = require("Home.MenuScene")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Arenarule.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.number:setString(info.maxRank)
	self.m_csNode.Text2:setString(info.offsetRank)
	if info.diamond > 0 then
		local node = ItemNode:create(102, info.diamond)
		node:setCascadeOpacityEnabled(true)
		node:setAnchorPoint(0.5,0.5)
		self.m_csNode.item:addChild(node)
		self.m_csNode.tips:setVisible(false)
	else
		self.m_csNode.tips:setVisible(true)
	end
end

function This:onEnter()
	super.onEnter(self)
	self.m_csNode:playCSAnimation(nil,false)
end


function This:onTouchMask()
	self:close()
end
