--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)

function This:create(...)
	local o = {}
	setmetatable(o,self)
	o:init(...)
	return o
end

function This:init()
	self.m_observers = {}
end

function This:addObserver(o)
	for i , observer in pairs(self.m_observers) do
		if observer == o then
			return 
		end
	end
	table.insert(self.m_observers,o)
end

function This:removeObserver(o)
	for i , observer in pairs(self.m_observers) do
		if observer == o then
			table.remove(self.m_observers,i)
			return
		end
	end
end

function This:notifyObservers(funcName,...)
	local observers = {}
	for i , o in pairs(self.m_observers) do
		table.insert(observers,o)
	end
	
	for i, observer in pairs(observers) do
		if observer[funcName] then
			observer[funcName](observer,...)
		end
	end
end

--endregion
