--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)

AttrType =
{
	kHp = 1,    --血量
	kMaxHp = 2,  --最大血量
	kMaxHpRatio = 3, --最大血量加成
	kPower = 4,  --力量
	kIntelligence = 5, --智力
	kChiefValue = 6,  --统帅值
	kCritRatio = 7,  --暴击概率
	kDodge = 8,  --闪避概率
	kPenetrate = 9, --识破概率
	kAngerValue = 10, --怒气值
	kDfs = 11, --御
	kPowerGrowValue = 12, --武力成长值
	kIntelligenceGrowValue = 13, --智力成长值
	kChiefGrowValue = 14, --统帅成长值
	kDfsGrowValue = 15, --御成长值
	kDefenceCritRatio = 16, --抗暴
	kDefencePenetrate = 17, --对抗识破率
	kDefenceDodge = 18, --对抗闪避率

	kFirst = 100, --武将先手值
	kPhyAttack = 101, --物理攻击
	kPhyAttAddRatio = 102, --物理攻击加成
	kPhyDefence = 103, --物理防御
	kPhyDefAddRatio = 104, --物理防御加成
	kPhyDamageAddRatio = 105,  --物理伤害加成
	kPhyDamageReduceRatio = 106, --物理伤害减免
	kMagicAttack = 107,  --魔法攻击
	kMagicAttAddRatio = 108, --魔法攻击加成
	kMagicDefence = 109,  --魔法防御
	kMagicDefAddRatio = 110, --魔法防御加成
	kMagicDamageAddRatio = 111,  --魔法伤害加成
	kMagicDamageReduceRatio = 112, --魔法伤害减免
	kBothAttAddRatio = 113, --双攻加成
	kBothDefAddRatio = 114, --双防加成
	kBothDamageAddRatio = 115,  --物理魔法伤害加成
	kBothDamageReduceRatio = 116, --物理魔法伤害减免
	kAdditionalPhyDamage = 117, --额外物理伤害
	kAdditionalPlanDamage = 118, --额外计策伤害
	kAdditionalPhyDamageReduce = 119, --额外物理减免
	kAdditionalPlanDamageReduce = 120, --额外计策减免
	kAdditionalPhyDamageAddRatio = 121, --额外物理伤害加成，百分比类型
	kAdditionalPlanDamageAddRatio = 122, --额外计策伤害加成，百分比类型
	kDamageBlockPercent = 123, --伤害格挡百分比
	kDamageBlockRatio = 124, --伤害格挡概率
	kBurstBonus =125,--爆伤加成
	kBurstRelief =126,--爆伤减免

	kIsImmuneDebuff = 201,  --是否免疫debuff
	kIsImmuneDamage = 202,  --是否免疫伤害
	kIsCanCommonAttack = 203, --是否能普攻
	kIsCanCastSkill = 204, --是否能释放技能
	kIsCanRecoverAnger = 205, --是否能回复怒气
	kHpAddRatio = 206, --生命回复加成系数
	kPhyDamageValue = 207, --受一系列攻击时的最终的物理伤害
	kMagicDamageValue = 208, --受到一些列攻击时的最终魔法攻击

	kToArmy1DamegeRatio = 301, --对步兵伤害加成
	kForArmy1DamegeRatio = 302,--受到步兵伤害减免
	kToArmy2DamegeRatio = 303,--对弓兵伤害加成
	kForArmy2DamegeRatio = 304,--受到弓兵伤害减免
	kToArmy3DamegeRatio = 305,--对骑兵伤害加成
	kForArmy3DamegeRatio = 306,--受到骑兵伤害减免
	kToArmy4DamegeRatio = 307,--对车兵伤害加成
	kForArmy4DamegeRatio = 308,--受到车兵伤害减免
	kToWallDamegeRatio = 309,--对城墙伤害加成
	kForWallDamegeRatio = 310,--受到城墙伤害减免

}

AttrName=
{
	[AttrType.kHp] = Serialize["Battle_AttributeHelper_1"],
	[AttrType.kMaxHp] = Serialize["Battle_AttributeHelper_2"],
	[AttrType.kMaxHpRatio] = Serialize["Battle_AttributeHelper_3"],--（加成）
	[AttrType.kPower] = Serialize["Battle_AttributeHelper_4"],
	[AttrType.kIntelligence] = Serialize["Battle_AttributeHelper_5"],
	[AttrType.kChiefValue] = Serialize["Battle_AttributeHelper_6"],
	[AttrType.kCritRatio] = Serialize["Battle_AttributeHelper_7"],
	[AttrType.kDodge] = Serialize["Battle_AttributeHelper_8"],
	[AttrType.kPenetrate]= Serialize["Battle_AttributeHelper_9"],
	[AttrType.kAngerValue] = Serialize["Battle_AttributeHelper_10"],

	[AttrType.kDfs] = Serialize["Battle_AttributeHelper_11"],
	[AttrType.kPowerGrowValue] = Serialize["Battle_AttributeHelper_12"],
	[AttrType.kIntelligenceGrowValue] = Serialize["Battle_AttributeHelper_13"],
	[AttrType.kChiefGrowValue] = Serialize["Battle_AttributeHelper_14"],
	[AttrType.kDfsGrowValue] = Serialize["Battle_AttributeHelper_15"],
	[AttrType.kDefenceCritRatio] = Serialize["Battle_AttributeHelper_16"],
	[AttrType.kDefencePenetrate] = Serialize["Battle_AttributeHelper_17"],
	[AttrType.kDefenceDodge] = Serialize["Battle_AttributeHelper_18"],

	[AttrType.kFirst] = Serialize["Battle_AttributeHelper_19"],
	[AttrType.kPhyAttack] = Serialize["Battle_AttributeHelper_20_c"],
	[AttrType.kPhyAttAddRatio] = Serialize["Battle_AttributeHelper_21"],
	[AttrType.kPhyDefence] = Serialize["Battle_AttributeHelper_22"],
	[AttrType.kPhyDefAddRatio] = Serialize["Battle_AttributeHelper_23"],
	[AttrType.kPhyDamageAddRatio] = Serialize["Battle_AttributeHelper_24"],
	[AttrType.kPhyDamageReduceRatio] = Serialize["Battle_AttributeHelper_25"],
	[AttrType.kMagicAttack] = Serialize["Battle_AttributeHelper_26_c"],
	[AttrType.kMagicAttAddRatio] = Serialize["Battle_AttributeHelper_27"],
	[AttrType.kMagicDefence] = Serialize["Battle_AttributeHelper_28"],
	[AttrType.kMagicDefAddRatio] = Serialize["Battle_AttributeHelper_29"],
	[AttrType.kMagicDamageAddRatio] = Serialize["Battle_AttributeHelper_30"],
	[AttrType.kMagicDamageReduceRatio] = Serialize["Battle_AttributeHelper_31"],
	[AttrType.kBothAttAddRatio] = Serialize["Battle_AttributeHelper_32"],
	[AttrType.kBothDefAddRatio] = Serialize["Battle_AttributeHelper_33"],
	[AttrType.kBothDamageAddRatio] = Serialize["Battle_AttributeHelper_34"],
	[AttrType.kBothDamageReduceRatio] = Serialize["Battle_AttributeHelper_35"],
	[AttrType.kAdditionalPhyDamage] = Serialize["Battle_AttributeHelper_52"],
	[AttrType.kAdditionalPlanDamage] = Serialize["Battle_AttributeHelper_53"],
	[AttrType.kAdditionalPhyDamageReduce] = Serialize["Battle_AttributeHelper_54"],
	[AttrType.kAdditionalPlanDamageReduce] = Serialize["Battle_AttributeHelper_55"],
	[AttrType.kAdditionalPhyDamageAddRatio] = Serialize["Battle_AttributeHelper_56"],
	[AttrType.kAdditionalPlanDamageAddRatio] = Serialize["Battle_AttributeHelper_57"],
	[AttrType.kDamageBlockPercent] = Serialize["Battle_AttributeHelper_58"],
	[AttrType.kDamageBlockRatio] = Serialize["Battle_AttributeHelper_59"],
	[AttrType.kBurstBonus] = Serialize["Battle_AttributeHelper_60"],
	[AttrType.kBurstRelief] = Serialize["Battle_AttributeHelper_61"],

	[AttrType.kIsImmuneDebuff] = Serialize["Battle_AttributeHelper_36"],
	[AttrType.kIsImmuneDamage] = Serialize["Battle_AttributeHelper_37"],
	[AttrType.kIsCanCommonAttack] = Serialize["Battle_AttributeHelper_38"],
	[AttrType.kIsCanCastSkill] = Serialize["Battle_AttributeHelper_39"],
	[AttrType.kIsCanRecoverAnger] = Serialize["Battle_AttributeHelper_40"],
	[AttrType.kHpAddRatio] = Serialize["Battle_AttributeHelper_41"],
	[AttrType.kPhyDamageValue] = Serialize["Battle_AttributeHelper_20_c"],
	[AttrType.kMagicDamageValue] = Serialize["Battle_AttributeHelper_26_c"],


	[AttrType.kToArmy1DamegeRatio] = Serialize["Battle_AttributeHelper_42"],
	[AttrType.kForArmy1DamegeRatio] = Serialize["Battle_AttributeHelper_43"],
	[AttrType.kToArmy2DamegeRatio] = Serialize["Battle_AttributeHelper_44"],
	[AttrType.kForArmy2DamegeRatio] = Serialize["Battle_AttributeHelper_45"],
	[AttrType.kToArmy3DamegeRatio] = Serialize["Battle_AttributeHelper_46"],
	[AttrType.kForArmy3DamegeRatio] = Serialize["Battle_AttributeHelper_47"],
	[AttrType.kToArmy4DamegeRatio] = Serialize["Battle_AttributeHelper_48"],
	[AttrType.kForArmy4DamegeRatio] = Serialize["Battle_AttributeHelper_49"],
	[AttrType.kToWallDamegeRatio] = Serialize["Battle_AttributeHelper_50"],
	[AttrType.kForWallDamegeRatio] = Serialize["Battle_AttributeHelper_51"],
}

ValueType = 
{
	kPercent = 1,
	kValue = 2,
	kBoolean = 3,
}

AttrInfo = 
{
	[AttrType.kHp] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kMaxHp] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kMaxHpRatio] = {
		valueType = ValueType.kPercent,
	},--（加成）
	[AttrType.kPower] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kIntelligence] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kChiefValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kCritRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kDodge] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kPenetrate]= {
		valueType = ValueType.kPercent,
	},
	[AttrType.kAngerValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kDfs] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kPowerGrowValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kIntelligenceGrowValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kChiefGrowValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kDfsGrowValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kDefenceCritRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kDefencePenetrate] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kDefenceDodge] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kFirst] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kPhyAttack] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kPhyAttAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kPhyDefence] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kPhyDefAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kPhyDamageAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kPhyDamageReduceRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kMagicAttack] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kMagicAttAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kMagicDefence] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kMagicDefAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kMagicDamageAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kMagicDamageReduceRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kBothAttAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kBothDefAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kBothDamageAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kBothDamageReduceRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kAdditionalPhyDamage] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kAdditionalPlanDamage] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kAdditionalPhyDamageReduce] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kAdditionalPlanDamageReduce] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kAdditionalPhyDamageAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kAdditionalPlanDamageAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kDamageBlockPercent] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kDamageBlockRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kBurstBonus] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kBurstRelief] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kIsImmuneDebuff] = {
		valueType = ValueType.kBoolean,
	},
	[AttrType.kIsImmuneDamage] = {
		valueType = ValueType.kBoolean,
	},
	[AttrType.kIsCanCommonAttack] = {
		valueType = ValueType.kBoolean,
	},
	[AttrType.kIsCanCastSkill] = {
		valueType = ValueType.kBoolean,
	},
	[AttrType.kIsCanRecoverAnger] = {
		valueType = ValueType.kBoolean,
	},
	[AttrType.kHpAddRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kPhyDamageValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kMagicDamageValue] = {
		valueType = ValueType.kValue,
	},
	[AttrType.kToArmy1DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kForArmy1DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kToArmy2DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kForArmy2DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kToArmy3DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kForArmy3DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kToArmy4DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kForArmy4DamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kToWallDamegeRatio] = {
		valueType = ValueType.kPercent,
	},
	[AttrType.kForWallDamegeRatio] = {
		valueType = ValueType.kPercent,
	},
}

DamageType = 
{
	kPhyDamage = 1 , --物理伤害
	kMagicDamage = 2, --法术伤害
}

kPowerToAttackRatio = 3
kDfsToDefenceRatio = 2.5
kChielfToMaxHpRatio = 16
kIntelligenceToAttackRatio = 3
kIntelligenceToDefenceRatio = 1

function This:create()
	local o = {}
	setmetatable(o,self)
	o:init()
	return o
end

function This:init()
	self.m_attr = {}
	self:setAttrDefault()
	self.m_max = {}
	self.m_max[AttrType.kDodge] = 0.6
	self.m_max[AttrType.kPenetrate] = 0.6
	self.m_max[AttrType.kCritRatio] = 1.0
end

function This:setAttrDefault()
	for i , key in pairs(AttrType) do
		self.m_attr[key] = 0
	end
end

function This:getAllAttr()
	return self.m_attr
end

function This:copy()
	local a = {}
	setmetatable(a,This)
	a.m_attr = {}
	a.m_max = {}
	for k , v in pairs(self.m_attr) do
		a.m_attr[k] = v
	end
	for k , v in pairs(self.m_max) do
		a.m_max[k] = v
	end
	return a
end

function This:setAllAttr(attrs)
	if not attrs then return end
	for key , value in pairs(self.m_attr) do
		if attrs[key] then
			self.m_attr[key] = attrs[key]
		end
	end
end

function This:getAttr(attrId)
	if self.m_attr[attrId] then
		local v = self.m_attr[attrId]
		if attrId == AttrType.kMaxHp then
			v = v * (1 + self.m_attr[AttrType.kMaxHpRatio])
		elseif attrId == AttrType.kPhyAttack then
			local addRatio = self.m_attr[AttrType.kPhyAttAddRatio] + self.m_attr[AttrType.kBothAttAddRatio]
			v = v * ( 1 + addRatio)
		elseif attrId == AttrType.kPhyDefence then
			local addRatio = self.m_attr[AttrType.kPhyDefAddRatio] + self.m_attr[AttrType.kBothDefAddRatio]
			v = v * (1 + addRatio)
		elseif attrId == AttrType.kMagicAttack then
			local addRatio = self.m_attr[AttrType.kMagicAttAddRatio] + self.m_attr[AttrType.kBothAttAddRatio]
			v = v * (1 + addRatio)
		elseif attrId == AttrType.kMagicDefence then
			local addRatio = self.m_attr[AttrType.kMagicDefAddRatio] + self.m_attr[AttrType.kBothDefAddRatio]
			v = v * (1 + addRatio)
		elseif attrId == AttrType.kPower then
			v = v + self.m_attr[AttrType.kPowerGrowValue]
		elseif attrId == AttrType.kIntelligence then
			v = v + self.m_attr[AttrType.kIntelligenceGrowValue]
		elseif attrId == AttrType.kChiefValue then
			v = v + self.m_attr[AttrType.kChiefGrowValue]
		elseif attrId == AttrType.kDfs then
			v = v + self.m_attr[AttrType.kDfsGrowValue]
		end
		if self.m_max[attrId] then
			return v > self.m_max[attrId] and self.m_max[attrId] or v
		end
		return v
	end
	return 0
end

function This:setAttr(attrId,value)
	if self.m_attr[attrId] then
		self.m_attr[attrId] = value
		if attrId == AttrType.kPower then
			self.m_attr[AttrType.kPhyAttack] = (value + self.m_attr[AttrType.kPowerGrowValue]) * kPowerToAttackRatio
		elseif attrId == AttrType.kChiefValue then
			self.m_attr[AttrType.kMaxHp] = (value + self.m_attr[AttrType.kChiefGrowValue]) * kChielfToMaxHpRatio
		elseif attrId == AttrType.kIntelligence then
			self.m_attr[AttrType.kMagicAttack] = (value + self.m_attr[AttrType.kIntelligenceGrowValue]) * kIntelligenceToAttackRatio
			self.m_attr[AttrType.kMagicDefence] = (value + self.m_attr[AttrType.kIntelligenceGrowValue])* kIntelligenceToDefenceRatio
		elseif attrId == AttrType.kDfs then
			self.m_attr[AttrType.kPhyDefence] = (value + self.m_attr[AttrType.kDfsGrowValue])* kDfsToDefenceRatio
		elseif attrId == AttrType.kPowerGrowValue then
			self.m_attr[AttrType.kPhyAttack] = (value + self.m_attr[AttrType.kPower]) * kPowerToAttackRatio
		elseif attrId == AttrType.kIntelligenceGrowValue then
			self.m_attr[AttrType.kMagicAttack] = (value + self.m_attr[AttrType.kIntelligence]) * kIntelligenceToAttackRatio
			self.m_attr[AttrType.kMagicDefence] = (value + self.m_attr[AttrType.kIntelligence])* kIntelligenceToDefenceRatio
		elseif attrId == AttrType.kChiefGrowValue then
			self.m_attr[AttrType.kMaxHp] = (value + self.m_attr[AttrType.kChiefValue]) * kChielfToMaxHpRatio
		elseif attrId == AttrType.kDfsGrowValue then
			self.m_attr[AttrType.kPhyDefence] = (value + self.m_attr[AttrType.kDfs])* kDfsToDefenceRatio
		end
		return value
	end
	assert(false,string.format("have not the attrId:%d",attrId))
end

function This:addAttr(attrId,value)
	if self.m_attr[attrId] then
		-- if attrId ==103 and value>0 then
		-- 	print("add-->",value)
		-- 	print(self.m_attr[attrId])
		-- end
		self.m_attr[attrId] = self.m_attr[attrId] + value
		-- print(self.m_attr[attrId])
		if attrId == AttrType.kHp then
			if self.m_attr[attrId] > self.m_attr[AttrType.kMaxHp] then
				self.m_attr[attrId] = self.m_attr[AttrType.kMaxHp]
			end
		elseif attrId == AttrType.kPower then
			self.m_attr[AttrType.kPhyAttack] = self.m_attr[AttrType.kPhyAttack] + value * kPowerToAttackRatio
		elseif attrId == AttrType.kChiefValue then
			self.m_attr[AttrType.kMaxHp] = self.m_attr[AttrType.kMaxHp] + value * kChielfToMaxHpRatio
		elseif attrId == AttrType.kIntelligence then
			self.m_attr[AttrType.kMagicAttack] = self.m_attr[AttrType.kMagicAttack] + value * kIntelligenceToAttackRatio
			self.m_attr[AttrType.kMagicDefence] = self.m_attr[AttrType.kMagicDefence] + value * kIntelligenceToDefenceRatio
		elseif attrId == AttrType.kDfs then
			self.m_attr[AttrType.kPhyDefence] = self.m_attr[AttrType.kPhyDefence] + value * kDfsToDefenceRatio
		elseif attrId == AttrType.kPowerGrowValue then
			self.m_attr[AttrType.kPhyAttack] = self.m_attr[AttrType.kPhyAttack] + value * kPowerToAttackRatio
		elseif attrId == AttrType.kChiefGrowValue then
			self.m_attr[AttrType.kMaxHp] = self.m_attr[AttrType.kMaxHp] + value * kChielfToMaxHpRatio
		elseif attrId == AttrType.kIntelligenceGrowValue then
			self.m_attr[AttrType.kMagicAttack] = self.m_attr[AttrType.kMagicAttack] + value * kIntelligenceToAttackRatio
			self.m_attr[AttrType.kMagicDefence] = self.m_attr[AttrType.kMagicDefence] + value * kIntelligenceToDefenceRatio
		elseif attrId == AttrType.kDfsGrowValue then
			self.m_attr[AttrType.kPhyDefence] = self.m_attr[AttrType.kPhyDefence] + value * kDfsToDefenceRatio
		end
		return self.m_attr[attrId]
	end
	assert(false,string.format("have not the attrId:%d",attrId))
end

function This:reduceAttr(attrId,value)
	if self.m_attr[attrId] then
		-- if attrId ==103 and value>0 then
		-- 	print("remove-->",value)
		-- 	print(self.m_attr[attrId])
		-- end
		self.m_attr[attrId] = self.m_attr[attrId] - value
		-- print(self.m_attr[attrId])
		if attrId == AttrType.kPower then
			self.m_attr[AttrType.kPhyAttack] = self.m_attr[AttrType.kPhyAttack] - value * kPowerToAttackRatio
		elseif attrId == AttrType.kChiefValue then
			self.m_attr[AttrType.kMaxHp] = self.m_attr[AttrType.kMaxHp] - value * kChielfToMaxHpRatio
		elseif attrId == AttrType.kIntelligence then
			self.m_attr[AttrType.kMagicAttack] = self.m_attr[AttrType.kMagicAttack] - value * kIntelligenceToAttackRatio
			self.m_attr[AttrType.kMagicDefence] = self.m_attr[AttrType.kMagicDefence] - value * kIntelligenceToDefenceRatio
		elseif attrId == AttrType.kDfs then
			self.m_attr[AttrType.kPhyDefence] = self.m_attr[AttrType.kPhyDefence] - value * kDfsToDefenceRatio
		elseif attrId == AttrType.kPowerGrowValue then
			self.m_attr[AttrType.kPhyAttack] = self.m_attr[AttrType.kPhyAttack] - value * kPowerToAttackRatio
		elseif attrId == AttrType.kChiefGrowValue then
			self.m_attr[AttrType.kMaxHp] = self.m_attr[AttrType.kMaxHp] - value * kChielfToMaxHpRatio
		elseif attrId == AttrType.kIntelligenceGrowValue then
			self.m_attr[AttrType.kMagicAttack] = self.m_attr[AttrType.kMagicAttack] - value * kIntelligenceToAttackRatio
			self.m_attr[AttrType.kMagicDefence] = self.m_attr[AttrType.kMagicDefence] - value * kIntelligenceToDefenceRatio
		elseif attrId == AttrType.kDfsGrowValue then
			self.m_attr[AttrType.kPhyDefence] = self.m_attr[AttrType.kPhyDefence] - value * kDfsToDefenceRatio
		end
		return self.m_attr[attrId]
	end
	assert(false,string.format("have not the attrId:%d",attrId))
end

function This:caculatePhyDamage(otherAttr)
	--[[print("敌方属性如下：")
	otherAttr:print()
	print("我方属性如下：")
	self:print()]]
	local attack = self:getAttr(AttrType.kPhyAttack)
	local defence = otherAttr:getAttr(AttrType.kPhyDefence)
	local addRatio = self:getAttr(AttrType.kPhyDamageAddRatio) + self:getAttr(AttrType.kBothDamageAddRatio)
	local reduceRatio = otherAttr:getAttr(AttrType.kPhyDamageReduceRatio) + otherAttr:getAttr(AttrType.kBothDamageReduceRatio)
	
	local ratio = math.max(1 + addRatio - reduceRatio, 0.1)
	local damage = (attack - defence) * ratio
	local minDamage = attack * 0.1 * ratio
	print(string.format("物理攻击 攻击:%f,防御:%f,伤害加成:%f,伤害减免:%f,最终伤害系数:%f,最小伤害:%f,伤害:%f",attack,defence,addRatio,reduceRatio,ratio,minDamage,damage))
	return math.max(damage,minDamage)
end

function This:caculateMagicDamage(otherAttr)
	--[[print("敌方属性如下：")
	otherAttr:print()
	print("我方属性如下：")
	self:print()]]
	local attack = self:getAttr(AttrType.kMagicAttack)
	local defence = otherAttr:getAttr(AttrType.kMagicDefence)
	local addRatio = self:getAttr(AttrType.kMagicDamageAddRatio) + self:getAttr(AttrType.kBothDamageAddRatio)
	local reduceRatio = otherAttr:getAttr(AttrType.kMagicDamageReduceRatio) + otherAttr:getAttr(AttrType.kBothDamageReduceRatio)
	
	local ratio = math.max(1 + addRatio - reduceRatio, 0.1)
	local damage = (attack - defence) * ratio
	local minDamage = attack * 0.1 * ratio
	print(string.format("计策攻击 攻击:%f,防御:%f,伤害加成:%f,伤害减免:%f,最终伤害系数:%f,最小伤害:%f,伤害:%f",attack,defence,addRatio,reduceRatio,ratio,minDamage,damage))
	return math.max(damage,minDamage)
end

function This:checkCrit()
	local n = self:getAttr(AttrType.kCritRatio) * 100
	return math.random(1,100) <= n
end

function This:checkDodge()
	local n = self:getAttr(AttrType.kDodge) * 100
	return math.random(1,100) <= n
end

function This:checkPenetrate()
	local n = self:getAttr(AttrType.kPenetrate) * 100
	return math.random(1,100) <= n
end

function This:IsImmuneControl()
	return self:getAttr(AttrType.kIsImmuneControl) > 0
end  --免疫控制

function This:IsImmuneDebuff()
	return self:getAttr(AttrType.kIsImmuneDebuff) > 0
end  --免疫debuff

function This:IsImmuneDamage()
	return self:getAttr(AttrType.kIsImmuneDamage) > 0
end--免疫伤害

function This:IsCanCommonAttack() 
	return self:getAttr(AttrType.kIsCanCommonAttack) <= 0
end--是否能普攻

function This:IsCanCastSkill()
	return self:getAttr(AttrType.kIsCanCastSkill) <= 0
end --是否能释放技能

function This:IsCanRecoverAnger()
	return self:getAttr(AttrType.kIsCanRecoverAnger) <= 0
end --是否能回复怒气

function This:print()
	local str = ""
	for key , value in pairs(self.m_attr) do
		str = str .. string.format("%s = %f, ",AttrName[key],value)
	end
	print(str)
end

--endregion
