--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Battle.BattleSceneView")
local BattleDataManager = require("Battle.BattleDataManager")

function This:init()
	super.init(self)
	--self.m_panel = cc.Node:createFromCSFile("GameScene/NodeUI/BattleTestScene.csb")
	--self:addChild(self.m_panel)

	self.m_troopsInfo = 
	{
		{index = 1 , isEnemy = false, soilderNum = 16, heroId = 1},
		{index = 2 , isEnemy = false, soilderNum = 16, heroId = 2},
		{index = 3 , isEnemy = false, soilderNum = 16, heroId = 1},
		{index = 4 , isEnemy = false, soilderNum = 16, heroId = 2},
		{index = 5 , isEnemy = false, soilderNum = 16, heroId = 1},
		{index = 6 , isEnemy = false, soilderNum = 16, heroId = 2},
		{index = 1 , isEnemy = true, soilderNum = 16, heroId = 1},
		{index = 2 , isEnemy = true, soilderNum = 16, heroId = 2},
		{index = 3 , isEnemy = true, soilderNum = 16, heroId = 1},
		{index = 4 , isEnemy = true, soilderNum = 16, heroId = 2},
		{index = 5 , isEnemy = true, soilderNum = 16, heroId = 1},
		{index = 6 , isEnemy = true, soilderNum = 16, heroId = 2}
	}
	self.m_key = nil
	self:addTouchListener({
		onBegan = function(touch,point)
			self:onTouchBegan(touch,point)
		end,
		onEnded = function(touch,point)
			self:onTouchEnded(touch,point)
		end
	})
end

function This:onEnter()
	super.onEnter(self)
	cc.Application:addListener(self)
end

function This:onExit()
	super.onExit(self)
	cc.Application:removeListener(self)
end

function This:refreshAttr(troops)
	local attrPanel = self.m_panel.Panel_Attr
	attrPanel.Text_hp:setString(AttrName(AttrType.kHp)..":"..troops:getAttr(AttrType.kHp))
	attrPanel.Text_maxhp:setString(AttrName(AttrType.kMaxHp)..":"..troops:getAttr(AttrType.kMaxHp))
	attrPanel.Text_maxhpratio:setString(AttrName(AttrType.kHpAddRatio)..":"..troops:getAttr(AttrType.kHpAddRatio))
	attrPanel.Text_power:setString(AttrName(AttrType.kPower)..":"..troops:getAttr(AttrType.kPower))
	attrPanel.Text_Intelligence:setString(AttrName(AttrType.kIntelligence)..":"..troops:getAttr(AttrType.kIntelligence))
	attrPanel.Text_ChiefValue:setString(AttrName(AttrType.kChiefValue)..":"..troops:getAttr(AttrType.kChiefValue))
	attrPanel.Text_CritRatio:setString(AttrName(AttrType.kCritRatio)..":"..troops:getAttr(AttrType.kCritRatio))
	attrPanel.Text_Dodge:setString(AttrName(AttrType.kDodge)..":"..troops:getAttr(AttrType.kDodge))
	attrPanel.Text_Penetrate:setString(AttrName(AttrType.kPenetrate)..":"..troops:getAttr(AttrType.kPenetrate))
	attrPanel.Text_AngerValue:setString(AttrName(AttrType.kAngerValue)..":"..troops:getAttr(AttrType.kAngerValue))
	attrPanel.Text_PhyAttack:setString(AttrName(AttrType.kPhyAttack)..":"..troops:getAttr(AttrType.kPhyAttack))
	attrPanel.Text_PhyAttAddRatio:setString(AttrName(AttrType.kPhyAttAddRatio)..":"..troops:getAttr(AttrType.kPhyAttAddRatio))
	attrPanel.Text_PhyDefence:setString(AttrName(AttrType.kPhyDefence)..":"..troops:getAttr(AttrType.kPhyDefence))
	attrPanel.Text_PhyDefAddRatio:setString(AttrName(AttrType.kPhyDefAddRatio)..":"..troops:getAttr(AttrType.kPhyDefAddRatio))
	
end

function This:onKeyDown(keyCode)
	if keyCode == '1' then
		self:onShowStagePanel()
	elseif keyCode == 'N' then
		BattleDataManager:nextStep()
	else
		self.m_key = keyCode
	end
end

function This:onShowStagePanel()
	local panel = self:openDialog("Stage.StagePanel")

end

function This:onKeyUp(keyCode)
	self.m_key = nil
end

function This:onTouchBegan(touch,point)
	return true
end

function This:onTouchEnded(touch,point)
	local x , y = self:convertToNodeSpace(point.x,point.y)
	for id, view in pairs(self.m_troopsViews) do
		local w , h = view:getContentSize()
		if view:getBoundingBox():isContainsPoint(cc.Vec(x,y)) then
			if self.m_key == 'Q' then
				self.m_attacker = view:getModel()
				print(string.format("select attacker %d",self.m_attacker:getId()))
			elseif self.m_key == 'W' then
				self.m_hitter = view:getModel()
				print(string.format("select hitter %d",self.m_hitter:getId()))
			elseif self.m_key == 'E' then
				self.m_hitters = self.m_hitters or {}
				local hitter = view:getModel()
				table.insert(self.m_hitters,hitter)
				print(string.format("select hitter %d",hitter:getId()))
			end
			return
		end
	end
end
--endregion
