--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Battle.BattlePerformer")
local SkillWallSoilder = require("Skill.SkillWallSoilder")
local AttributeHelper = require("Battle.AttributeHelper")

function This:init(info)
	self.m_isEnemy = true
	self.m_index = 7
	self.m_id = 107
	self.m_x = 1
	self.m_y = 7
	self.m_view = nil
	self.m_state = TroopsState.kFree
	self.m_heroId = info.heroId
	self.m_buffs = {}

	self.m_attr = AttributeHelper:create()
	self.m_attr = AttributeHelper:create()
	self.m_attr:setAttr(AttrType.kHp,info.hp)
	self.m_attr:setAttr(AttrType.kMaxHp,info.hp)
	self.m_attr:setAttr(AttrType.kAngerValue,info.anger)
	self.m_attr:setAllAttr(info.attrList)
end

function This:castSkill(skillId,effectList,result)
	print("城墙兵普攻...")
	self.m_state = TroopsState.kAttack
	self.m_skill = SkillWallSoilder:create()
	self.m_skill:setTroops(self)
	self.m_attacStartkTime = os.clock()
	self.m_activeEndTime = os.clock()
	self.m_forwardEndTime = os.clock()
	self.m_skill:work(effectList)
end

function This:attack(target,attackEndHandler)
	local function endHandler()
		if attackEndHandler then
			attackEndHandler()
		end
	end
	if self.m_view then
		self.m_view:attack(target,endHandler)
	else
		endHandler()
	end
end

function This:back(isNeedBack,endHandler)
	self.m_attackEndTime = os.clock()
	super.back(self,isNeedBack,endHandler)
	self.m_state = TroopsState.kFree
end


--endregion
