-- @Author: Su
-- @Date:   2019-07-11 10:18:33
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-11 10:18:33
-- @File Name: PrincipalBoss.lua
-- @Description: 

local This ,super = class(...,"Base.BaseModel")
local HeroManager = require("Hero.HeroManager")

function This:create(info)
	local ret = {}
	setmetatable(ret, self)
	ret:init(info)
	return ret
end

function This:init(info)
    self.m_config = info
end

function This:isCardCanChallenge(uid)
	if not self.m_challengeCards then
		return true
	end
	
	return not self.m_challengeCards[uid]
end

function This:getCanEmbattleHeroList()
	local heroList = HeroManager:getAllHeroGotWithSort(function(hero)
		if not self:isCardCanChallenge(hero:getUid()) then
			return false
		end
		return true
	end)
	return heroList
end

function This:getName()
    return self.m_config.name
end

function This:getCurHp()

end

function This:getConfig()
	return self.m_config
end