-- @Author: Su
-- @Date:   2019-07-11 09:48:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-04 20:34:46
-- @File Name: PrincipalBossEmbattlePanel.lua
-- @Description: 

local This , super = class(...,"Family.BossEmbattlePanel")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")

function This:initItems()
	-- super.initItems(self)	
end

function This:initBaseInfo()
	self.m_csNode.bg3.tagettext:setString(Serialize[60508])
	self.m_csNode.bg3.taget:setString(self.m_stage:getName())
	self.m_csNode.bg3.name:setString(GamePlayer:getRoleName())
	self.m_csNode.bg3.totalhp:setString("0")
	self.m_csNode.bg3.consume:setString(Serialize[60509])
	self.m_csNode.bg3.cost:setString(self.m_stage:getCurHp())
	self.m_csNode.text100:setVisible(false)
	self.m_csNode.time:setVisible(false)
	self.m_csNode.diban2:setVisible(false)
	self.m_csNode.bg3.cost:setVisible(false)
	self.m_csNode.bg3.consume:setVisible(false)
end

function This:onCloseBtnClick()
	if self.m_battleHandler then
		self.m_battleHandler()
	end
	self:close()
end

function This:getAllHeroList()
	local heros = HeroManager:getAllHeroGotWithSort(function(hero) 
		if hero:isDeputy() then
			return false
		end
		return true
	end)
	table.sort(heros,function(a,b)
		return a:getFightPower() > b:getFightPower()
	end)
	return heros
end