--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")

function This:init(text,style)
	self.m_text = text
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PaoMaDeng.csb")

	local label = cc.Label:createNormalTTF("",14)
	label:setStringWithColor(text)
	label:setAnchorPoint(0,0.5)
	if style then
		-- self.m_csNode.node.laba:setImage("MenuScene/qitiantubiao.png")
	end
	local x , y = self.m_csNode.node.laba:getPosition()
	local w , h = self.m_csNode.node.laba:getContentSize()
	label:setPosition(x + 20,y + 4)
	self.m_csNode.node:addChild(label)
	
	w , h = self.m_csNode.diban:getContentSize()
	local layer = cc.LayerColor:create(cc.Color(255,255,0,255))
	layer:setContentSize(w,h)

	local drawNode = cc.ClippingNode:create(layer)
	drawNode:addChild(self.m_csNode)
	
	self:addChild(drawNode)
	self.m_width = w
	self.m_textWidth = label:getContentWidth()
	self:setContentSize(w,h)
end

function This:onEnter()
	super.onEnter(self)
	self:initAction()
	self:scheduleUpdate()
end

function This:initAction()
	self.m_csNode.node:setPositionX(self.m_width)
	local time = (self.m_width + self.m_textWidth) / 100
	self.m_csNode.node:runAction(cc.Sequence(cc.MoveBy(time,-self.m_width - self.m_textWidth,0), cc.CallFunc(function()
		if self.m_finishHandler then
			self.m_finishHandler()
		end
	end)))
end

function This:setFinishHandler(handler)
	self.m_finishHandler = handler
end

function This:update(dt)
	assert(true)
end

--endregion
