-- @Author: Su
-- @Date:   2019-09-02 10:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-09-02 10:17:05
-- @File Name: CompetitionNoticePanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local GamePlayer = require("Player.GamePlayer")
local CompetitionManager = require("Competition.CompetitionManager")

function This:initNode()
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionNotice.csb")
	self.m_csNode = csNode

    self:addChild(csNode)
    self.m_isTouch = false
    csNode:setToCenter()

end

function This:onEnter()
    super.onEnter(self)
    self.m_csNode:playCSAnimation("animation0",true)
end

function This:onExit()
    super.onExit(self)
end

function This:initTouchEvent()

    self.m_csNode.button:setTouchEnded(function ()
        g_scene:openDialog("Competition.CompetitionMainPanel", {})  
        self:close()
    end)

    self.m_csNode.dianji:setTouchEnded(function ()
        if not self.m_isTouch then
            self.m_csNode:playCSAnimation("start",false) 
            self.m_isTouch = true
        end
    end)
end

function This:onTouchMask()
    self:close()
end