-- @Author: zheng
-- @Date:   2019-08-12 16:09:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-26 10:07:56
-- @File Name: CompetitionReplaceServerItemView.lua

local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "GameScene/NodeUI/CompetitionReplaceServerItem.csb"
function This:setModel( achieve, index )
    if achieve then
        self.m_data = achieve
        self.m_myIndex = index
    end
    self:refresh()
end

function This:initNode(info)
    self:setAnchorPoint(0.5,0.5)
    self.m_data = info.data
    self.m_closeFun = info.closeFun
    local w,h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self:refresh()
end

function This:refresh()
    self.bg.name:setString(string.format(Serialize[60653],string.numberToWord(self.m_data)))
end

function This:initTouchEvent()
     self.bg:setTouch({
            onEnded = function()            
                print(self.m_data)
                if self.m_closeFun then
                    self.m_closeFun()
                end
            end,
            isScale = false,
            isDynamic = true,
            isSwallow = false,
        })
end
