-- @Author: zheng
-- @Date:   2019-08-12 16:09:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-24 16:11:00
-- @File Name: CompetitionResultItemView.lua

local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "GameScene/NodeUI/CompetitionResultItem.csb"
function This:setModel( achieve, index )
    if achieve then
        self.m_data = achieve
        self.m_data.rank = index
        self.m_myIndex = index
    end
    self:refresh()
end

function This:initNode(info)
    self:setAnchorPoint(0.5,0.5)
    self.m_data = info.data
    self.m_refreshFun = info.refreshFun
    local w,h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self:refresh()
end

function This:refresh()
    if self.m_refreshFun then
        self.m_refreshFun(self,self,self.m_data)
    end
end
