-- @Author: Su
-- @Date:   2019-10-19 16:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-10-19 16:17:05
-- @File Name: CrossServerBossBtn.lua
-- @Description: 

local This, super = class(..., "Home.MenuButton")
local CrossServerBossManager = require("CrossServerBoss.CrossServerBossManager")
local GamePlayer = require("Player.GamePlayer")
local ArgConfig = require("Metadatas.ArgConfig")


function This:init(config)
    self.m_Id = config.id
    self.m_config = config
    self.time:setVisible(false)
    self.timebg:setVisible(false)
end

function This:initTouchEvent()
    self:setTouch({
		onEnded = function()
            g_scene:openDialog("CrossServerBoss.CrossServerBossPanel", {})  
		end,
		isScale = false
	})
end

function This:getDefaultVisible()
    local isShow = CrossServerBossManager:isShow()
    return GamePlayer:getLevel() >= ArgConfig.cross_server_boss_open_level.arg[1] and isShow
    -- return true
end