-- @Author: Su
-- @Date:   2019-09-16 11:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-09-16 11:30:53
-- @File Name: CrossServerBossRewardListItem.lua
-- @Description: 

local This , super = class(...,"NodeUI")
local ItemNode = require("UI.ItemNode")
This.fileName = "MenuScene/NodeUI/CrossServerBossRewardList.csb"

function This:initNode(info)
    self.m_data = info
    self:refresh()
end

function This:refresh()
    --self.top:setImage()
    self.top:setVisible(false)
    self.rank:setVisible(true )
    self.scrollview:setDirection("horizontal")
    self.scrollview.m_direction = "right"
    if self.m_data.max == self.m_data.min then
        self.rank:setString(string.format( Serialize[60698],self.m_data.max))
        --  self.top:setImage(string.format("MenuScene/top%d.png",self.m_data.max))
    else
        self.rank:setString(string.format( Serialize[60699],self.m_data.max,self.m_data.min))
    end
    local itemList = self.m_data.rewardlist
    for i,itemData in pairs(itemList) do
        local item = ItemNode:create(itemData[1],itemData[2])
        item:setAnchorPoint(0.5,0.5)
        local w,h = item:getContentSize()
        self.scrollview:pushBackCustomItem(item,w,h,0.5)
    end

end

function This:getSize()
    local w,h = self.bg:getContentSize()
    return w,h
end