local This, super = class(..., "Dialog")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("Common/NodeUI/GuideTips.csb")
    self.m_csNode:setPosition(cc.visible.left.x, cc.visible.left.y)
    self:addChild(self.m_csNode)
    self.m_csNode.text:setString(info.stepInfo.text, 280)
    self.m_allowTouch = false
    self:setTimer(0.5, function ()
        self.m_allowTouch = true
    end)
end

function This:onTouchMask()
    if self.m_allowTouch then
        self:close()
    end
end