-- @Author: zheng
-- @Date:   2019-09-19 11:00:27
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-24 10:11:12
-- @File Name: RuneSolt.lua

local This , super = class(...,"Hero.PsvSkillSolt")
local RuneSoltConfig = require("Metadatas.RuneSoltConfig")
function This:initCustom()
    local id = self.m_quality * 100 + self.m_solt
    self.m_config = RuneSoltConfig[id]
end

function This:getPsvSkillId()
    if self.m_psvSkill then
        return self.m_psvSkill:getUid()
    end
    return 0
end

function This:setIsActive(isActive)
    -- if self.m_psvSkill then
    --     self.m_psvSkill:setIsActive(isActive,self.m_hero)
    -- end
end


function This:getAttr()
    if not self.m_psvSkill then
        return {}
    end
    local attrs =self.m_psvSkill:getAttr()
    return attrs
end

function This:setPsvSkill(skill)
    self.m_psvSkill = skill
end

function This:removePsvSkill()
    if self.m_psvSkill then
        self.m_psvSkill = nil
    end
end

function This:lock()
    if self:isEmpty() then return end
end

function This:unlock()
    
end

function This:hasLuckyLock()
    return false
end

function This:isPsvSkill()
    return false
end

function This:isRune()
    return true
end