--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Event.GameEvent")
local EventDispatcher = require("EventDispatcher")

function This:init(func, event, predicateHandler,recieveCount)
	self.m_func = func
	self.m_event = event
    self.m_predicateHandler = predicateHandler
	self.m_isFinish = false
	self.m_isWaiting = false
    self.m_recieveCount = recieveCount or 1
	EventDispatcher:addListener(self,self.m_event,self.onEventNotify)
end

function This:execute()
	if not self.m_isWaiting and not self.m_isFinish then
		if self.m_func then
			self.m_func()
		end
		self.m_isWaiting = true
	end
end

function This:isFinish()
	return self.m_isFinish
end

function This:onEventNotify(msg)
    self.m_recieveCount = self.m_recieveCount - 1
    if not self.m_predicateHandler then
        if self.m_recieveCount <= 0 then 
            self.m_isFinish = true
        end
    else
        self.m_isFinish = self.m_predicateHandler(msg)
    end
    
    if self.m_isFinish then
		EventDispatcher:removeListener(self,self.m_event)
	end
end

function This:setDecisionHandler(predicate)
    self.m_predicateHandler = predicate
end

--endregion
