---
---
--- Created by aid.
--- DateTime: 2018/12/21 17:56
---
local This , super = class(...,"Dialog")

function This:initData(data)
    super.initData(self, data)
    self.m_callback = data.callback
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TreasureRefineTips.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:initTouchEvent()
    -- 拒绝按钮
    self.m_csNode.cancelButton:setTouchEnded(function()
        self.m_callback(false)
        self:close()
    end)

    -- 同意按钮
    self.m_csNode.confirmButton:setTouchEnded(function()
        self.m_callback(true)
        self:close()
    end)
end