-- @Author: superm
-- @Date:   2018-07-10 19:27:57
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-13 15:22:09
-- @File Name: FamilyAchieveBoxPanel.lua
-- @Description: 

local This , super = class(...,"Achieve.WeeklyAchieveBoxPanel")
local VitalityManager = require("Achieve.VitalityManager")

function This:refreshNote(info)
	local vitality  = info.vitality
	local hasRecieve = false
	if vitality < self.m_config.vitality then
		if self.m_type ~= VitalityBoxType.kFamily then
			self.m_csNode.condition:setString(string.format(Serialize[60925], self.m_config.vitality))
		else
			self.m_csNode.condition:setString(string.format(Serialize[60926], self.m_config.vitality))
		end
	else
		if self.m_type ~= VitalityBoxType.kFamily then
			hasRecieve = VitalityManager:isDailyBoxReward(self.m_index)
		else
			hasRecieve = VitalityManager:isBoxReward(self.m_index)
		end
	end

	self.m_csNode.condition:setVisible(vitality < self.m_config.vitality)
	self.m_csNode.yilingqu:setVisible(hasRecieve)
	self.m_csNode.lingqu:setVisible(vitality >= self.m_config.vitality and not hasRecieve)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.lingqu:setTouchEnded(function()
		VitalityManager:onGetFamilyBoxRewardRequest(self.m_index, self.m_type)
	end)
end

function This:onGetBoxReward(index, boxType)
end

function This:onGetFamilyBoxReward(index, boxType)
	if self.m_index == index then
		self:close()
	end
end
