
local This, super = class(...,"Dialog")
local FamilyBossManager = require("FamilyBoss.FamilyBossManager")


function This:initNode(chapter)
	self.m_chapter = chapter

	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyBossCome.csb")
	node:setToCenter()
	self:addChild(node)
    self.m_csNode = node
	self.m_tipState = false
	self.gouxuan = self.m_csNode.tishi.gouxuan
	self.weigouxuan = self.m_csNode.tishi.weigouxuan
    self.gouxuan:setVisible(self.m_tipState)
    self.weigouxuan:setVisible(not self.m_tipState)
	self:refresh()
end

function This:refresh()
	local infoNode = self.m_csNode.info
	-- infoNode.hero1:setImage(self.m_chapter:getBackgroundImage())
	-- infoNode.name:setImage(self.m_chapter:getNameImage())
end
           
function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.beijing.closebutton:setTouchEnded(function()
		self:close()
	end)

	csNode.know.buttonbg:setTouchEnded(function()
		self:close()
	end)

	csNode.tishi.gouxuan:setTouchEnded(function()
		self:setTipState(false)
	end)

	csNode.tishi.weigouxuan:setTouchEnded(function()
		self:setTipState(true)
	end)
end

function This:setTipState(yes)
	self.m_tipState = yes
	FamilyBossManager:setTipState(self.m_tipState)
	self.gouxuan:setVisible(self.m_tipState)
    self.weigouxuan:setVisible(not self.m_tipState)
end