-- @Author: Su
-- @Date:   2019-06-24 15:46:07
-- @Last Modified by:   Su-
-- @Last Modified time: 2019-06-24 15:46:07
-- @File Name: IconBtnView.lua
-- @Description: 

local This , super = class(...,"Hero.SoilderBtnView")
local GameUtil = require("Util.GameUtil")

function This:init(id)
    self.m_id = id

    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/CreateRoleSceneItem.csb")
	self:addChild(self.m_csNode)
    
    local w , h = self.m_csNode.touxiang1.bg:getContentSize()
	local scale = self.m_csNode.touxiang1.bg:getScale()
	w = w * scale
	h = h * scale
	self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)

end

function This:refresh()
    GameUtil:setPlayerIconNodeImage(self.m_csNode.touxiang1.icon,self.m_id)
    -- GameUtil:setPlayerFeltNodeResource(self.m_csNode.touxiang1.icon,self.m_id)
end

function This:setSelect(isSelect)
    self:setVisible(not isSelect)
    if isSelect and self.m_selectHandler then
		self.m_selectHandler()
	end
end

function This:setModel(id)
	self.m_id = id
	self:refresh()
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end