--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")

function This:init(hero)
	self.m_hero = hero
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/HeroPassiveList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.xuanzhong:setVisible(false)
end

function This:initTouchEvent()
	self.m_csNode.bg:setTouch({
		onEnded = function()
			if self.m_selectHandler then
				self.m_selectHandler(self.m_hero)
			end
		end,
		isScale = false,
		isContainer = true,
	})
end

function This:refresh()
	self.m_csNode.icon:setImage(GameUtil:getItemIcon(self.m_hero:getId()))
	self.m_csNode.mingzi:setString(self.m_hero:getName())
	local color = QualityColor[self.m_hero:getQuality()]
	self.m_csNode.mingzi:setColor(color.r,color.g,color.b)
	local star = self.m_hero:getStarLv()
	for i = 1, 5 do
		self.m_csNode["star"..i]:setVisible(star >= i)
	end
	self.m_csNode.level:setString(self.m_hero:getLevel())
	if self.m_isSelectHandler then
		local isSelect = self.m_isSelectHandler(self.m_hero)
		self.m_csNode.xuanzhong:setVisible(isSelect)
	end
end

function This:getModel()
	return self.m_hero
end

function This:setModel(hero)
	if self.m_hero ~= hero then
		self.m_hero = hero
		self:refresh()
	end
end

function This:setSelect(isSelect)
	self.m_csNode.xuanzhong:setVisible(isSelect)
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:setIsSelectHandler(handler)
	self.m_isSelectHandler = handler
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self:refresh()
end

--endregion
