-- @Author: superm
-- @Date:   2018-06-06 10:07:06
-- @Last Modified by:   superm
-- @Last Modified time: 2018-06-06 22:13:55
-- @File Name: PsvTransHeroItemView.lua
-- @Description: 

local This , super = class(..., "Stage.StageHeroItemView")
local HeroManager = require("Hero.HeroManager")

function This:init(heroId,info)
	self.m_hero = info.hero
	super.init(self, heroId, info, "GameScene/NodeUI/HeroCard.csb")
end

function This:getHeroInfo()
	if self.m_hero then
		return self.m_hero
	end
	return super.getHeroInfo(self)
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:onTransPsvSkill(shero, thero)
	if self.m_heroId and shero == self.m_heroId or thero == self.m_heroId then
		self:refreshAttr()
	end
end