

-- 皇帝战进入地图界面

local This, super = class(..., "LegionEntrant.KingWarSignUpNode")
local GameUtil = require("Util.GameUtil")

function This:refresh()
	super.refresh(self)

	local csNode = self.m_csNode
	csNode.btnApply:setVisible(false)
	csNode.btnInvite:setVisible(false)
	csNode.btnRank:setVisible(false)

	local data = self.m_data
	if data:isHasTeam() then
		local team = data:getMyTeam()
		local isOut = team:getIsOut() or team:isSelfOut()
		if isOut then
			csNode.zhandouzhong:setString(Serialize[61561])
			csNode.btnEnter:setVisible(false)
		else
			csNode.zhandouzhong:setString("")
			csNode.btnEnter:setVisible(true)
		end
	else
		-- 路人
		csNode.zhandouzhong:setVisible(true)
		csNode.zhandouzhong:setString(Serialize[61562])
		csNode.btnEnter:setVisible(false)
	end	
end

function This:updateLeftTime(leftTime)
	self.m_leftTime = leftTime
	self.m_csNode.time:setString( GameUtil:formatDTime(Serialize[61563], leftTime) )
end

