

--军团战初始界面

local This, super = class(..., "NodeView")
local GameUtil = require("Util.GameUtil")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_data = info.data
	self.m_mapType = info.data:getMapType()	
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LegionWarPreview.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.toumingzhuang:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )
	csNode.baoming:setVisible(false)
	csNode.already:setVisible(false)
	csNode.huoyue:setVisible(false)
	csNode.huoyuebg:setVisible(false)
	csNode.time:setVisible(false)
	csNode.timebg:setVisible(false)

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end)

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kLegion})
	end)

	-- 投名状
	csNode.toumingzhuang:setTouchEnded(function()
		g_scene:openDialog("FamilyRating.FamilWarlordPanel",{warType = self.m_mapType})
	end)
end

function This:refresh()

end



