--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local Parabolic = require("Action.Parabolic")

function This:init(info)
	self.m_sv = info.startPoint
	self.m_march = info.march
	self.m_speed = info.speed
	self.m_scene = info.scene
	self.m_originAngle = 0

	self.m_sprite = cc.Sprite:create("WarScene/Buttlet.png")
	self:addChild(self.m_sprite)
	self.m_sprite:setRotation(90)
	local paomaView = self.m_scene:getMarchPaoMaEffect(self.m_march)
	local x , y = paomaView:getPosition()
	self.m_ev = cc.Vec(x,y)

	local av = (self.m_ev - self.m_sv):length()
	self:setPosition(self.m_sv.x,self.m_sv.y)
	self.m_time = 1 --(self.m_ev - self.m_sv):length() / self.m_speed * 0.6

	self.m_parablic = Parabolic:create({
		bx = self.m_sv.x,
		by = self.m_sv.y,
		ex = self.m_ev.x,
		ey = self.m_ev.y,
		time = self.m_time,
		arrowNode = self,
		nodeAngle = 90,
		av = av
	})
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
end

function This:onExit()
	super.onExit(self)
end

function This:update(dt)
	if self.m_parablic:isFinish() then
		local paomaView = self.m_scene:getMarchPaoMaEffect(self.m_march)
		if paomaView then
			paomaView:setColor(255,0,0)
			paomaView:runAction(cc.Sequence(cc.DelayTime(0.1),cc.CallFunc(function()
				paomaView:setColor(255,255,255)
			end)))
			self:removeFromParent()
		end
		return
	end 
	self.m_parablic:update(dt)
end

--[[function This:update(dt)
	self.m_escape = self.m_escape + dt
	local sx , sy = self:getPosition()
	self.m_sv = cc.Vec(sx,sy)

	local paomaView = self.m_scene:getMarchPaoMaEffect(self.m_march)
	if paomaView then
		local x , y = paomaView:getPosition()
		self.m_ev = cc.Vec(x,y)
	end
	local v1 = self.m_ev - self.m_sv
	
	if v1:length() < 10 or self.m_escape >= self.m_time then
		self:removeFromParent()
		return
	end
	local v2 = cc.Vec.createByDegree(self.m_angle)
	local v3 = cc.Vec.createByDegree(self.m_angle + 90)

	local angle = v2:getDegreeByVec(v1)
	local dAngle = angle  / (self.m_time - self.m_escape) * dt
	local flag = v3:dot(v1) > 0 and 1 or -1
	if flag < 0 then
		print("ddd")
	end

	self.m_angle = self.m_angle + dAngle * flag
	self.m_sprite:setAngle(self.m_angle - self.m_originAngle)
	local v3 = cc.Vec.createByDegree(self.m_angle) * self.m_speed * dt
	self.m_sv = self.m_sv + v3
	self:setPosition(self.m_sv.x, self.m_sv.y)
end]]



--endregion
