--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Dialog")
local LegionReportView = require("Map.LegionReportView")
local ReportManager = require("Report.ReportManager")

function This:initNode()
	ReportManager:onGetLegionSimpleReportRequest()
end

function This:initInfo()
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionReport.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:initItemView()
	self:initTouch()
end

function This:initItemView()
	for _, report in ipairs(self.m_reportList) do
		local view = LegionReportView:create(report)
		self.m_csNode.scrollview:pushBackCustomItem(view, 650, 136)
	end
end

function This:initTouch()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	ReportManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ReportManager:removeObserver(self)
end

function This:onGetLegionSimpleReport(reportList)
	self.m_reportList = reportList
	self:initInfo()
end

--endregion
