-- @Author: superm
-- @Date:   2019-09-16 15:42:23
-- @Last Modified by:   superm
-- @Last Modified time: 2019-09-16 15:44:29
-- @File Name: LegionContributionItem.lua
-- @Description: 

local This , super = class(...,"NodeView")

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildContributionItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode
    self.m_rankData = info
    self:refresh()
end

function This:getSize()
    local w, h = self.m_csNode.paimingbg:getContentSize()
    return w,h
end

function This:refresh()
    local node = self.m_csNode
    node.me.paiming:setString(self.m_rankData.rank)
    node.me.name:setString(self.m_rankData.role_name)
    node.me.hurt:setString(self.m_rankData.value)
    node.me.level:setString(string.format("Lv%d",self.m_rankData.level))
end