--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

function This:initNode(info)
	self.m_msg = info.msg
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionSettlementRank.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	-- local t = {Serialize[60012],Serialize[60013],Serialize[60014],Serialize[60015]}
	-- self.m_csNode.ranking:setString(string.format(Serialize[61718],t[self.m_msg.rank]))
	local rank = ((self.m_msg.rank or 4) - 1) % 4 + 1
	self.m_csNode["ranking" .. rank]:setVisible(true)
	local legion = self.m_map:getLegion(self.m_msg.group_id)
	if legion then
		self.m_csNode.group_name:setString(legion:getName())
	end
end

function This:onTouchMask()
	if self.m_msg.rank == 1 or self.m_map:getMyLegionId() == self.m_msg.group_id then
		cc.SceneManager:switchTo("Home.MenuScene")
	else
		self:close()
	end
end

--endregion
