--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local LegionCityConfig = require("Metadatas.LegionCityConfig")
local ReportManager = require("Report.ReportManager")

function This:init(report)
	self.m_report = report
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionReportTotal.csb")
	self:addChild(self.m_csNode)
	self:refresh()
end

function This:refresh()
	self.m_csNode.actionname:setString(self.m_report.origin_group)
	self.m_csNode.name:setString(self.m_report.now_group)
	self.m_csNode.actionaddress:setString(string.format(Serialize[61798],LegionCityConfig[self.m_report.city_id].city_name))
	self.m_csNode.time:setString(string.format(Serialize[61799],GameUtil:formatDate(Serialize["y_m_d_H_M_S"],self.m_report.start_time)))
	self.m_csNode.numberbifen:setString(self.m_report.count)
end

function This:initTouchEvent()
	self.m_csNode.buttonhuang:setTouch({
		onEnded = function()
			g_scene:openDialog("Map.LegionLittleReportPanel",self.m_report.report_list)
		end,
		isScale = false,
		isContainer = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end



--endregion
