--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

function This:initNode(info)
	self.m_msg = info.msg
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/LegionSettlement.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_legions = {}
	for i , info in ipairs(self.m_msg.group_list) do
		self.m_legions[info.group_id] = info
	end
	self.m_roles = {}
	for i , role in ipairs(self.m_msg.role_list) do
		self.m_roles[role.id] = role
	end
	self:initInfo()
end

function This:initInfo()
	local legion = self.m_legions[self.m_msg.group_rank_list[1]]
	self.m_csNode.huosheng.text:setString(legion.group_name)
	legion = self.m_legions[self.m_msg.group_rank_list[2]]
	self.m_csNode.dierming.text:setString(legion.group_name)
	legion = self.m_legions[self.m_msg.group_rank_list[3]]
	self.m_csNode.disanming.text:setString(legion.group_name)
	legion = self.m_legions[self.m_msg.group_rank_list[4]]
	self.m_csNode.disiming.text:setString(legion.group_name)

	for i = 1 , 3 do
		local role = self.m_roles[self.m_msg.wakuang_list[i]]
		self.m_csNode.wakuang["top"..i]:setString(role.name)
		role = self.m_roles[self.m_msg.shadi_list[i]]
		self.m_csNode.shadi["top"..i]:setString(role.name)
		role = self.m_roles[self.m_msg.jianshe_list[i]]
		self.m_csNode.jianshe["top"..i]:setString(role.name)
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.button:setTouchEnded(function()
		g_scene:openDialog("Map.LegionSettlementPanel",{
			map = self.m_map,
			msg = self.m_msg.my_rank_list
		})
	end)
end

--endregion
