--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Map.LegionTroopsAddHpPanel")
local LegionMapUtil = require("Map.LegionMapUtil")
local HeroManager = require("Hero.HeroManager")

function This:initNode(info)
	super.initNode(self,info)
	self.m_scene = g_scene
	self.m_csNode.time:setVisible(false)
	self.m_csNode.jiesangbutton.text:setString(Serialize[61860])
	self.m_csNode.bubingbutton:setVisible(false)
	self.m_csNode.kaishibutton.text:setString(Serialize[61861])
	self.m_csNode.time2:setVisible(false)
	self.m_csNode.tittle:setString(Serialize[61862])
end

function This:updateCardInfo(info)
	self.m_reserveHp = self.m_city:getMineral()
	self.m_unitcost = self.m_map:getTransMineralCostCoin(1)
	self.m_cardList = {}
	local cardList = self.m_biandui:getCardList()
	for _, card in ipairs(cardList) do
		local pos = card:getPos()
		self.m_maxHp[pos] = self.m_map:getTransMaxMineral(card:getMaxHp(), card:getHeroId())
		self.m_curHp[pos] = 0
		self.m_initHp[pos] = 0
		self.m_cardList[pos] = card
	end
end

function This:refresh()
	local totalHp , maxTotal ,addTotal , coin = 0, 0 , 0 , 0
	for i = 1 , 6 do
		totalHp = totalHp + self.m_curHp[i]
		maxTotal = maxTotal + self.m_maxHp[i]
		addTotal = addTotal + self.m_curHp[i] - self.m_initHp[i]
	end
	self.m_totalHp = totalHp
	coin = self.m_map:getTransMineralCostCoin(addTotal)

	self.m_csNode.zongbingli:setString(string.format(Serialize[61863],totalHp))
	self.m_csNode.hpnum:setString(string.format(Serialize[61864],self.m_reserveHp))
	self.m_csNode.cointotal:setString(string.format(Serialize[61848],self.m_map:getCoin()))
	self.m_csNode.bingli:setString(string.format(Serialize[61865],self.m_curHp[self.m_curPos],self.m_maxHp[self.m_curPos]))

	local coin1 = self.m_map:getTransMineralCostCoin(self.m_curHp[self.m_curPos] - self.m_initHp[self.m_curPos])
	self.m_csNode.xiaohao:setString(string.format(Serialize[61866],coin1))
	self.m_csNode.money:setString(string.format(Serialize[61842],coin))

	local soilder = self.m_curHero:getCurSoilder()
	self.m_csNode.bingzhong:setString(string.format(Serialize[61844],soilder:getName()))
end

function This:autoAddHp()
	local coin = self.m_map:getCoin()
	local totalHp = 0
	for i = 1 , 6 do
		self.m_curHp[i] = self.m_initHp[i]
		local hp = math.floor( math.min(coin / self.m_unitcost, self.m_maxHp[i] - self.m_curHp[i], self.m_reserveHp - totalHp))
		self.m_curHp[i] = self.m_curHp[i] + hp
		coin = coin - hp * self.m_unitcost
		totalHp = totalHp + hp
	end
	self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
end

function This:initTouchEvent()
	self.m_csNode.closebutton:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.jiahao:setTouchEnded(function()
		self.m_csNode.slider:setPercent(1)
	end)
	self.m_csNode.jianhao:setTouchEnded(function()
		self.m_csNode.slider:setPercent(0)
	end)
	self.m_csNode.jiesangbutton:setTouchEnded(function()
		self:autoAddHp()
	end)
	self.m_csNode.kaishibutton:setTouchEnded(function()
		if self.m_totalHp <= 0 then
        	g_scene:showTips(Serialize[61867])
			return
		end
		self.m_scene:closeAllDialog()
		self.m_scene:enterSelectMode(self.m_city,self.m_biandui, LegionTransType.kMineral,self.m_curHp)
	end)
end

--endregion
