-- @Author: ZYY
-- @Date:   2018-07-31 20:49:25
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-08-02 17:41:51
-- @File Name: LegionTroopsDefenseView.lua
-- @Desc: 城防界面
local This , super = class(...,"NodeUI")
local LegionDefenseItemView = require("Map.LegionDefenseItemView")
local UpdateLayer = require("UI.UpdateLayer")

This.fileName = "LegionScene/NodeUI/LegionTroopsDefense.csb"

function This:initNode()
	self.m_npcListData = {1,2,3,4,5,6,7,8,9,10,1,1,1,1,1,1,1,}
	self.m_npcListItem = {}

	self.m_listLayer = UpdateLayer:create({
        itemWidth = 100,
        itemHeight = 127,
		column = 6,
		spaceY = 0,
		spaceX = 0,
        scrollView = self.ScrollView,
    })
    self.m_listLayer:setAnchorPoint(0.5,0)
    local w , h = self.m_listLayer:getContentSize()
    self.ScrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setCascadeOpacityEnabled(true)
end

function This:refresh()
	self.m_listLayer:setDataList(self.m_npcListData, function(member, index)
		local item = LegionDefenseItemView:create(member)
		return item
	end)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()

end
