--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
--This.noMask = true

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/OurGrade.csb")
	self:addChild(self.m_csNode)
	self.m_initPosX = cc.visible.rect.width + 133
	self.m_initPosY = cc.visible.rect.height / 2
	self.m_csNode:setPosition(self.m_initPosX,self.m_initPosY)

	self.m_csNode.grade:setString(info.score)
	self.m_csNode.KAS:setString(string.format("%d/%d/%d",info.kill,info.assist,info.city_num))
	self.m_csNode.session:setString(info.match_num)
	self.m_csNode.unify:setString(info.win_num)
	
	local rate = info.match_num == 0 and 0 or info.win_num / info.match_num
	self.m_csNode.winningrate:setString(string.format("%.2f%%",rate * 100))
	self.m_csNode.consecutivevictories:setString(info.max_continue_win_num)
	self.m_csNode.surrender:setString(info.master_win_num)
	self.m_csNode.surrender_0:setString(Serialize[61953])
	self.m_csNode.surrender_0_0:setString(Serialize[61954])
end

function This:initTouchEvent()
	self.m_csNode.gameinformation.gameinformationbg:setTouch({
		onEnded = function()
			self:close()
		end,
		isScale = false
	})
end

function This:runOpenAnimation()
    self:setCascadeOpacityEnabled(true)
    self:setOpacity(0)
    self.m_csNode:runAction(cc.MoveTo(0.2, self.m_initPosX - 265, self.m_initPosY, "ExponentialIn"))
    self:runAction(cc.Sequence(cc.FadeIn(0.2), cc.CallFunc(function ()
        self:onOpen()
    end)))
end

function This:runCloseAnimation()
    self:setCascadeOpacityEnabled(true)
    self:setOpacity(255)
    self.m_csNode:runAction(cc.MoveTo(0.2, self.m_initPosX, self.m_initPosY, "ExponentialOut"))
    self:runAction(cc.Sequence(cc.FadeOut(0.2), cc.CallFunc(function ()
        self:removeFromParent()
    end)))
end

--endregion
