--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local MenuScene = require("Home.MenuScene")

function This:initNode(msg)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingEndReward.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.timereward.timereward1num:setString(string.format("+%d",msg.coin))
	self.m_csNode.timereward.timereward2num:setString(string.format("+%d",msg.exp))
	self.m_csNode.timereward.timereward3num:setString(string.format("+%d",msg.bingfashu))
	self.m_csNode.timereward.timereward4num:setString(string.format("+%d",msg.time_zhangong))

	local function setGray(index)
		self.m_csNode["winreward"..index].unifyreward:setColor(144,152,166,255)
		self.m_csNode["winreward"..index].unifyrewardnum:setColor(144,152,166,255)
		self.m_csNode["winreward"..index].unifyrewardtext:setColor(144,152,166,255)
	end

	if msg.state == ResultState.kSecceed then
		if msg.is_master then
			self.m_csNode.result:setImage(ResultImage.master)
			setGray(2)
			setGray(3)
		elseif msg.is_colleague then
			self.m_csNode.result:setImage(ResultImage.colleague)
			setGray(1)
			setGray(3)
		elseif msg.is_ally then
			self.m_csNode.result:setImage(ResultImage.ally)
			setGray(1)
			setGray(2)
		else
			self.m_csNode.result:setImage(ResultImage.master)
			setGray(2)
			setGray(3)
		end
	elseif msg.state == ResultState.kDogfall then
		self.m_csNode.result:setImage(ResultImage.dogfall)
		setGray(1)
		setGray(2)
		setGray(3)
	else
		setGray(1)
		setGray(2)
		setGray(3)
	end
end

function This:initTouchEvent()
	self.m_csNode["return"]:setTouchEnded(function()
		if g_scene:getName() ~= "MenuScene" then
			cc.SceneManager:switchTo("Home.MenuScene")
		else
			self:close()
		end
	end)
	self.m_csNode.goto:setTouchEnded(function()
		if g_scene._NAME ~= "MenuScene" then
			cc.SceneManager:switchTo("Home.MenuScene")
			MenuScene:addDelayDialog({name = "Match.MatchPanel"})
		else
			g_scene:openDialog("Match.MatchPanel")
		end
		self:close()
	end)
end

--endregion
