--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")

function This:init(roleInfo)
	self.m_id = tonumber(roleInfo.role_id)
	self.m_name = roleInfo.role_name
	self.m_icon = roleInfo.role_icon
	self.m_level = roleInfo.role_level
	self.m_isReady = roleInfo.is_ready
	self.m_rankLv = roleInfo.rank_level
	self.m_groupId = roleInfo.group_id
	self.m_groupName = roleInfo.group_name
	self.m_groupTitle = roleInfo.group_title
	self.m_isMaster = false
	self.m_isAlly = false
	self.m_isColl = false
	self.m_isOwner = false
end

function This:getId()
	return self.m_id
end

function This:getName()
	return self.m_name
end

function This:getLevel()
	return self.m_level
end

function This:getRank()
	if self.m_rankLv <= 0 then
		return 1
	end
	return self.m_rankLv
end

function This:getGroupId()
	return self.m_groupId
end

function This:getGroupName()
	return self.m_groupName
end

function This:getGroupTitle()
	return self.m_groupTitle
end

function This:getIcon()
	return self.m_icon
end

function This:isReady()
	return self.m_isReady
end

function This:setIsReady(isReady)
	self.m_isReady = isReady
end

function This:setIsMaster(isMaster)
	self.m_isMaster = isMaster
	if isMaster then
		self.m_isAlly = false
		self.m_isColl = false
	end
end

function This:setIsAlly(isAlly)
	self.m_isAlly = isAlly
	if isAlly then
		self.m_isMaster = false
		self.m_isColl = false
	end
end

function This:setIsColl(isColl)
	self.m_isColl = isColl
	if self.m_isColl then
		self.m_isMaster = false
		self.m_isAlly = false
	end
end

function This:isMaster()
	return self.m_isMaster
end

function This:isAlly()
	return self.m_isAlly
end

function This:isColleague()
	return self.m_isColl
end

function This:isRoomOwner(roleId)
	if roleId then
		return self.m_id == tonumber(roleId)
	end
	return self.m_isOwner
end

function This:setIsRoomOwner(isOwner)
	self.m_isOwner = isOwner
end

function This:updateInfo(info)
	if self.m_id == info.role_id then
		self.m_isReady = info.is_ready
	else
		assert(false)
	end
end

--endregion
