--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")

function This:initNode()
	local function finishHandler()
		if g_scene:getName() ~= "MenuScene" then
			cc.SceneManager:switchTo("Home.MenuScene")
		else
			g_scene:closeAllDialog()
		end
	end 

	self.m_effect = GameUtil:createEffect("ShengZhi",false,nil,{
		onAnimationEvent = function()
			self.m_effect:unscheduleUpdate()
			self.m_csNode.button:setVisible(true)
			self.m_csNode.button:runAction(cc.RepeatForever(cc.Sequence(cc.ScaleTo(1,1.1),cc.ScaleTo(1,1))))
		end,
		onAnimationComplete = function()
			finishHandler()
		end
	})
	self:addChild(self.m_effect)
	self.m_effect:setPosition(cc.visible.center.x,cc.visible.center.y)
	self.m_effect:recoveryToFixedWidth("","")

	self.m_csNode = cc.Node:createFromCSFile("Common/NodeUI/Decree.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.button:setVisible(false)

end

function This:initTouchEvent()
	self.m_csNode.button:setTouchEnded(function()
		self.m_effect:scheduleUpdate()
		self.m_csNode.button:setVisible(false)
	end)	
end



--endregion
