--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local EventDispatcher = require("EventDispatcher")

function This:init()

end

function This:initTouchEvent()
	self.m_listener = cc.TouchListener:create({
		onBegan = function()
			return true
		end
	})
    self:addEventListener(self.m_listener)
end

function This:showWaiting()
	print("-------------showWaiting1----------------",os.clock())
	self:stopAllActions()
	self:runAction(cc.Sequence(cc.DelayTime(0.3),cc.CallFunc(function()
		print("-------------create wait view2----------------",os.clock())
			if not self.m_waitNode then
				self.m_waitNode = cc.Sprite:create("Common/waiting.png")
				self:addChild(self.m_waitNode)
				self.m_waitNode:setScale(0.6)

				self.m_waitNode:setPosition(cc.visible.center.x,cc.visible.center.y)
				self.m_waitNode:runAction(cc.RepeatForever(cc.RotateBy(5,360)))
			end
		end),
		cc.DelayTime(15),
		cc.CallFunc(function()
			print("-------------create login ui3----------------",os.clock())
			EventDispatcher:dispatcher("connect_lost")
			local Socket = require("Net.Socket")
			print("Socket:", Socket.m_maskKey)
		end)
	))
	if self.m_listener then
		self.m_listener:setEnabled(true)
	end
end

function This:hideWaiting()
	print("-------------hideWaiting4----------------",os.clock())
	if self.m_waitNode then
		self.m_waitNode:removeFromParent()
		self.m_waitNode = nil
	end
	self:stopAllActions()

	if self.m_listener then
		self.m_listener:setEnabled(false)
	end
end

function This:onEnter()
	super.onEnter(self)
	local zorder = g_scene:getMaxLocalZOrder() + 1
	self:setLocalZOrder(zorder)
end

function This:onExit()
	super.onExit(self)
end

--endregion
