-- @Author: Su
-- @Date:   2020-07-21 10:31:58
-- @Last Modified by:   Su
-- @Last Modified time: 2020-07-21 10:31:58
-- @File Name: ActivityDecreeTaskBtn.lua
-- @Description: 

local This, super = class(..., "Home.MenuButton")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GamePlayer = require("Player.GamePlayer")
local ArgConfig = require("Metadatas.ArgConfig")

function This:init(config)
    self.m_Id = config.id
    self.m_config = config
end

function This:initTouchEvent()
    self:setTouch({
		onEnded = function()
            g_scene:openDialog("Activity.ActivityDecreeMainPanel", {})  
		end,
		isScale = false
	})
end

function This:getDefaultVisible()
    self.m_activity = NewActivityManager:getActivity(self.m_config.uiclass.ids[1])
    return self.m_activity:isOpen()
end