-- @Author: zheng
-- @Date:   2018-08-07 20:41:04
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-08-09 19:50:24
-- @File Name: ActivityHappyRewardPanel.lua

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

function This:initNode(rewardList)
	self.m_rewards = rewardList
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivityHappyReward.csb")
	self.m_csNode = csNode
	self:addChild(csNode)
	csNode:setToCenter()

	local function createItemView(model)
		local node = ItemNode:create(model[1],model[2])
		node:setAnchorPoint(0.5,0.5)
		return node
	end

    for i, model in ipairs(self.m_rewards) do
        local view = createItemView(model)
        csNode.ScrollView:pushNode(view, 95, 90, 5) 
    end
end

function This:initTouchEvent()
	self.m_csNode.button:setTouchEnded(function()
		self:close()
	end)
end