--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local BudoShopConfig = require("Metadatas.BudoShopConfig")
local GamePlayer = require("Player.GamePlayer")

function This:init(pos)
	super.init(self)
	self.m_pos = pos
	self.m_costItemId = 0
	self.m_costItemNum = 0
	self.m_itemId = 0
	self.m_itemNum = 0
	self.m_discount = 10
	self.m_buyCount = 0
	self.m_endTime = 0
end

function This:getLeftTime()
	local leftTime = self.m_endTime - GamePlayer:getServerTime()
	return math.max(0,leftTime)
end

function This:getDiscount()
	return self.m_discount
end

function This:getBuyCount()
	return self.m_buyCount
end

function This:getCostItem()
	return self.m_costItemId, self.m_costItemNum
end

function This:setCostItem(itemId,itemNum)
	self.m_costItemId , self.m_costItemNum = itemId, itemNum
end

function This:getBuyItem()
	return self.m_itemId , self.m_itemNum
end

function This:getPos()
	return self.m_pos
end

function This:getConfigId()
	return self.m_config.id
end

function This:getPassiveSkillId()
	return self.m_config.item
end

function This:updateInfo(info)
	self.m_pos = info.grid_id
	self.m_config = BudoShopConfig[info.config_id]
	self.m_costItemId = info.price_type
	self.m_costItemNum = info.price_num
	self.m_itemId = info.item_id
	self.m_itemNum = info.item_num
	self.m_discount = info.discount
	self.m_buyCount = info.buy_role_num
	if info.remain_seconds > 0 then
		self.m_endTime = GamePlayer:getServerTime() + info.remain_seconds
	else
		self.m_endTime = 0
	end
end

--endregion
