-- @Author: Su
-- @Date:   2019-05-16 17:42:41
-- @Last Modified by:   Su
-- @Last Modified time: 2019-05-16 17:42:41
-- @File Name: AnimalsTurnTableInfo.lua

local This , super = class(...,"NodeUI")

function This:initNode(info)
    self.m_name = info.text.name
    self.m_itemName = AppText:getServerText(info.text.item_name)
    self.m_itemCount = info.text.item_count
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/AnimalsTurnTableInfo.csb")
    local w,h = self.m_csNode.bg:getContentSize()
    self.m_csNode:setContentSize(250,h)
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    self.m_csNode.text:setStringWithColor(Serialize[62065]..self.m_name..Serialize[62066]..self.m_itemName.."x"..tostring(self.m_itemCount).."!")

end

function This:getSize()
    local w,h = self.m_csNode.bg:getContentSize()
    return w,h
end