-- @Author: Su
-- @Date:   2020-04-16 11:45:20
-- @Last Modified by: Su
-- @Last Modified time: 2020-04-16 11:45:20
-- @File Name: SeasonRechargeChapter.lua

local This = class(...)
local OpenTaskConfig = require("Metadatas.OpenTaskConfig")

function This:create(id)
    local Morality = {}
    setmetatable(Morality,This)
    Morality:init(id)
    return Morality
end

function This:init(id)
    self.id = id
    self.m_config = OpenTaskConfig[id]
    self.open_num = self.m_config.open_num
    self.reward = self.m_config.reward
    self.progress = self.m_config.progress
    self.m_state = SevenDayActivityTaskState.kNotReceive
end

function This:getId()
    return self.id
end

function This:getConfig()
    return self.m_config
end

function This:getProgress()
    return self.m_config.progress
end

function This:getState()
    return self.m_state
end

function This:setState(state)
    self.m_state = state
end

function This:getDesc()
    return self.m_config.desc
end

function This:getRewardList()
    return self.m_config.reward
end