-- @Author: zheng
-- @Date:   2018-09-27 20:26:37
-- @Last Modified by:   superm
-- @Last Modified time: 2019-10-21 14:47:13
-- @File Name: OfficialGiftItemView.lua

local This , super = class(...,"NodeUI")
local OfficialPositionConfig = require("Metadatas.OfficialPositionConfig")
This.fileName = "MenuScene/NodeUI/OfficialAwardInfo.csb"
local strList ={
	str1=Serialize["Official_GiftItem_1"],
	str2=Serialize["Official_GiftItem_2"],
}
function This:initNode(info)
    if info then
       -- self.m_family = info.family
       self.m_config = info
    end
    local w,h = self.bg1:getContentSize()
    self:setContentSize(w,h)--300,78)
    self:refresh()
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
-- function This:initTouchEvent()
   
-- end

function This:refresh()
	local myData = self.m_config
	local giftId = myData.gift_id
	if giftId ==0 then
		giftId = 1011
	end
	local officialItem =OfficialPositionConfig[myData.official_id]
	local giftOwnerOfficialName = strList.str1
	if officialItem then
		giftOwnerOfficialName = officialItem.name
	end
	local giftName = self:getGiftName(myData.gift_id)
	local timeStr1 = os.serverdate("%Y-%m-%d", myData.time)
	local timeStr2 = os.serverdate("%H:%M:%S", myData.time)
	local huangDiStr = string.format("<New13>%s <New9>%s",giftOwnerOfficialName,myData.emperor_name)
	local jiangliStr = string.format("<New13>%s <New7>%s <New13>%s",strList.str2,myData.role_name,giftName)
	self.time1:setString(timeStr1)
	self.time2:setString(timeStr2)
	self.huangdi:setStringWithColor(huangDiStr)
	self.jiangli:setStringWithColor(jiangliStr)
end

function This:getGiftName(id)
	local ItemUtil = require("Bag.ItemUtil")
	return ItemUtil.getName(id)
end
