-- @Author: zheng
-- @Date:   2018-10-11 10:32:02
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-12 14:39:21
-- @File Name: OfficialNewEmperor.lua
local OfficialManager = require("Official.OfficialManager")
local This , super = class(...,"Dialog")
local strList={
	format1 = Serialize["Official_NewEmperor_1"],
	format2 = Serialize["Official_NewEmperor_2"],
}

local ViewUtil = require("UI.ViewUtil")
This.fileName = "MenuScene/NodeUI/OfficialBeTheEmperor.csb"
This.isQuickExit = true
function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_csNode.over:setVisible(false)
    self.m_csNode.bg:fitScreen()
    ViewUtil:blinkView(self.m_csNode.over, true)
    self:refresh()
    if self:isEmperorOld() then--皇帝禅让
    	local tipNode = self.m_csNode.tip_node
    	tipNode.juntuan:setVisible(false)
		-- tipNode.name:setPositionY(0)
    end
end

--皇帝禅让
function This:isEmperorOld()
    local CountryInfor = OfficialManager:getCountryInfor()
    local types = CountryInfor.flag
    return types == OfficialType.kemperorOld
end

function This:refresh(  )
	local tipNode = self.m_csNode.tip_node
	local countryInfor = OfficialManager:getCountryInfor()
	-- tipNode.juntuan:setString(string.format(strList.format1,countryInfor.group_name))
	-- tipNode.name:setString(string.format(strList.format2,countryInfor.name))
    local str = string.format(strList.format1..strList.format2,countryInfor.group_name,countryInfor.name)
    if self:isEmperorOld() then--皇帝禅让
        str = string.format(strList.format2,countryInfor.name)
    end
    tipNode.juntuan:setString(str)
end

function This:initTouchEvent()
   self.m_csNode.bg:setTouchEnded(function()
		 self:close()
	end)
end
