-- @Author: ZYY
-- @Date:   2018-09-19 15:11:05
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-27 20:28:56
-- @File Name: PeakContestBattleInfoPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local PeakContestBattleInfoListView = require("PeakContest.PeakContestBattleInfoListView")

function This:initNode(data)
	self.data = data
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestBattleInfo.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_itemList = {}
	self:refresh()
end

function This:refresh()
	local height = 180
	for i , v in ipairs(self.data) do 
		local item = self.m_itemList[i]
		if not item then
			item = PeakContestBattleInfoListView:create(v,i)
			item:setPosition(0, height * (1 - i))
			self.m_csNode.battle:addChild(item)
		else
			item:setData(v,i)
		end
		self.m_itemList[i] = item
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onTouchMask()

end
