--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RedeemCode.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.save:setTouchEnded(function()
        self:submitCode()
    end)
end

function This:submitCode()
    local code = self.m_csNode.name:getString()
    GamePlayer:onSubmitCodeRequest(code)
end

function This:onEnter()
    super.onEnter(self)
    GamePlayer:addObserver(self)
end

function This:onExit()
    GamePlayer:removeObserver(self)
    super.onExit(self)
end

function This:onCodeSubmit()
    self:close()
end

--endregion