-- @Author: superm
-- @Date:   2017-12-15 15:52:12
-- @Last Modified by:   superm
-- @Last Modified time: 2018-02-06 11:56:44
-- @File Name: RankFamilyUI.lua
-- @Description: 

local This, super = class(..., "Rank.RankBaseUI")
This.fileName = "MenuScene/NodeUI/RankingListFamilyBg.csb"

local RankManager = require("Rank.RankManager")
local RankFamilyItemView = require("Rank.RankFamilyItemView")
local FamilyManager = require("Family.FamilyManager")

function This:initTabsInfo()
end

function This:initTouchEvent()
	super.initTouchEvent(self)
	self.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips", {text = Serialize["rank_family_help_tips"], node = self.help})
	end)
end

function This:requestData()
	self.m_curSubType = RankSubType.kAll
	RankManager:onGetRankInfoRequest(self.m_curType, true)
end

function This:getSelfRank()
    if FamilyManager:hasFamily() then
        return super.getSelfRank(self)
    end
end

function This:refreshTitleVIew( rankType )
end


function This:getViewByType( rankType, item, index )
    return RankFamilyItemView:create( item, index )  
end