--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local RecruitManager = require("Recruit.RecruitManager")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitHeroChoose.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:selectCard(Country.kShuGuo)
end

function This:selectCard(country)
	for i = 1, 4 do
		self.m_csNode["node"..i].choose:setVisible(i == country)
	end	
	self.m_country = country
end

function This:initTouchEvent()
	for i = 1 , 4 do
		self.m_csNode["node"..i].bg:setTouchEnded(function()
			self:selectCard(i)
		end)
	end
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.surebutton:setTouchEnded(function()
		RecruitManager:onRecruitFavoursRequest(self.m_country)
		self:close()
	end)
end



--endregion
