-- @Author: superm
-- @Date:   2019-04-11 10:53:12
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-11 16:44:11
-- @File Name: RescuBianDuiEditItemView.lua
-- @Description: 

local This , super = class(...,"Map.LegionBianDuiEditItemView")

function This:initData(info)
    self.m_filename = "RescueEmperor/RescueEmperorTroopsEditItem.csb"
end

function This:refreshSelectState()
	local csNode = self.m_csNode
	csNode.troop:setVisible(false)
	csNode.x:setVisible(false)
	if self.m_hero then
		self.m_isInAllTeam = self.m_judgeInAllTeamHandler and self.m_judgeInAllTeamHandler(self.m_hero)
		csNode.xuanzhong:setVisible(self.m_isInAllTeam)
		self.m_isInCurTeam = self.m_judgeInCurTeamHandler and self.m_judgeInCurTeamHandler(self.m_hero)
		csNode.xuanzhong.gou:setVisible(self.m_isInCurTeam)
		if self.m_isContanier then
			csNode.troop:setVisible(self.m_isInAllTeam)
			if self.m_isInAllTeam and self.m_isInAllTeam > 0 then
				csNode.troop.num:setString(tostring(self.m_isInAllTeam))
				local index = 36 + self.m_isInAllTeam
				csNode.troop:setImage(string.format("MenuScene/kuang%d.png", index))
			end
		end

		if self.m_isSwallow then
			csNode.x:setVisible(true)
		end
	else
		csNode.xuanzhong:setVisible(false)
		csNode.xuanzhong.gou:setVisible(false)
	end
end
