-- @Author: Su
-- @Date:   2019-03-21 20:05:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-04-01 10:34:33
-- @File Name: RescueEmperorBuildMainRankItem.lua
-- @Description: 

local This, super = class(...,"NodeUI")
This.fileName ="RescueEmperor/RescueEmperorBuildMainRankItem.csb"
local GamePlayer = require("Player.GamePlayer")
function This:initData(info)
    local w , h = self.line1:getContentSize()
    h = self.line1:getPositionY()*2
    self:setContentSize(w,h)
    self:refresh(info)
end

function This:refresh(info)
    self.m_rank = info.rank or ""
    self.m_name = info.role_name or ""
    self.m_num = info.value or ""
    self.num1:setString(self.m_rank)
    self.name:setString(self.m_name)
    self.num2:setString(self.m_num)
    local isNormal = true
    if info.rank then
    	isNormal = false
    end
    self.num4:setVisible(isNormal)
    self.num5:setVisible(isNormal)
    local temRoleName = GamePlayer:getRoleName() or ""
    self.num5:setString(temRoleName) 
end