
-- 勤王战空界面（只有背景和关闭）

local This, super = class(..., "NodeView")


function This:initData(info)
	self.m_mainUI = info.mainUI
end

function This:initNode(info)
	self:initEmptyNode()
end

-- 空的界面
function This:initEmptyNode()
	self:removeCsNode()

    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorBeforeMain.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:setVisible(false)
	csNode.qinwangdian:setVisible(false)

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end)
end

function This:removeCsNode()
	if self.m_csNode then
		self.m_csNode:removeFromParent(true)
		self.m_csNode = nil
	end	
end