

-- 不要在这里配置任何文字
-- 文字配置转到 SerializeConfig.xlsx

local SerializeConfig = require("Metadatas.SerializeConfig")


Serialize = {}
setmetatable(Serialize, {__index = function (tb, key)
	local lang = AppText:getLanguage()
	local config = SerializeConfig[key]

	if not config then
		config = SerializeConfig[tostring(key)]
	end
	
	if config then
		local str = config[lang]
		if str == '' then
			str = config[AppLanguage.zh_CN]
		end
		return str
	end
end})


return Serialize