-- @Author: zheng
-- @Date:   2018-12-13 16:12:23
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-29 16:54:41
-- @File Name: GameTowerLevelReward.lua
local TierRewardConfig = require("Metadatas.TierRewardConfig")
local This = class(...)

-- local SingleManager = require("SingleDaily.SingleManager")

function This:create(id)
    local o = {}
    setmetatable(o,This)
    o:init(id)
    return o
end

function This:init(id)
    self.m_id = id
    self.m_config = TierRewardConfig[id]
    self.m_isHaveBoxReward = false
end

function This:getId()
    return self.m_id
end

function This:getReward()
    return self.m_config.reward
end

function This:getPassReward()
   return self.m_config.passreward 
end

function This:getChapterId()
    return self.m_config.layer
end

function This:setIsHaveBoxReward(isHaveBoxReward)
    self.m_isHaveBoxReward = isHaveBoxReward or false
end

function This:IsHaveBoxReward()
   return self.m_isHaveBoxReward
end

function This:getLevelHeadIcon()
    local iconId = self.m_config.icon
    local result = "Icons/Item/"..iconId..".png"
    return result
end
