-- @Author: zheng
-- @Date:   2019-11-27 14:59:07
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-11 18:02:27
-- @File Name: WarTowerVipBuyPanel.lua
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")
local SdkManager = require("Sdk.SdkManager")
local WarTowerManager = require("SingleDaily.WarTowerManager")
local GameUtil = require("Util.GameUtil")
This.fileName = "MenuScene/NodeUI/DrumTowerHelp.csb"
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    -- local data = self.m_data
    -- local csNode = self.m_csNode
    local isVip,endTime,haveReward = WarTowerManager:getVipInfo()
    self.m_isVip = isVip
    local rewards,day,price = WarTowerManager:getVipConfig()
    local csNode = self.m_csNode
    local vipBg = csNode.VIPbg
    csNode.days:setString(string.format(Serialize[64231],day))
    vipBg.notactive:setVisible(not isVip)
    vipBg.activated:setVisible(isVip)
    local jiHuo,lingQu,yiLingQu = true,false,false
    if isVip then
        jiHuo = false
        lingQu = haveReward
        yiLingQu = not haveReward
    end
    for index=1,10 do
        local node1 = vipBg["VIPrewarditem"..index]
        local temReward = rewards[index]
        if node1 and temReward then
            GameUtil:creatItemNode(node1,temReward) 
        end
    end
    csNode.received:setVisible(yiLingQu)
    csNode.receive:setVisible(lingQu)
    csNode.activation:setVisible(jiHuo)
    csNode.activation.text:setString(string.format(Serialize[64232],price))
end

function This:initTouchEvent()
    local csNode = self.m_csNode

 --    item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
    -- csNode.close:setTouchEnded(function()
 --        self:close()
 --    end)
    csNode.colsebg:setTouchEnded(function()
        self:close()
    end)
    csNode.receive:setTouchEnded(function()--领取
        WarTowerManager:onGetVipRewardRequest()
    end) 
    csNode.activation:setTouchEnded(function()--购买
        SdkManager:onApplyBillIDRequest(WarTowerManager:getVipId())
    end)
    -- csNode.colsebg:setTouchEnded(function()
    --     
    -- end)
    -- csNode.colsebg:setTouchEnded(function()
    --     
    -- end)
end

function This:onEnter()
    super.onEnter(self)
    WarTowerManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    WarTowerManager:removeObserver(self)
end

function This:onGetInfo()
    local isVip,endTime,haveReward = WarTowerManager:getVipInfo()
    if not self.m_isVip and isVip then
        g_scene:showTips(Serialize[64233])
    end
    self:refresh()
end
This.onGetVipReward = This.refresh