--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local BuffConfig = require("Metadatas.BuffConfig")

BuffState = 
{
	Running = 1,
	Stop = 2,
}

BuffKind =
{
	kRecoverAnger = 1, --回复怒气(瞬间起效)
	kPurificate = 2,  --净化，移除不良状态(瞬间起效)
	kBardArmor = 3, --坚铠，物伤减免（持续状态）
	kAcePack = 4, --锦囊，计谋减免（持续状态）
	kDragonScales =5, --龙鳞， 免疫所有控制和debuff
	kFlyGeneral = 6, --飞将，免疫所有控制和负面状态（持续状态）
	kInvincible = 7, --无敌，免疫所有伤害和效果（持续状态）
	kSpiritChain = 8, --灵魂锁链，伤害分摊（持续状态）
	kDevilSeeks = 9, --鬼谋，计谋伤害加成（持续状态）
	kHappeneth = 10, --力战，物理伤害加成（持续状态）
	kEncouraging = 11, --鼓舞，伤害加成（持续状态）
	kTreatment = 12, --治疗， 恢复生命(瞬间起效)
	kResistEnemy = 13, --克敌， 暴击率提升（持续状态）
	kEaseFatigue = 14, --以逸待劳， 闪避率提升（持续状态）
	kSeeThrough = 15, --看穿，识破率提升（持续状态）
	kWeakenAnger = 16, --削怒，减少怒气(瞬间起效)
	kToDisperse = 17, --驱散	,移除增益状态(瞬间起效)
	kDizziness = 18, --眩晕，无法发动普通攻击和技能（持续状态）
	kConstraint = 19, --束缚,无法发动普通攻击（持续状态）
	kSilence = 20, --沉默,无法发动技能（持续状态）
	kCalcination = 21, --灼烧,持续受到伤害（持续状态）
	kIronChain = 22,--铁索连环，部分伤害共享（持续状态）
	kBlockAnger = 23, --封怒，阻止恢复怒气（持续状态）
	kSeriouslyInjured = 24, --重伤，百分比减少治疗量（持续状态）
	kSunderArmor = 25, --破甲，减少物伤减免（持续状态）
	kBreakStratagem = 26, --破计， 减少计谋伤害减免（持续状态）
	kWeaken = 27, --虚弱	，减少伤害减免（持续状态）
	kTurnCripple = 28, --残废，减少物伤加成（持续状态）
	kFoolCrossbow = 29, --愚弩,减少计谋加成（持续状态）
	kBluntness = 30, --迟钝，减少伤害加成（持续状态）
}

BuffClass=
{
	[BuffKind.kRecoverAnger] = {class = "Skill.BuffInstant",name=Serialize[64241]},
	[BuffKind.kPurificate] = {class = "Skill.BuffInstant",name = Serialize[64242]},
	[BuffKind.kBardArmor] = {class="Skill.BuffState",name=Serialize[64243]},
	[BuffKind.kAcePack] = {class = "Skill.BuffState",name=Serialize[64244]},
	[BuffKind.kDragonScales] = {class = "Skill.BuffState", name = Serialize[64245]},
	[BuffKind.kFlyGeneral] = {class = "Skill.BuffState", name =Serialize[64246]},
	[BuffKind.kInvincible] = {class = "Skill.BuffState", name = Serialize[63555]},
	[BuffKind.kSpiritChain] = {class = "Skill.BuffGroupDmg", name = Serialize[64247]},
	[BuffKind.kDevilSeeks] = {class = "Skill.BuffState", name = Serialize[64248]},
	[BuffKind.kHappeneth] = {class = "Skill.BuffState", name = Serialize[64249]},
	[BuffKind.kEncouraging] = {class = "Skill.BuffState",name= Serialize[64250]},
	[BuffKind.kTreatment] = {class = "Skill.BuffInstant",name = Serialize[64251]},
	[BuffKind.kResistEnemy] = {class = "Skill.BuffState",name=Serialize[64252]},
	[BuffKind.kEaseFatigue] = {class = "Skill.BuffState",name=Serialize[64253]},
	[BuffKind.kSeeThrough] = {class = "Skill.BuffState",name=Serialize[64254]},
	[BuffKind.kWeakenAnger] = {class = "Skill.BuffInstant",name=Serialize[64255]},
	[BuffKind.kToDisperse] = {class = "Skill.BuffInstant",name=Serialize[64256]},
	[BuffKind.kDizziness] = {class = "Skill.BuffState",name=Serialize[64257]},
	[BuffKind.kConstraint] = {class = "Skill.BuffState",name=Serialize[64258]},
	[BuffKind.kSilence] = {class = "Skill.BuffState",name = Serialize[64259]},
	[BuffKind.kCalcination] = {class = "Skill.BuffDamage",name = Serialize[64260]},
	[BuffKind.kIronChain] = {class = "Skill.BuffGroupDmg",name = Serialize[64261]},
	[BuffKind.kBlockAnger] = {class = "Skill.BuffState", name = Serialize[64262]},
	[BuffKind.kSeriouslyInjured] = {class = "Skill.BuffState", name = Serialize[64263]},
	[BuffKind.kSunderArmor] = {class = "Skill.BuffState", name = Serialize[64264]},
	[BuffKind.kBreakStratagem] = {class = "Skill.BuffState",name = Serialize[64265]},
	[BuffKind.kWeaken] = {class = "Skill.BuffState",name = Serialize[64266]},
	[BuffKind.kTurnCripple] = {class = "Skill.BuffState",name = Serialize[64267]},
	[BuffKind.kFoolCrossbow] = {class = "Skill.BuffState",name = Serialize[64268]},
	[BuffKind.kBluntness] = {class = "Skill.BuffState",name = Serialize[64269]}
}

function This:create(...)
	local buff = {}
	setmetatable(buff,self)
	buff:init(...)
	return buff
end

function This:init(info)
	self.m_state = BuffState.Stop
	self.m_attackInfo = info
	self.m_id = info.id
	self.m_config = BuffConfig[info.id]
	self.m_roundCount = self.m_config.last_round_num
	self.m_gameScene = nil
end

function This:getGameScene()
	return self.m_gameScene
end

function This:setGameScene(gameScene)
	self.m_gameScene = gameScene
end

function This:getId()
	return self.m_attackInfo.id
end

function This:getType()
	return self.m_config.type
end

function This:getAttackInfo()
	return self.m_attackInfo
end

function This:getConfig()
	return self.m_config
end

function This:isStop()
	return self.m_state == BuffState.Stop
end

function This:isRunning()
	return self.m_state == BuffState.Running
end

function This:isBuff()
	return self.m_config.is_buff == 1
end

function This:isDebuff()
	return self.m_config.is_buff == 0
end

function This:getApplyer()
	return self.m_attackInfo.applyer
end

function This:getReceiver()
	return self.m_attackInfo.receiver
end

function This:getRoundCount()
	return self.m_roundCount
end

function This:addRoundCount(count)
	self.m_roundCount = self.m_roundCount + count
end

function This:playSound()
	if self:isBuff() then
		cc.Audio:playEffect("Skill_Up.mp3")
	else
		cc.Audio:playEffect("Skill_Down.mp3")
	end
end

function This:work()
	assert(false,"buff work")
end

function This:stop()
	
end

function This:receiverEnterAttack()
	
end

function This:receiverHitted()
	
end

function This:troopsDead(troops)

end

function This:update()

end

--endregion
