--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Skill.Behavior")
local BattlePlayer = require("Battle.BattlePlayer")
local SkillCommon = require("Skill.SkillCommon")

function This:work(behavior,finishHandler)
	local sourcetarget = BattlePlayer:getTroopsByHeroId(behavior.sourceIsEnemy,behavior.sourceHeroId)
	local troops = BattlePlayer:getTroopsByHeroId(behavior.isEnemy,behavior.heroId)

	if not sourcetarget or not sourcetarget:isAlive() or not troops or not troops:isAlive() then
		finishHandler()
		return
	end

	local function handler()
		print(string.format("部队%d开始反击...",troops:getId()))
		local effectList = {}
		local effect = {}
		effect.heroId = behavior.sourceHeroId
		effect.isEnmey = behavior.sourceIsEnemy
		effect.effectResult = 0
		table.insert(effectList,effect)

		local target = {}
		target.heroId = behavior.heroId
		target.isEnemy = behavior.isEnemy
		target.effectId = behavior.effectId
		target.effectValue = behavior.effectValue
		target.effectResult = behavior.effectResult
		target.hp = behavior.hp
		target.effectFinalValue = behavior.hp
		target.behavior = {}
		effect.target = {target}

		local skill = SkillCommon:create()
		skill:setTroops(sourcetarget)
		sourcetarget:setSkill(skill)
		skill:work(effectList)		
	end

	local t = {}
	t.onTroopsForward = function(_,tp)
		if tp == sourcetarget then
			local view = sourcetarget:getView()
			if view then
				view:showFanji()
			end
		end
	end

	t.onTroopsBack = function(_,tp)
		if tp == sourcetarget then
			finishHandler()
			BattlePlayer:removeObserver(t)
		elseif tp == troops then
			handler()
		end
	end
	--[[t.onTroopsHitted = function(_,tp)
		if tp == troops then
			local view = troops:getView()
			if view then
				view:showFanji()
			end
		end
	end]]
	BattlePlayer:addObserver(t)
end

--endregion
