--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Skill.SkillCommon")
local HeroManager = require("Hero.HeroManager")
local BattlePlayer = require("Battle.BattlePlayer")

function This:init(id)
	self.m_id = id
	self.m_searchId = TargetSearchType.kOtherSideSingle
	self.m_psvSkill = HeroManager:getPsvSkill(self.m_id)
end

function This:getName()
	return self.m_psvSkill:getName()
end

function This:isNeedForward()
	return false
end

function This:isPassive()
	return true
end

function This:active(endHandler)
	self.m_state = SkillState.ACTIVE
	--[[local view = self.m_troops:getView()
	if view then
		view:skillActived(self,endHandler)
	else
		endHandler()
	end]]
	endHandler()
end

function This:work(effectList)
	BattlePlayer:onTroopsAttack(self.m_troops,self)
	local view = self.m_troops:getView()
	if view then
		--[[local timer = g_scene:getTimer()
		timer:setTimer(kSkillShowTime - kSkillActiveTime,function()]]
			self.m_troops.m_forwardEndTime = os.clock()
			self:doWork(effectList,false)
		--end,"skill_work")
	else
		self:doWork(effectList,isNeedForward)
	end
end



--endregion
