--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Skill.SkillSpecial")
local BattlePlayer = require("Battle.BattlePlayer")

function This:doWork(effectList,isNeedBack)
	local effect1004 = {}
	local effectOther = {}

	local callBackCount = 0
	for i , effect in ipairs(effectList) do
		if effect.effectResult == 0 then
			for j , target in ipairs(effect.target) do
				callBackCount = callBackCount + 1
			end
			if effect.effectId == 1004 then
				table.insert(effect1004,effect)
			else
				table.insert(effectOther,effect)
			end
		end
	end

	local function hitEndHandler()
		callBackCount = callBackCount - 1
		if callBackCount <= 0 then
			self.m_troops:back(isNeedBack)
		end
	end

	local function applyOtherEffect(effect)
		for i , hitInfo in ipairs(effect.target) do
			local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
			if target and target:getState() ~=  TroopsState.kDead then
				print(string.format("部队%d施加效果,效果ID:%d,效果值:%f",target:getId(),hitInfo.effectId,hitInfo.effectValue))
				target:hitted(hitInfo,self.m_troops,hitEndHandler)	
			end
		end
	end

	for i , effect in ipairs(effectOther) do
		applyOtherEffect(effect)
	end

	local index = 1
	local function apply1004Effect(effect)
		for i , hitInfo in ipairs(effect.target) do
			local function endHandler()
				if i == #effect.target then
					index = index + 1
					if index <= #effect1004 then
						apply1004Effect(effect1004[index])
					end
				end
				hitEndHandler()
			end
			local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
			if target and target:getState() ~= TroopsState.kDead then
				print(string.format("部队%d施加效果,效果ID:%d,效果值:%f",target:getId(),hitInfo.effectId,hitInfo.effectValue))
				target:hitted(hitInfo,self.m_troops,endHandler)
			else
				endHandler()
			end
		end
	end

	if index <= #effect1004 then
		apply1004Effect(effect1004[index])
	end
end


--endregion
