--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

----------------------------------------特殊技能---------------------------------------

local This , super = class(...,"Skill.SkillCommon")
local SkillConfig = require("Metadatas.SkillConfig")
local BuffConfig = require("Metadatas.BuffConfig")
local BattleDataManager = require("Battle.BattleDataManager")
local BattlePlayer = require("Battle.BattlePlayer")
local Timer = require("Timer")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")

function This:init(id)
	self.m_id = id
	self.m_config = SkillConfig[id]
	self.m_searchId = TargetSearchType.kOtherSideSingle
end

function This:getConfig()
	return self.m_config
end

function This:getName()
	return self.m_config.name
end

function This:getDescripe()
	return self.m_config.desp
end

function This:getDamageType()
	return self.m_config.herooo
end

function This:isWaken()
	return self.m_config.type == 1
end

function This:isPassive()
	return false
end

function This:active(endHandler)
	self.m_state = SkillState.ACTIVE
	local view = self.m_troops:getView()
	if view then
		view:skillActived(self,endHandler)
	else
		endHandler()
	end
end

function This:work(effectList)
	BattlePlayer:onTroopsAttack(self.m_troops,self)
	local view = self.m_troops:getView()
	if view then
		local timer = g_scene:getTimer()
		timer:setTimer(kSkillShowTime - kSkillActiveTime,function()
			self.m_troops.m_forwardEndTime = os.clock()
			self:doWork(effectList,false)
		end,"skill_work")
	else
		self:doWork(effectList,isNeedForward)
	end
end

--endregion
