-- @Author: zheng
-- @Date:   2018-10-20 14:44:30
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-10-20 14:44:30
-- @File Name: ChallengeTimesRewardPanel.lua
local ChallengeStageManager = require("Stage.ChallengeStageManager")

local This , super = class(...,"NewActivity.ActivityHappyTurnDayItemView")


function This:onPickUpBtnClick()
    if self:isOpening() then
        ChallengeStageManager:onRequestGetChallengeTimesReward(self.m_config.id)
    end
end

function This:refresh(data)
    if data then
        self.m_config = data
    end
    self.numbercishu:setString(self.m_config.challengetime)
    self:setItemEnable(self:isOpening())
    self.beijing.zhuandong:setImage("MenuScene/wordcishu.png")
end

function This:isOpening()
    return self.m_config and self.m_config.state == ChallengeBoxState.kOpen
end

function This:isLocked()
    return self.m_config and self.m_config.state == ChallengeBoxState.kLock
end