-- @Author: zheng
-- @Date:   2018-08-16 20:13:37
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-06 11:39:26
-- @File Name: ChallengeTurnDayItemView.lua
local ChallengeStageManager = require("Stage.ChallengeStageManager")

local This , super = class(...,"NewActivity.ActivityHappyTurnDayItemView")


function This:onPickUpBtnClick()
    if self:isOpening() then
        ChallengeStageManager:onReceiveStarRewardRequest(2,self.m_config.id)
    end
end

function This:refresh(data)
    if data then
        self.m_config = data
    end
    self.numbercishu:setString(self.m_config.starLv)
    self:setItemEnable(self:isOpening())
    self.beijing.zhuandong:setImage("MenuScene/wordxingshu.png")
end

function This:isOpening()
    return self.m_config and self.m_config.state == ChallengeBoxState.kOpen
end

function This:isLocked()
    return self.m_config and self.m_config.state == ChallengeBoxState.kLock
end