--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(..., "Store.StoreItemView")
This.fileName = "MenuScene/NodeUI/QualifyingBaogeItem.csb"

local MatchingConfig = require("Metadatas.MatchingConfig")

function This:isLocked()
    return self.m_slot:isLocked()
end

function This:refreshConditionUI()
    if self.m_slot:getStoreType() == StoreType.kMingWangBaoge then
          self.condition:setVisible(true)
          self.condition:setString(Serialize[64367] .. self.m_slot.m_condLevel .. Serialize[60759])
    else
        local cType, cNum = self.m_slot:getCondition()

        local switch = {
            [TerrConditionType.kPlayerLev] = function(arg)
                self.condition:setString(Serialize[62310] .. arg .. Serialize[60759])
            end,
            [TerrConditionType.kTerrMainBuildLev] = function(arg)   
                self.condition:setString(Serialize[64368] .. arg .. Serialize[60759])
            end,
            [TerrConditionType.kRankLev] = function(arg)   
                self.condition:setString(MatchingConfig[arg].rank_level .. Serialize[60201])
            end,
            [TerrConditionType.kArenaRank] = function(arg)   
                self.condition:setString(Serialize[64360] .. arg .. Serialize[64361])
            end,
        }

        local func = switch[cType]
        if func then
            self.condition:setVisible(true)
            func(cNum)
        else
            self.condition:setVisible(false)
        end
    end
end

function This:onBuyCommonStoreItem( storeType, slotId )
end

function This:onBuyBaogeStoreItem( storeType, slotId )
    self:refreshWhenBought( storeType, slotId )
end


--endregion
