--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Store.StoreBaseModel")
local DepotManager = require("Depot.DepotManager")

function This:create(...)
    local ret = {}
    setmetatable(ret,self)
    ret:init(...)
    return ret
end

function This:beforeEndUpdate()
    self.m_state = StoreObjectState.kLocked
end

function This:initBaseData( info )
    super.initBaseData(self, info)
    self.m_interval = info.left_time or 0
    self.m_startTime = 0
    self.m_endTime = info.last_time or 0
    -- self.m_endTime = self.m_startTime + self.m_interval

end

function This:updateBaseData( info )
    super.updateBaseData(self, info)
    self.m_interval = info.left_time or 0
    self.m_startTime = 0
    self:setEndTime(info.last_time or 0)
end

function This:isNotLockedBy(condition)
    return true
end

function This:isNeedBuyValid()
    return false
end

function This:needBuy()
    return false
end

function This:hasItemNotBought()
    return self:getObjectBy(function ( obj )
        return not obj:isMaxTime()
    end)
end

function This:hasFreeItemNotBought()
    return self:getObjectBy(function ( obj )
        return obj:getPrice() <= 0 and not obj:isMaxTime()
    end)
end

function This:getCSFileName()
    return "MenuScene/NodeUI/QualifyingMysteryShop.csb"
end

function This:getUITypeName()
    return "Store.StoreMysteryUI"
end


--endregion