local This, super = class(..., "Dialog")
This.openSound = "Open_Ui.mp3"
This.isQuickExit = true
local SystemManager = require("System.SystemManager")

function This:initData()
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BuyVigorTips.csb")
    self.m_csNode:setPosition(cc.visible.center.x, cc.visible.center.y)
    self:addChild(self.m_csNode)
    self.m_csNode.cost:setString(SystemManager:getBuyPowerDiamondCost())
    self.m_csNode.vigor:setString(SystemManager:getBuyPower())
end

function This:initTouchEvent()
    self.m_csNode.cancelButton:setTouchEnded(function()
        self:close()
    end)
    self.m_csNode.confirmButton:setTouchEnded(function()
        SystemManager:onBuyPowerRequest()
        self:close()
    end)
end