--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local TerrBuildManager = require("Territory.TerrBuildManager")

function This:initNode(queue)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Building5.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	--只作为前端显示
	self.m_index = queue:getId()
	self.m_csNode.tips:setString(Serialize[64555] .. self.m_index .. Serialize[64556])

	self.m_csNode.FangShi1.price:setString("" .. queue:getBuyCost(1) .. Serialize[64557])
	self.m_csNode.FangShi2.price:setString("" .. queue:getBuyCost(7) .. Serialize[64558])
end

function This:setUnlockHandler(handler)
	self.m_handler = handler
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.FangShi1.button:setTouchEnded(function()
		if self.m_handler then
			self.m_handler(1)
		end	
	end)

	self.m_csNode.FangShi2.button:setTouchEnded(function()
		if self.m_handler then
			self.m_handler(7)
		end	
	end)
	
end

function This:onEnter()
	super.onEnter(self)
	TerrBuildManager:addObserver(self)
end

function This:onExit()
	TerrBuildManager:removeObserver(self)
    super.onExit(self)
end

function This:onTouchMask()
	self:close()
end

function This:onBuildQueueBuy()
	self:close()
end

--endregion
