-- @Author: su
-- @Date:   2019-02-27 16:14:00
-- @Last Modified by:   su
-- @Last Modified time: 2019-02-27 16:14:00
-- @File Name: TerrBuildingHuiShou.lua
-- @Description: 

local This , super = class(...,"Territory.TerrBuild")
local ArgConfig = require("Metadatas.ArgConfig")

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end

function This:getConditions()
    return {1,self.m_descConfig.open_level}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
    	g_scene:showTips(Serialize[64521] .. level .. Serialize[60394]) 
        return
    else
        if not self.m_clickFunc then
            self.m_clickFunc = function()
                g_scene:openDialog("Bag.RecyclePanel")
            end
        end
        return self.m_clickFunc
    end
end