--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local NewActivityManager = require("NewActivity.NewActivityManager")

local kShowSeconds = 5
local kHideSeconds = 3

local ShowTextList = 
{
	Serialize[64533],
	Serialize[64534],
	Serialize[64535],
	Serialize[64536],
}

local ShowBuyTextList = 
{
	Serialize[64537],
	Serialize[64538],
	Serialize[64539]
}

function This:init()
	self.m_model = NewActivityManager:getActivity(NewActivityType.kWuDaoShop1)
	self.m_viewName = Serialize[64652]
	self:initShopView()
end

function This:initShopView()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WuDaoNode.csb")
	self:addChild(self.m_csNode)
    local skeletonNode = cc.SkeletonNode:createCharacter("ShangRen")
    skeletonNode:scheduleUpdate()
	-- self.m_csNode:addChild(skeletonNode,-1)
	self.m_csNode.cityname_bg:setVisible(false)
	self.m_csNode.name:setVisible(false)
	self.m_csNode.name:setString(self.m_viewName)
	self.m_csNode.node:setCascadeOpacityEnabled(true)
	self.m_csNode.node:setOpacity(0)
	self.m_csNode.node:setPosition(-130,70)
	self.m_isVisible = false

	self.m_skeleton = skeletonNode
	self.m_escape = 15
end

-- function This:initTouchEvent()
-- 	self:setTouch({
-- 		onEnded = function()
-- 			local ret , season = self.m_model:isLevelOpen() 
-- 			if not ret then
-- 				g_scene:showTips(season)
-- 				return
-- 			end
-- 			if self.m_model:getState() == NewActivityState.kUpdating then
-- 				g_scene:openDialog("NewActivity.WudaoShopPanel")
-- 			else
-- 				g_scene:showTips(Serialize[62062])
-- 			end
-- 		end,
-- 		isDynamic = true,
-- 		sizeNode = self.m_csNode.dikuang
-- 	})
-- end

function This:onEnter()
	super.onEnter(self)
	-- self:initTouchEvent()
	self.m_model:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_model:removeObserver(self)
end

function This:appear(str)
	self.m_csNode.node.speek:setString(str, 600)
	local w , h = self.m_csNode.node.speek:getContentSize()
	local scale = self.m_csNode.node.speek:getScale()
	w , h = w * scale + 15 , h * scale + 40

	self.m_csNode.node.bg:setContentSize(w ,h)

	self.m_csNode.node.bg:setPosition(w / 2, h / 2)
	local x , y = self.m_csNode.node.bg:getPosition()
	self.m_csNode.node.speek:setPosition(w/2 , h/2 + 10)
	self.m_csNode.node:runAction(cc.FadeIn(0.5))
	self.m_isVisible = true
end

function This:appearWithBuyText()
	-- local index = math.random(1,#ShowBuyTextList)
	-- self:appear(ShowBuyTextList[index])
end

function This:appearWithIdleText()
	-- local index = math.random(1,#ShowTextList)
	-- self:appear(ShowTextList[index])
end

function This:disappear()
	self.m_csNode.node:runAction(cc.FadeOut(0.5))
	self.m_isVisible = false
end

function This:onActivityStart()
	self.m_escape = 0
	self:appearWithIdleText()
end

function This:onActivityEnded()
	self.m_escape = 0
	self:disappear()
end

function This:onUpdateActivity()
	self:update()
end

function This:update()
	if self.m_isVisible then
		self.m_escape = self.m_escape + 1
		if self.m_escape >= kShowSeconds then
			self.m_escape = 0
			self:disappear()
		end
	else
		self.m_escape = self.m_escape + 1
		if self.m_escape >= kHideSeconds then
			self.m_escape = 0
			self:appearWithIdleText()
		end
	end
end

--endregion
