local This, super = class(..., "Dialog")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("LoginScene/NodeUI/HotUpdate.csb")
    self.m_csNode:setPosition(cc.visible.center.x, cc.visible.center.y)
    self:addChild(self.m_csNode)
    self.m_csNode.button.text:setString(Serialize[64666])
    self.m_csNode.tips:setString(info.tips or Serialize[64667], 450)
    self.m_onConfirm = info.onConfirm
end

function This:initTouchEvent()
    self.m_csNode.button:setTouchEnded(function ()
        if self.m_onConfirm then
            self:m_onConfirm()
        end
        self:close()
    end)
end