--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ViewUtil = require "UI.ViewUtil"

local TabName = 
{
	[HelpPanelTabName.kMatch] = Serialize[64674],
	[HelpPanelTabName.kRank] = Serialize[64675],
	[HelpPanelTabName.kTerri] = Serialize[64676],
	[HelpPanelTabName.kStranger] = Serialize[64677],
	[HelpPanelTabName.kLevelUp] = Serialize[60793],
	[HelpPanelTabName.kVip] = "VIP",
}

local HelpText = 
{
	[HelpPanelTabName.kMatch] =Serialize["ui_HelpPanel_1"] ,
	[HelpPanelTabName.kRank] =Serialize["ui_HelpPanel_2"] ,
	[HelpPanelTabName.kTerri] =Serialize["ui_HelpPanel_3"] ,
	[HelpPanelTabName.kStranger] =Serialize["ui_HelpPanel_4"] ,
	[HelpPanelTabName.kLevelUp] =Serialize["ui_HelpPanel_5"] ,
	[HelpPanelTabName.kVip] =Serialize["ui_HelpPanel_6"] 
}

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/HelpMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self:addTabButton(HelpPanelTabName.kMatch,self.m_csNode.tep1,function()
		self:selectTab(HelpPanelTabName.kMatch)
	end)
	self:addTabButton(HelpPanelTabName.kRank,self.m_csNode.tep2,function()
		self:selectTab(HelpPanelTabName.kRank)
	end)
	self:addTabButton(HelpPanelTabName.kTerri,self.m_csNode.tep3,function()
		self:selectTab(HelpPanelTabName.kTerri)
	end)

	self:addTabButton(HelpPanelTabName.kStranger,self.m_csNode.tep4,function()
		self:selectTab(HelpPanelTabName.kStranger)
	end)

	self:addTabButton(HelpPanelTabName.kLevelUp,self.m_csNode.tep5,function()
		self:selectTab(HelpPanelTabName.kLevelUp)
	end)

	self:addTabButton(HelpPanelTabName.kVip,self.m_csNode.tep6,function()
		self:selectTab(HelpPanelTabName.kVip)
	end)
	self:selectTabButton(info and info.index or HelpPanelTabName.kMatch)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:selectTab(tab)
	if self.m_curTab == tab then
		return
	end
	self.m_curTab = tab
	self.m_csNode.teptitle:setString(TabName[tab])
	self.m_csNode.scrollview:removeAllItems()
	local text = cc.Label:createNormalTTF("",16)
	text:setStringWithColor(HelpText[tab],740)
	text:setAnchorPoint(0.5,0)
	text:setCascadeOpacityEnabled(true)
	local w , h = text:getContentSize()
	self.m_csNode.scrollview:pushBackCustomItem(text,w,h,0)
end



--endregion
