--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"UI.UIBaseView")
local Serialize = require("Serialize.Serialize")

function This:createWithErrorCode(errorCode)
	local str = Serialize[errorCode]
    local rv = self:create(str)
	return rv
end

function This:init(text)
	super.init(self)
	self.m_text = text
end

function This:onEnter()
	super.onEnter(self)
	local label = cc.Label:createNormalTTF(self.m_text)
	label:setColor(255,255,0)
	label:setAnchorPoint(0.5,0.5)
	self:addChild(label)
	self:startAction()
end

function This:startAction()
	local width ,height = cc.Director:getWinSize()
	local moveTo = cc.MoveTo(1.0, width/2, height/2 + 100, "SineInOut")
	local endHandler = cc.CallFunc(function()
		self:removeFromParent()
	end)
	self:runAction(cc.Sequence(moveTo,endHandler))
end

function This:show()
	local width ,height = cc.Director:getWinSize()
	self:setPosition(width/2,height/2)
	g_scene:addChild(self)
end

--endregion
