--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local function sendGm(cmd)
	local ChatManager = require("Chat.ChatManager")
	ChatManager:onSendGmRequest(cmd)
end

g_gmCmd = 
{

[1] = {
	name = "玩家属性",
	[1] = {name = "添加元宝10k\t",id = 1001,func = function()
		sendGm("add_gr 102 10000")
	end},
	[2] = {name = "添加金币1000k\t",id = 1002,func = function()
		sendGm("add_gr 101 1000000")
	end},
	[3] = {name = "添加体力120\t",id = 1003,func = function()
		sendGm("add_tili 120")
	end},
	[4] = {name = "服务器热更\t",id = 1004,func = function()
		sendGm("hot_update")
	end},
	[5] = {name = "自定义添加道具\t",id = 1005,func = function()
		GM.createEditDialog({"道具类型","道具数量"},function(values)
			print(values)
			sendGm(string.format("add_gr %s %s",values[1],values[2]))
		end)
	end},
	[6] = {name = "自定义等级\t",id = 1006,func = function()
		GM.createEditDialog({"玩家等级"},function(values)
			print(values)
			sendGm(string.format("change_level %s",values[1]))
		end)
	end},
	[7] = {name = "模拟充值648\t",id = 1007,func = function()
		sendGm("recharge 6")
	end},
	[8] = {name = "增加经验500\t",id = 1008,func = function()
		sendGm("add_exp 500")
	end},
	[9] = {name = "重登\t", id = 1009,func = function()
		local LoginManager = require("Login.LoginManager")
		LoginManager:switchAccount()
	end},
	[10] = {name = "跳过新手",id = 1010,func = function()
		local GuideManager = require("Guide.GuideManager")
		GuideManager:skipGuide()
	end},
	[11] = {name = "增加战局积分", id = 1011, func = function ()
		GM.createEditDialog({"新增数值"},function(values)
			print(values)
			sendGm(string.format("add_score %s",values[1]))
		end)
	end},
	[12] = {name = "设置服务器时间", id = 1012, func = function ()
		GM.createEditDialog({"年","月","日","时","分","秒"},function(values)
			print(values)
			sendGm(string.format("set_time %s %s %s %s %s %s",values[1],values[2],values[3],values[4],values[5],values[6]))
		end)
	end},
	[13] = {name = "添加所有装备3件",id = 1013, func = function()
		local ItemConfig = require("Metadatas.ItemConfig")
		local ChatManager = require("Chat.ChatManager")
		local ItemUtil = require("Bag.ItemUtil")
		for id, _ in pairs(ItemConfig) do
			if ItemUtil.getType(id) == ItemCommonType.kEquip then
				ChatManager:onSendGmRequest(string.format("add_gr %d 3", id))
			end
		end
	end},
	[14] = {name = "添加所有武将碎片10件",id = 1014, func = function()
		local ItemConfig = require("Metadatas.ItemConfig")
		local ChatManager = require("Chat.ChatManager")
		local ItemUtil = require("Bag.ItemUtil")
		for id, _ in pairs(ItemConfig) do
			if ItemUtil.getItemCategory(id) == ItemType.kHeroSpall then
				ChatManager:onSendGmRequest(string.format("add_gr %d 3", id))
			end
		end
	end},
	[15] = {name = "添加所有装备碎片10件",id = 1015, func = function()
		local ItemConfig = require("Metadatas.ItemConfig")
		local ChatManager = require("Chat.ChatManager")
		local ItemUtil = require("Bag.ItemUtil")
		for id, _ in pairs(ItemConfig) do
			if ItemUtil.getItemCategory(id) == ItemType.kEquipSpall then
				ChatManager:onSendGmRequest(string.format("add_gr %d 3", id))
			end
		end
	end},
	[16] = {name = "服务器热更到release", id = 1016, func = function ()
		GM.createEditDialog({"表名称"},function(values)
			print(values)
			sendGm(string.format("hot_update_release %s",values[1]))
		end)
	end},
	[17] = {name = "设置副本关卡", id = 1017, func = function ()
		GM.createEditDialog({"副本数"},function(values)
			print(values)
			sendGm(string.format("add_copy %s",values[1]))
		end)
	end},
	[18] = {name = "更换竞技场排名", id = 1018, func = function ()
		GM.createEditDialog({"排名1","排名2"},function(values)
			print(values)
			sendGm(string.format("change_competitive %s %s",values[1],values[2]))
		end)
	end},
},

[2] = {
	name = "世界地图",
	[1] = {name = "添加铜币100k\t",id = 2001,func = function()
		sendGm("add_coin 100000")
	end},
	[2] = {name = "添加粮草100k\t",id = 2002,func = function()
		sendGm("add_food 100000")
	end},
	[3] = {name = "立即开战\t",id = 2003,func = function()
		sendGm("change_fight_time 184")
	end},
	[4] = {name = "立即结束880\t",id = 2004,func = function()
		sendGm("change_start_time 880")
	end},
	[5] = {name = "立即结束280\t",id = 2005,func = function()
		sendGm("change_start_time 280")
	end},
	[6] = {name = "增加预备兵\t",id = 2006,func = function()
		GM.createEditDialog({"城池ID","数量"},function(values)
			print(values)
			sendGm(string.format("add_reserve_force %s %s",values[1],values[2]))
		end)
	end},
	[7] = {name = "修改城池归属\t",id = 2007,func = function()
		GM.createEditDialog({"城池ID"},function(values)
			print(values)
			sendGm(string.format("change_city_owner %s",values[1]))
		end)
	end},
	[8] = {name = "立即结束220\t",id = 2008,func = function()
		sendGm("change_start_time 220")
		end},
	[9] = {name = "马贼出现\t",id = 2009,func = function()
		sendGm("map_treasure 1")
	end}
},

[3] = {
	name = "武将属性\t",
	[1] = {name = "添加所有武将",id = 3001,func = function()
		GM.createEditDialog({"武将等级","武将星级"},function(values)
	      print(values)
	      sendGm(string.format("add_all_card %s %s",values[1],values[2]))
	    end)
	end},
	[2] = {name = "添加武将\t",id = 3002,func = function()
		GM.createEditDialog({"武将ID","武将等级","武将星级"},function(values)
	      print(values)
	      sendGm(string.format("add_card %s %s %s",values[1],values[2],values[3]))
	    end)
	end},
	[3] = {name = "添加武将经验\t",id = 3003,func = function()
		sendGm("add_property 3 1000000")
	end},
	[4] = {name = "升级特定武将\t",id = 3004,func = function()
		print("2004")
	end},
	[5] = {name = "添加升星石1000\t",id = 3005, func = function()
		sendGm("add_gr 113 1000")
	end},
	[6] = {name = "添加武将碎片\t",id = 3006, func = function()
		GM.createEditDialog({"碎片ID","碎片数量"},function(values)
	      print(values)
	      sendGm(string.format("add_gr %s %s",values[1],values[2]))
	    end)
	end},
	[7] = {name = "添加万能武将碎片\t",id = 3007, func = function()
		GM.createEditDialog({"碎片数量"},function(values)
	      sendGm(string.format("add_gr %d %s", 121,values[1]))
	    end)
	end},
	[8] = {name = "五连抽\t",id = 3008, func = function()
		GM.createEditDialog({"1蜀 2魏 3吴", "默认蜀"}, function(values)
			print(values)
			local countryId = tonumber(values[1]) or 1
			if countryId <= 0 then
				countryId = 1
			end
			local RecruitManager = require("Recruit.RecruitManager")
			local isOpen = RecruitManager:isCountryOpen(countryId)
			if isOpen then
				RecruitManager:onRecruitSpecialRequest(countryId,4)
			else
				local config = require("Metadatas.CountryConfig")[countryId]
				local c = config.card_num[1]
				g_scene:showTips(string.format("拥有%d个%s国武将或角色创建%d天解锁", config.card_num[2], CountryName[c],config.day))			
			end
		end)
	end},
	[9] = {name = "更新战力\t",id = 3009, func = function()
		GM.createEditDialog({"武将ID"}, function(values)
			local heroId = tonumber(values[1])
			local HeroManager = require("Hero.HeroManager")
			local hero = HeroManager:getHero(heroId)
			if hero:isGot() then
				hero:updateFightPower()
			end
		end)
	end},
	[10] = {name = "增加所有精进装备", id = 3010, func = function ()
		local RefinemenNeedtItemConfig = require("Metadatas.RefinemenNeedtItemConfig")
		for k, v in pairs(RefinemenNeedtItemConfig) do
			for i = 1, 4 do
				local needItem = v[string.format("need_item%d", i)]
				if needItem[1] then
					sendGm(string.format("add_gr %s %s", needItem[1], 200))
				end
			end
		end
	end},
	[11] = {name = "增加战法装备", id = 3011, func = function ()
		GM.createEditDialog({"战法星级"},function(values)
			-- print(values)
			local TacticsConfig = require("Metadatas.TacticsConfig")
			local star = tonumber(values[1])
			for id, v in pairs(TacticsConfig) do
				if v.star == star then
					sendGm(string.format("add_gr %s %s", id, 1))
				end
			end
		end)
	end},	
},
[4] = {
	name = "任务、活动相关",
	[1] = {name = "增加任务进度\t",id = 4001,func = function()
		GM.createEditDialog({"任务类型","参数1","参数2","参数3","进度"},function(values)
	      print(values)
	      sendGm(string.format("add_progress %s %s %s %s %s",values[1],values[2],values[3],values[4],values[5]))
	    end)
	end},
	[2] = {name = "重置每周活跃任务\t",id = 4002,func = function()
		sendGm("reset_week_mission")
	end},
	[3] = {name = "初始化活动列表\t",id = 4003,func = function()
		sendGm("init_activity_list")
	end},
	[4] = {name = "重置活动\t",id = 4004,func = function()
		GM.createEditDialog({"活动ID"},function(values)
			print(values)
			sendGm(string.format("reset_activity %s",values[1]))
		end)
	end},
	[5] = {name = "设置活动开始结束时间\t",id = 4005,func = function()
		GM.createEditDialog({"活动ID","开始时间戳","结束时间戳"},function(values)
			print(values)
			sendGm(string.format("set_activity_time %s %s %s",values[1],values[2],values[3]))
		end)
	end},
	[6] = {name = "设置开服时间戳\t",id = 4006,func = function()
		GM.createEditDialog({"开服时间戳"},function(values)
			print(values)
			sendGm(string.format("set_open_server_seconds %s",values[1]))
		end)
	end},
	[7] = {name = "设置合服时间戳\t",id = 4007,func = function()
		GM.createEditDialog({"合服时间戳"},function(values)
			print(values)
			sendGm(string.format("set_merge_server_seconds %s",values[1]))
		end)
	end},
	[8] = {name = "设置服务器 1内服 2正式 3release\t",id = 4008,func = function()
		GM.createEditDialog({"服务器No", "默认内服ip", "默认内服端口"},function(values)
			local configs = {
			    [1] = {-- 内服
				    loginServerHost = "192.168.1.87",
				    loginServerPort = 6677,
			    },
			    [2] = {-- 正式服
			    	loginServerHost = "193.112.18.195",
			    	loginServerPort = 6667,
			    	channelId = 1001,
			    	gameId = 1,
			    },
			    [3] = {--release
				    loginServerHost = "118.89.40.139",
				    loginServerPort = 6667,
				},
			    [4] = {--百龙争霸
				    loginServerHost = "129.204.197.78",
				    loginServerPort = 6667,
			    	channelId = 1001,
				    gameId = 2,
				},
				[5] = {-- 封测服
				    loginServerHost = "134.175.13.189",
				    loginServerPort = 6677,
				}
			}
			local index = tonumber(values[1])
			if not index or index <= 0 then index = 1 end
			local selectedConfig = configs[index] 
			local serverHost = string.len(values[2]) > 0 and values[2] or selectedConfig.loginServerHost

			local serverPort = tonumber(values[3]) 
			if not serverPort or serverPort <= 0 then serverPort = selectedConfig.loginServerPort end

			local channelId, gameId = selectedConfig.channelId or "", selectedConfig.gameId or ""

			local ServerConfig = require("Net.ServerConfig")
			ServerConfig.loginServerHost = serverHost
			ServerConfig.loginServerPort = serverPort
			ServerConfig.channelId = tostring(channelId) 
			ServerConfig.gameId = tostring(gameId) 
			g_setting.innerUsed = true
		end)
	end},
	},
	[5] = {
		name = "军团相关",
		[1] = {name = "添加军团资金\t",id = 5001,func = function()
			GM.createEditDialog({"资金数量"},function(values)
				print(values)
				sendGm(string.format("add_group_money %s",values[1]))
			end)
		end},
		[2] = {name = "进入军团地图\t", id = 5002, func = function()
			if g_setting.isWarTest then
				require("Map.GameMapUtil").getTestor(1, true)
			else
				require("Map.GameMapUtil").enterMap(1)
			end

		end},
		[3] = {name = "添加军团地图粮草\t", id = 5003, func = function()
			GM.createEditDialog({"粮草数量"},function(values)
				print(values)
				sendGm(string.format("add_food_group_war %s",values[1]))
			end)
		end},
		[4] = {name = "添加军团地图银币\t", id = 5004, func = function()
			GM.createEditDialog({"银币数量"},function(values)
				print(values)
				sendGm(string.format("add_coin_group_war %s",values[1]))
			end)
		end},
		[5] = {name = "军团出局\t", id = 5005, func = function()
			GM.createEditDialog({"军团名字"},function(values)
				print(values)
				sendGm(string.format("quit_map %s",values[1]))
			end)
		end},
		[6] = {name = "创建地图",id = 5006,func = function()
			sendGm(string.format("create_map 1"))
		end},
		[7] = {name = "更改城池归属",id = 5007, func = function()
			-- GM.createEditDialog({"城池ID","军团名字"}, function(values)
			-- 	local testor = require("Map.GameMapUtil").getTestor(3)
			-- 	if testor then
			-- 		local cityId = tonumber(values[1])
			-- 		local legionName = values[2]
			-- 		testor:changeCityToOur(cityId,legionName)
			-- 	end
			-- end)
			GM.createEditDialog({"城池ID"},function(values)
				sendGm(string.format("change_city_owner_group_war %s",values[1]))
			end)
		end},
		[8] = {name = "进入可编辑军团地图",id = 5008,func = function()
			require("Map.GameMapUtil").getEditor(1, true)
		end},
		[9] = {name = "进入勤王地图",id = 5009,func = function()
			if g_setting.isWarTest then
				require("Map.GameMapUtil").getTestor(3, true)
			else
				require("Map.GameMapUtil").enterMap(3)
			end
		end},
		[10] = {name = "创建行军\t", id = 5010, func = function()
			GM.createEditDialog({"出发城池","终点城池","运输资源","运输数量"},function(values)
				local testor = require("Map.GameMapUtil").getTestor(3)
				testor:createEnemyMarch({
					from_city = tonumber(values[1]),
					to_city = tonumber(values[2]),
					transType = tonumber(values[3]),
					resNum = tonumber(values[4]),
				})
			end)
		end},
		[11] = {name = "生成城防\t", id = 5011, func = function()
			GM.createEditDialog({"我方城池"},function(values)
				local testor = require("Map.GameMapUtil").getTestor(3)
				local cityId = tonumber(values[1])
				testor:createNewChengFang(cityId)
			end)
		end},
		[12] = {name = "更改城市状态",id = 5012,func = function()
			GM.createEditDialog({"城池ID","城池状态"},function(values)
				local testor = require("Map.GameMapUtil").getTestor(3)
				local cityId = tonumber(values[1])
				local state = tonumber(values[2])
				testor:changeCityState(cityId,state)
			end)
		end},
		[13] = {name = "进入可编辑勤王地图",id = 5013,func = function()
			require("Map.GameMapUtil").getEditor(3, true)
		end},
		[14] = {name = "添加军团龙气\t",id = 5014,func = function()
			GM.createEditDialog({"龙气值"},function(values)
				print(values)
				sendGm(string.format("add_group_loong %s",values[1]))
			end)
		end},
		[15] = {name = "添加军团活跃",id = 5015,func = function()
			GM.createEditDialog({"军团活跃"},function(values)
				print(values)
				sendGm(string.format("add_group_active %s",values[1]))
			end)
		end},
	},
	[6] = {
		name = "多语言切换",
		[1] = {name = "简体中文",id = 6001,func = function()
			require("AppText"):setLanguage('zh_CN')
		end},
		[2] = {name = "繁体中文",id = 6002,func = function()
			require("AppText"):setLanguage('zh_TW')
		end},
		[3] = {name = "美式英语",id = 6003,func = function()
			require("AppText"):setLanguage('en_US')
		end},
	}
}

-- function g_gmCmd.gmCommond(cmd)
	
-- end

function g_gmCmd.handleGm(cmd)
	if cmd then
		local pos = string.find(cmd, ":")
		if pos and pos > 1 then
			local tag = string.sub(cmd, 1, pos-1)
			if not tag then return end
			local content = string.sub(cmd, pos + 1)
			if not content then return end
			
			-- if g_gmCmd.handle_node then
			-- 	if g_gmCmd.handleNodeCommond(tag, content) then
			-- 		return
			-- 	end
			-- end

			if tag == "command" then 
				sendGm(content)
			elseif tag == "code" then 
				loadstring(content)()
			elseif tag == "reload" then 
				content = string.trim(content)
				content = string.trimAllNewline(content)
				require("Territory.TerrUtil"):reload(content)
			elseif tag == "reloadm" then 
				content = string.trim(content)
				content = string.trimAllNewline(content)
				require("Territory.TerrUtil"):find2Realod(content)
        	elseif tag == "debug" then
				local TerrUtil = require("Territory.TerrUtil")
				local value = loadstring(string.format("return %s", content))()
				g_setting.isDebug = value
				TerrUtil.open_debug = value
				TerrUtil.allways_debug = value
        	elseif tag == "print" then
        		local info = loadstring(string.format("return %s", content))()
				print_tmp(info)
			elseif tag == "node" then
				local TerrUtil = require("Territory.TerrUtil")
				g_setting.isDebug = true
				TerrUtil.isDebug = true
				content = string.trim(content)
				content = string.trimAllNewline(content)
				local paramList = string.split(content, ",")
				local keyList = {}
				local node_path = paramList[1]

			    for match in string.gmatch(node_path, "[^%.]+") do
			        keyList[#keyList + 1] = match
			    end

			    function getNode()
					local curNode = g_scene
					if curNode:getName() ~= keyList[1] then
						return
					end

					local fromIndex = 2
					local isVisible = curNode:isVisible()
					while fromIndex <= #keyList do
						local name = keyList[fromIndex]
						curNode = curNode:getChildByName(name)
						if not curNode then
							return
						end
						fromIndex = fromIndex + 1
					end
					return curNode
				end
				local node = getNode()
				if not node then
					print(string.format('node:%s not found', node_path))
				else
					g_gmCmd.handle_node = {
						node = node,					
						path = node_path,
						history = {},
						historyList = {}				
					}
					print(string.format('node:%s found', node_path))
				end
			end
		end
	end
end

function g_gmCmd.handleNodeCommond( cmd, content )
    if not g_gmCmd.handle_node then
    	return false
    end

    print("operate:" .. g_gmCmd.handle_node.path .. "\n")

	function pushCommond( cmd, content, result )
		local node = g_gmCmd.handle_node
	    if not node then
	    	return
	    end

	    node.result = result
		g_gmCmd.handle_node.last = cmd.. ":".. tostring(content)

		local historyList = node.history[cmd]
		if not historyList then
			historyList = {}
			node.history[cmd] = historyList
		end
	    historyList[content] = result
	    table.insert(node.historyList, cmd.. ":".. content)
	end

	local result = nil

    if cmd == "exit" then
		local TerrUtil = require("Territory.TerrUtil")
		g_setting.isDebug = false
		TerrUtil.isDebug = false
    	g_gmCmd.handle_node = nil
    	return false
    elseif cmd == "print" then
    	local curNode = g_gmCmd.handle_node.node
    	if not content or content == "[0]" then
			print_keys(curNode)
		else
			local result = loadstring("return g_gmCmd.handle_node.node." .. content)()
			print_keys(result)
			pushCommond( cmd, content, result )
		end
	elseif cmd == "mark" then
		local lastResult = g_gmCmd.handle_node.result
		g_gmCmd.handle_node.node = lastResult	
		return true
    end

	pushCommond( cmd, content, result )
    return true
end

return g_gmCmd

--endregion
