-- @Author: Su
-- @Date:   2019-05-06 17:33:33
-- @Last Modified by:   Su
-- @Last Modified time: 2019-05-06 17:33:33
-- @File Name: AnimalTeamWar.lua
-- @Description: 

local This , super = class(...,"Warfare.TeamWar")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")
local VipManager = require("Vip.VipManager")
local TeamCampaignConfig = require("Metadatas.TeamCampaignConfig")

function This:init(info)
    -- super.init(self)
    if info then
        self.m_config = info.config
        self.m_id = self.m_config.id
    end
    self.m_copyId = 11
    self.m_hasFight = false
    self.m_deConfig =TeamCampaignConfig[self.m_copyId]
    self.m_type = self.m_deConfig.tpye
    self.m_hasFight = false
end

function This:getState()
    return TeamWarState.kActive
end

function This:getRewardList()
    return self.m_config.reward_show
end

function This:getName()
    return self.m_deConfig.name
end

function This:getCopyId()
    return self.m_copyId
end

function This:getNextHard()
    return self.m_config.difficult
end

function This:getTicketId()
    return self.m_deConfig.ticket_ID
end

function This:getTicketCost()
    return self.m_deConfig.cost[1]
end

function This:setIsFight(isfight)
    self.m_hasFight = isfight
end

function This:getIsFight()
    return self.m_hasFight
end
