-- @Author: Su
-- @Date:   2019-05-06 17:33:33
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-04 17:33:33
-- @File Name: BossTeamWar.lua
-- @Description: 

local This , super = class(...,"Warfare.TeamWar")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")
local VipManager = require("Vip.VipManager")


function This:init(robber)
    self.m_posId = robber:getId()
    self.m_id = robber:getRobberId()
    self.m_copyId = 12
    self.m_hasFight = false
    self.m_config = robber:getConfig()
end

function This:getState()
    return TeamWarState.kActive
end

function This:getRewardList()
    return self.m_config.reward
end

function This:getName()
    return self.m_config.name
end

function This:getPosId()
    return self.m_posId
end

function This:getCopyId()
    return self.m_copyId
end

function This:getId()
    return self.m_id
end

function This:getType()
    return WarfareType.kBoss
end

function This:setIsFight(isfight)
    self.m_hasFight = isfight
end

function This:getIsFight()
    return self.m_hasFight
end
