-- @Author: superm
-- @Date:   2018-08-27 12:15:30
-- @Last Modified by:   superm
-- @Last Modified time: 2018-09-03 12:38:19
-- @File Name: WarMarchArmy.lua
-- @Description: 

local This = class(...)

function This:create(...)
	local a = {}
	setmetatable(a,self)
	a:init(...)
	return a
end

function This:init(info, isOur, index, anonymous)
	if not anonymous then
		self.m_id = info.id
	else
		self.m_id = info.id + index
	end
	self.m_level = info.level
	self.m_name = info.name
	self.m_initHp = info.force_num_init or 0
	self.m_leftHp = info.force_num_result
	self.m_reward = info.reward_list
	self.m_armyId = info.object_id
	self.m_isOur = isOur

	self.m_anonymous = anonymous
	self.m_index = info.index
end

function This:getTotalHp()
    return self.m_initHp
end

function This:getName()
	if not self.m_anonymous then
    	return self.m_name
    else
    	return ""
    end
end

function This:getId()
    return self.m_id
end

function This:getOwnerId()
   return self.m_id  
end

function This:isOur()
    return self.m_isOur
end
