--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local WorldMapManager = require("World.WorldMapManager")
local ItemConfig = require("Metadatas.ItemConfig")

function This:initNode(info)
	self.m_city = info.city;
	self.m_itemUid = info.itemUid
	self.m_itemId = info.itemId
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TreasuseMap.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode.jindutiao:setPercent(0)
	self.m_csNode.button3:setVisible(false)
	self.m_csNode.tips:setVisible(false)
	self.m_csNode.jindutiao:setVisible(false)
	self.m_csNode.jindutiaobg:setVisible(false)
	self.m_csNode.text:setString(string.format(Serialize["world_TreasureMap_1"],ItemConfig[self.m_itemId].name))
end

function This:initTouchEvent()
	self.m_csNode.button1:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.button3:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.button2:setTouchEnded(function()
		self:startAction()
	end)
end

function This:startAction()
	self.m_csNode.jindutiao:runPercentAction(100,100/3)
	self:runAction(cc.Sequence(
		cc.DelayTime(3),
		cc.CallFunc(function()
			WorldMapManager:onUseTreasureMapRequest(self.m_itemUid,self.m_itemId)
		end)
	))
	self.m_csNode.tips:setVisible(true)
	self.m_csNode.jindutiao:setVisible(true)
	self.m_csNode.jindutiaobg:setVisible(true)
	self.m_csNode.text:setVisible(false)
end

function This:onEnter()
	super.onEnter(self)
	WorldMapManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	WorldMapManager:removeObserver(self)
end

function This:onUseTreasureMap(eventType)
	self.m_csNode.button3:setVisible(true)
	self.m_csNode.button1:setVisible(false)
	self.m_csNode.button2:setVisible(false)
	self.m_csNode.tips:setVisible(false)
	self.m_csNode.text:setVisible(true)
	self.m_csNode.jindutiao:setVisible(false)
	self.m_csNode.jindutiaobg:setVisible(false)
	self.m_csNode.title:setImage("MenuScene/cbt_title2.png")

	if eventType == TreasureMapEventType.kTreasureBox then
		self.m_csNode.text:setString(Serialize["world_TreasureMap_2"])
	elseif eventType == TreasureMapEventType.kRebels then
		self.m_csNode.text:setString(Serialize["world_TreasureMap_3"])
	else
		self:close()
	end
end

--endregion
