--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Stage.StageSelectHeroPanel")
local HeroManager = require("Hero.HeroManager")
local StageHeroItemView = require("Stage.StageHeroItemView")
local TroopView = require("World.TroopView")

function This:initNode(info)
	self.m_troops = info.troops or {}
	super.initNode(self,info)
end

function This:getHeroView(troop)
	local troop = self.m_troops[troop:getHeroId()]
	local view = TroopView:create({troop = troop,showLegion = false})
	return view
end

function This:getHeroList()
	local result = {}
	local troopList = {}
	for i , troop in pairs(self.m_troops) do
		if not self.m_haveSelectHeros[troop:getHeroId()] then
			table.insert(troopList,troop)
		end
	end
	table.sort(troopList,function(a,b)
		local ah = HeroManager:getHero(a:getHeroId())
		local bh = HeroManager:getHero(b:getHeroId())
		if ah:getQuality() > bh:getQuality() then
			return true
		elseif ah:getQuality() == bh:getQuality() and ah:getFightPower() > bh:getFightPower() then
			return true
		elseif ah:getQuality() == bh:getQuality() and ah:getFightPower() == bh:getFightPower() and ah:getId() < bh:getId() then
			return true
		end
		return false
	end)
	--[[for i , troop in ipairs(troopList) do
		local hero = HeroManager:getHero(troop:getHeroId())
		table.insert(result,hero)
	end]]
	return troopList
end

--endregion
