-- @Author: superm
-- @Date:   2018-07-26 19:48:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-05 09:25:51
-- @File Name: WorldBossEmbattlePanel.lua
-- @Description: 

local This , super = class(...,"Family.BossEmbattlePanel")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")

function This:initItems()
	-- super.initItems(self)	
end

function This:initBaseInfo()
	self.m_csNode.bg3.tagettext:setString(Serialize[64972])
	self.m_csNode.bg3.taget:setString(self.m_stage:getName())
	self.m_csNode.bg3.name:setString(GamePlayer:getRoleName())
	self.m_csNode.bg3.totalhp:setString("0")
	self.m_csNode.bg3.consume:setString(Serialize[60509])
	self.m_csNode.bg3.cost:setString(self.m_stage:getCurHp())
	self.m_csNode.text100:setVisible(false)
	self.m_csNode.time:setVisible(false)
	self.m_csNode.diban2:setVisible(false)
end

function This:onCloseBtnClick()
	if self.m_battleHandler then
		self.m_battleHandler()
	end
	self:close()
end

function This:getAllHeroList()
	self.m_haveSelectHeros = {}
	-- for i , info in pairs(self.m_heros) do
	-- 	self.m_haveSelectHeros[info.heroId] = true
	-- end
	local heroList = self.m_stage:getCanEmbattleHeroList()
	local result = {}
	for i , hero in ipairs(heroList) do
		if not self.m_haveSelectHeros[hero:getId()] and not hero:isDeputy() then
			table.insert(result,hero)
		end 
	end

	table.sort(result,function(a,b)
		return a:getFightPower() > b:getFightPower()
	end)
	return result
end