-- @Author: superm
-- @Date:   2018-08-01 10:44:54
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-09 15:34:46
-- @File Name: WorldBossOverPanel.lua
-- @Description: 

local This, super = class(...,"FamilyBoss.FamilyBossOverPanel")
local PopDialogManager = require("UI.PopDialogManager")
local WorldMonsterManager = require("WorldBoss.WorldMonsterManager")

function This:onTouchMask()
	local bossList = WorldMonsterManager:getBossesList()
	local bossCount = #bossList
	if bossCount > 0 then
		PopDialogManager:addPopDialog({scene = "MenuScene", name = "WorldBoss.WorldBossPanel", arg = nil, level = DialogLevel.kForLevel})
	end
	cc.SceneManager:switchTo("Home.MenuScene")
end
