local This, super = class(..., "cc.RenderTexture")
cc.DynamicScreenshot = This

function This:onEnter()
    super.onEnter(self)
    lib2d.ccNode.scheduleUpdate(self[0], 10)
end

function This:update(delta)
    g_scene:setChildrenVisible(true)
    self:setVisible(false)

    self:beginRender()
    g_scene:visit()
    self:endRender()
    g_scene:setChildrenVisible(false)
    self:setVisible(true)
end

function This:stopRender()
    lib2d.ccNode.unscheduleUpdate(self[0])
end