local This = class(...)

function This:onDown()
end

function This:onUp()
end

function This:onMove()
    
end

function This:onScroll()
end

local lastMouseX = nil
local lastMouseY = nil
lib2d.ccMouseListener.setCallback(function (this, eventType, x, y, scrollX, scrollY, buttonID)
    local self = cc.objectRegistry[this]
    self.x = x
    self.y = y
    self.scrollX = scrollX
    self.scrollY = scrollY
    self.buttonID = buttonID
    if lastMouseX == nil then
        lastMouseX = x
    end
    if lastMouseY == nil then
        lastMouseY = y
    end
    self.deltaX = x - lastMouseX
    self.deltaY = y - lastMouseY
    lastMouseX = x
    lastMouseY = y
    self[eventType](self)
end)

function This:create(touch)
    local listener = lib2d.ccMouseListener.create()
    return cc.registerObject(listener, self, touch)
end