-- @Author: zheng
-- @Date:   2019-05-14 16:12:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-02 11:15:05
-- @File Name: GiftDayAchieve.lua

local This , super = class(...,"Achieve.MainAchieve")
local DayGiftConfig = require("Metadatas.DayGiftConfig")

function This:init(info)
    self.m_id = info.id                         -- 配置表主键，前后端通信使用
    self.m_index = info.index
    self.m_config = DayGiftConfig[self.m_id]
    self.m_progress = info.num or 0
    self.m_state = info.state or 0
    self.m_type = info.type or 0
end

function This:getPrice()
    return self.m_config.recharge_price
end

function This:getYuanBaoNum()--购买即可获得XX元宝
    return self.m_config.yuanbao
end

function This:getGiftNum()--价值XX元礼包
    return self.m_config.num
end

function This:getRewardList()
   return self.m_config.reward 
end

function This:getBuyId()
   return self.m_config.key1  
end

function This:getNextId()
   return self.m_config.next_id
end

function This:getPreviousId()
    return self.m_id -1
end

function This:getOpenLv()
  return self.m_config.level or 1
end
