-- @Author: superm
-- @Date:   2017-11-28 16:01:39
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-02-27 14:55:41
-- @File Name: LimitedTimePreferentialAchieve.lua
-- @Description: 

local This , super = class(...,"Base.BaseModel")
local PushGiftConfig = require("Metadatas.PushGiftConfig")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	self.m_id = info.id
	self.m_config = PushGiftConfig[self.m_id]
	-- self.m_progress = info.num or 0
	 self.m_state = info.state or 0
	self.m_type = info.type or 0
	-- self.m_startTime = -1
end

function This:getId()
	return self.m_id
end

function This:getDuration()
	return self.m_config.time
end

function This:getPrice()
	return self.m_config.recharge_price
end

function This:getBuyId()
	return self.m_config.key1
end

function This:getYuanBaoNum()
	return self.m_config.yuanbao_price
end

function This:getRewardList()
	return self.m_config.reward
end

function This:getImageName()
	return self.m_config.picture
end

function This:getNextAchiveId()
	local nextId = self.m_config.next_id 
	return nextId,nextId~=0
end

function This:getType()
	return self.m_type
end

function This:getState()
	return self.m_state
end

function This:setState(state)
	self.m_state = state
end

function This:updateInfo(info)
	self.m_state = info.state
	self.m_progress = info.num or 0
end
