-- @Author: Su
-- @Date:   2019-1-31 11:01:39
-- @Last Modified by:   Su
-- @Last Modified time: 2019-1-31 11:01:39
-- @File Name: ZhengJiAchieve.lua
-- @Description: 

local This , super = class(...,"Achieve.TianXiaAchieve")
local BoxMissionConfig = require("Metadatas.BoxMissionConfig")

local AchieveManager = require("Achieve.AchieveManager")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
    self.m_id = info.id
    self.m_config = BoxMissionConfig[self.m_id]
    self.m_progress = info.num or 0
	self.m_state = info.state or 0
    self.m_type = info.type or 0
    self.m_quality = self.m_config.quality
end

function This:getConfig()
    return self.m_config
end

function This:getQuality()
    return self.m_quality
end

function This:hasGuider()
    if self.m_config.guide_data and self.m_config.guide_data ~= "" then
    	return true
    end

    if self.m_config.panel and self.m_config.panel ~= "" then
    	return true
    end
    return false
end