-- @Author: superm
-- @Date:   2019-03-03 00:07:32
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:12:56
-- @File Name: ActivityRankModel.lua
-- @Description: 冲冠活动的排名

local This, super = class(..., "Activity.ActivityBaseModel")

function This:getCondition()
    return 
end

function This:getDesc()
    if not os.isWin32 then
    	local minIndex, maxIndex = self.m_config.mix_ranking, self.m_config.max_ranking
    	if minIndex ~= maxIndex then
        	return string.format(Serialize[60232], minIndex, maxIndex)
        else
        	return string.format(Serialize[60233], minIndex)
        end
    else
    	local minIndex, maxIndex = self.m_config.mix_ranking, self.m_config.max_ranking
    	if minIndex ~= maxIndex then
        	return string.format(Serialize[60234], self:getId(), minIndex, maxIndex)
        else
        	return string.format(Serialize[60235], self:getId(), minIndex)
        end
    end
end