

local This , super = class(...,"NodeUI")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/kingWayArrayValueItem.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.bg:getContentSize()
    self.m_csNode:setPosition(w/2, h/2)
    self:setContentSize(w, h)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    csNode.text:setStringWithColor(data)
end