-- @Author: zheng
-- @Date:   2018-07-21 15:38:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-08-04 15:04:32
-- @File Name: AwakeInfoPanel.lua
-- 三个阶段懂完成获得的属性加成

local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/WakeInfo.csb"
local AwakeInfoItemView = require("Awake.AwakeInfoItemView")

function This:initNode(info)
	self.m_heroId = info.heroId
	self.m_showAwake = info.showAwake
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    	
    self:refreshMemeberList()
end

function This:initTouchEvent()
   
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)    
end

function This:refreshMemeberList()
	for i=1,3 do
		local info = {heroId = self.m_heroId,paragraph = i,showAwake= self.m_showAwake}
		local node = self.m_csNode["juexing"..i]
		local view = self:createItemView(info)
		node:addChild(view)
	end
end

function This:createItemView(info)
	local node = AwakeInfoItemView:create(info)
	return node
end

