-- @Author: zheng
-- @Date:   2018-12-25 21:49:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-27 20:16:57
-- @File Name: GameArmsCost.lua

local This = class(...)
-- local GamePlayer = require("Player.GamePlayer")
-- local GameUtil = require("Util.GameUtil")

local ArmPackageConfig = require("Metadatas.ArmPackageConfig")

-- local SingleManager = require("SingleDaily.SingleManager")

function This:create(id)
    local o = {}
    setmetatable(o,This)
    o:init(id)
    -- self:updateInfor()
    return o
end

function This:init(id,info)
    -- self.m_id = id
    self.m_config = ArmPackageConfig[id]
    -- if info then
    --     self:updateInfor(info)
    -- end
end

function This:getId()
    return self.m_config.solt
end

function This:getItemId()--道具ID
    return self.m_config.item_id
end

function This:getItemNum()
    return self.m_config.item_num
end

function This:getLv()
    return self.m_config.level
end

function This:getCostId()--消耗道具Id
    return self.m_config.cost_id
end

function This:getCostMoney(num)--价格
    if not num then
        num = self:getBuyCount()
        num  = num + 1
    end
    local price = self.m_config.price
    local result = price[num]
    if not result then
        return price[#price]
    end
    return result
end

-- function This:getDiscount(num)--折扣
--     if not num then
--         num = self:getBuyCount()
--         num  = num + 1
--     end
--     local discount = self.m_config.discount
--     local result = discount[num]
--     if not result then
--         return discount[#discount]
--     end
--     return result
-- end

-- 设置购买次数
function This:setBuyCount(buyCount)
    self.m_buyCount = buyCount
end

function This:getBuyCount()
    return self.m_buyCount or 0
end

function This:setDiscount(discount)
    self.m_discount = discount
end

function This:getDiscount()
    return self.m_discount or 10
end
