-- @Author: zheng
-- @Date:   2019-06-26 15:19:12
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-23 18:15:41
-- @File Name: LordEquipMasterPanel.lua

local LordEquipManager = require("Awake.LordEquipManager")
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")
-- local AchieveManager = require("Achieve.AchieveManager")
local LordEquipMasterStrengthenTab = require("Awake.LordEquipMasterStrengthenTab")
local LordEquipMasterInscriptionTab = require("Awake.LordEquipMasterInscriptionTab")
-- This.fileName = "MenuScene/NodeUI/LordEquipMaster.csb"
function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LordEquipMaster.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    -- for tabKey = 1, LordEquipMasterPanelTabName.kCount do
    --     local item = csNode["tep"..tabKey]
    --     self:addTabButton(tabKey, item, function()
    --         self:openTabNode(tabKey)
    --         self:lightTabButton(tabKey)
    --         self.m_selectIndex = tabKey
    --     end)
    -- end
    -- self.m_selectIndex = LordEquipMasterPanelTabName.kStrengthen
    -- self:selectTabButton(self.m_selectIndex)
    local node = self:createTabNode(LordEquipMasterPanelTabName.kStrengthen)
    local parent = self.m_tabNodeParent or self.m_csNode or self
    parent:addChild(node)

    self:refreshDot()
end


function This:refreshDot()
    local tabNode = self.m_csNode
--    local tabNames = self:getTabList()
    for tabKey = 1, LordEquipMasterPanelTabName.kCount do
        local item1 = tabNode["tep"..tabKey]
        local isHaveRed = self:isHaveRed(tabKey)
        if item1 then
            GameUtil:refreshRedDot(item1, isHaveRed)
        end
    end
end

function This:isHaveRed(tabType)
    return false
end


function This:createTabNode(name)
    -- print(name)
    if LordEquipMasterPanelTabName.kStrengthen == name then
        return LordEquipMasterStrengthenTab:create({tabType = name})
    elseif LordEquipMasterPanelTabName.kInscription == name then
        return LordEquipMasterInscriptionTab:create({tabType = name})
    end
end


function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

-- function This:onEnter()
--     super.onEnter(self)
--     AchieveManager:addObserver(self)
-- end

-- function This:onExit()
--     super.onExit(self)
--     AchieveManager:removeObserver(self)
-- end
