-- @Author: zheng
-- @Date:   2019-07-02 10:59:19
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-10 10:20:02
-- @File Name: LordInscriptionTab.lua
local LordEquipManager = require("Awake.LordEquipManager")
local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/LordEquipInscription.csb"
function This:initNode(info)
    
	local fileName = "MenuScene/NodeUI/LordEquipAll.csb"
	self.m_rightNode = cc.Node:createFromCSFile(fileName)

    -- self.m_rightNode:setPositionX(-300)


    self:addChild(self.m_rightNode)
    self:initUpdateLayer()

    self:getData()
    
    -- self:refresh()
end

function This:getData()
end

function This:initUpdateLayer()
    local scrollView = self.m_rightNode.scrollView
    local scrollView2 = self.m_rightNode.scrollView2
       if scrollView then
        scrollView:setDirection("vertical")
         self.m_listLayer = UpdateLayer:create({
            itemWidth = 92,
            itemHeight = 80,
            spaceX = 8,
            spaceY = 0,
            column = 4,
            scrollView = scrollView,
            dataCounter = function ()
                return #self.m_configlist
            end,
         viewCreator =  function(index, node)
                local item = self.m_configlist[index]
                if item then
                    if not node then
                        return self:getScroolItem(item,index)
                    else
                        node:setModel(item, index)
                    end
                end
            end,
--            hint = self.m_selectIndex,
        })
        
        self.m_listLayer:setCascadeOpacityEnabled(true)
        self.m_listLayer:setAnchorPoint(0, 0)
        local w , h = self.m_listLayer:getContentSize()
        scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    end 

end
