--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = BaseClass(..., "Bag.BaseItemModel")
local HeroUtil = require("Hero.HeroUtil")
local ItemUtil = require("Bag.ItemUtil")

function This:__init(data, eq)
    self.equip = eq or {}
end

function This:isEquip()
    return true
end

function This:isFabao()
	return false
end

function This:getStrengthLv()
    return self.equip:getStrengthLv()
end

function This:getLevel()
	return self.equip:getLevel()
end

function This:getAddAttr()
    return self.equip:getAddAttr()
end

function This:canUsed(showWarming)
	if not self:canUsedForStrength(showWarming) then
		return false
	end
	if not self:canUsedForAscend(showWarming) then
		return false
	end

    return true
end

function This:canUsedForStrength(showWarming)
	local ret = self:getStrengthLv() < kMaxStrengthLv
	if not ret and showWarming then
		g_scene:showTips(Serialize["bag_EquipItem_1"])
	end
    return ret
end

function This:canUsedForAscend(showWarming)
	local ret = self:getQuality() < kMaxQuality
	if not ret and showWarming then
		g_scene:showTips(Serialize["bag_EquipItem_2"])
	end
    return ret
end

function This:setEquipId( id )
	if self:getId() == id then
		return 
	end

    if id and id > 0 and ItemUtil.getType(id) == ItemCommonType.kEquip then
    	self:resetId(id)
    end
end

function This:isEquipped()
    return self.equip:getHeroId() > 0
end

function This:canReborn()
    return self.equip:canReborn()
end

function This:getRebornReturn(exp)
    return self.equip:getRebornReturn(exp)
end

--endregion
