-- RuneItemModel.lua
local This, super = BaseClass(..., "Bag.PlanItemModel")
local InscriptionConfig = require("Metadatas.InscriptionConfig")
-- local GameUtil = require("Util.GameUtil")
-- local ItemUtil = require("Bag.ItemUtil")
-- local AttributeLibraryConfig = require("Metadatas.AttributeLibraryConfig")


function This:getInscriptionConfig()
    if not self.m_inscriptionConfig then
        local id = self:getId()
        for i,config1 in pairs(InscriptionConfig) do
            if id == config1.inscription_item then
                self.m_inscriptionConfig = config1
                break
            end
        end
    end
    return self.m_inscriptionConfig
end


function This:Clear()
    super.Clear(self)
    self.m_inscriptionConfig = nil
end

function This:isInscription()
    return true
end


function This:getSolt()
    return self:getInscriptionConfig().solt
end

function This:isEquipped()
    return self.equip_card_id>0
end