--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local HeroUtil = require("Hero.HeroUtil")

kWallSoilderIndex = 7
kSweepMaxTimesOnce = 10

kWallSoilderCount = 6
WallSoilderPosition = 
{
	[4]={x = -35,y = 140},
	[5]={x = 5,y = 100},
	[6]={x = 45,y = 60},
	[1]={x = 85,y = 20},
	[2]={x = 125,y = -20},
	[3]={x = 165,y = -60},
}

TroopsFormate =   --队形
{
	ROW = 2,
	COLUMN = 3
}

SkillState = 
{
	ACTIVE = 1,
	STOP = 2
}

BattleResult = 
{
	kAttackerVictory = 1,
	kDefenderVictory = 2,
	kDogfall = 3,
	kPerishTogether = 4,
}

BattleType = 
{
	kBattleSituation = 1, --战局
	kBattleStage = 2, --副本
	kBattleFriend = 3, --好友切磋
}

ActionResult =
{
	kTakeEffect = 0, --生效
	kFailCommonAttack = 1, --无法普通攻击
	kFailSkillAttack = 2, --无法技能攻击
	kNoTarget = 3, --没有目标
	kTargetWuDi = 4, --目标处于无敌状态
	kBuffDisappear = 5, --消失
}

EffectType = 
{
	kCommonAttack = 1, --普攻伤害
	kCrit = 2, --暴击  （行为）
	kDodge = 3, --闪避 （行为）
	kPhyAttack = 4, --物理攻击
	kMagAttack = 5, --计策攻击
	
	kPhyTreat = 6, --物理攻击治疗
	kMagTreat = 7, --计策攻击治疗
	kRemoveDebuff = 8, --净化
	kRemoveBuff = 9, --驱散
	kRecoverAnger = 10, --回复怒气
	kReduceAnger = 11, --减少怒气
	kSelfMaxHpDamage = 12, --自身最大生命伤害
	kAddBuff = 18, --没有伤害（施加BUFF）
	kEffectAttackAddAnger = 19, --回复怒气效果  （行为）
	kEffectSkillDelAnger = 20, --减少怒气效果 （行为）
	kSpiritChain = 28, --灵魂锁链(分摊)
	kTieSuoLianHuan = 42 , --铁索连环
	kReboundDamage  = 51, --反弹（行为）
	kFightBack = 52, --反击（行为）
	kPenetrate = 53, --识破（行为）
	kPhyDamage = 54, --物理伤害
	kMagDamage = 55, --计策伤害
	kJiNengXiXue = 56, --技能吸血
	kPuGongXiXue = 58, --普攻吸血
	kLianJi = 62, --连击
	kFuHuo = 63, --复活
	kFengLiao = 64, --封疗

	kigPythical = 65, --忽视物理技能
	kignPocxy = 66, --忽视计策防御
	kpythiccalDamage = 67, --物理技能伤害乘以倍率
	kpocxyDamage = 68, --计策技能伤害乘以倍率
	kPyhicDamage = 69, --物理技能伤害加固定值
	kpocxyDamageA = 70, --计策技能伤害加固定值
	kpocxyLiao = 71, --计策治疗乘以倍率
	kpocxyLiaoA = 72, --计策治疗加固定值
	kMonsterDamage = 73, --神兽伤害
	kMonsterLiao = 74, --神兽治疗


}

PlayMode = 
{
	kStage = 1, --关卡 
	kWorld = 2, --世界地图 2
	kReport = 3, --战报
	kArena = 4, --竞技场
	kFamilyBoss = 5, --军团boss 2
	kWorldBoss = 6, --世界boss 2
	kWarfare = 7, --战役 2
	kWarSingle = 8, --单人挑战
	kWarSingleMultiQueue = 9, --单人挑战(多队列)
	kRescu = 10,--勤王战
	kCrossServBoss = 11, --跨服boss
}

BattlePlayAccelerate = 
{
	[PlayMode.kStage] = true, --关卡 
	[PlayMode.kReport] = true, --战报，有跳过，有加速
	[PlayMode.kArena] = true, --竞技场
	[PlayMode.kWarSingle] = true, --单人挑战
	[PlayMode.kWarSingleMultiQueue] = true, --单人挑战(多队列)
	[PlayMode.kRescu] = false,--勤王战,只有跳过
	[PlayMode.kCrossServBoss] = true,
	[PlayMode.kFamilyBoss] = true,
}

BattlePlaySkip = {
	[PlayMode.kReport] = true,
	[PlayMode.kStage] = true,
	[PlayMode.kWarSingle] = true,
	[PlayMode.kRescu] = true,
	[PlayMode.kCrossServBoss] = true,
	[PlayMode.kFamilyBoss] = true,
}

BattlePlayMultiReport = {
	[PlayMode.kWorld] = true,
	[PlayMode.kWarfare] = true,
	[PlayMode.kWarSingleMultiQueue] = true,
	[PlayMode.kCrossServBoss] = true,
}

SoilderAttackSound =
{
	[SoilderType.kArcher] = "Atk_Gong.mp3",
	[SoilderType.kCavalry] = "Atk_Qi.mp3",
	[SoilderType.kSapperCar] = "Atk_Tou.mp3",
	[SoilderType.kShield] = "Atk_Bu.mp3",
}

SoilderKeZhi = 
{
	[SoilderType.kShield] = SoilderType.kArcher,
	[SoilderType.kCavalry] = SoilderType.kShield,
	[SoilderType.kArcher] = SoilderType.kCavalry,
	[SoilderType.kSapperCar] = SoilderType.kSapperCar,
}

kSkillShowTime = 1.5  --技能展示
kCommonAttackTime = 1 --普通攻击 （去的时间，返回的时间个一半）
kGongBingComAttackTime = 0.8  --弓兵攻击时间
kCheBingComAttackTime = 0.7 --车兵的攻击时间
kWallSoilderComAttackTime = 0.5 --城墙的攻击时间
kSkillActiveTime = 0.5
--endregion
