-- @Author: Su
-- @Date:   2019-06-29 15:20:32
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-29 15:20:32
-- @File Name: PrincipalBossRankItem.lua
-- @Desc: BOSS

local This , super = class(...,"NodeUI")


function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingBossHurtItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode
    -- self:setToCenter()

    self.m_data = data
    self:refresh()
end

function This:getSize()
    local w, h = self.m_csNode.paimingbg:getContentSize()
    return w,h
end

function This:refresh()
    local node = self.m_csNode
    node.me.level02:setString(self.m_data.rank)
    node.me.name:setString(self.m_data.role_name)
    node.me.hurt:setString(self.m_data.value)
    node.me.level:setString(string.format("Lv%d",self.m_data.level))
end