--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")

function This:init()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WorldChatVioceState.csb")
	self:addChild(self.m_csNode)
	self.m_state = VoiceState.kNone
end

function This:setState(state)
	if self.m_state ~= state then
		self.m_state = state
		if self.m_state == VoiceState.kRecording then
			self:showRecordVoiceState()
		elseif self.m_state == VoiceState.kCancel then
			self:showCannelRecordState()
		end
	end
end

function This:showRecordVoiceState()
	self.m_csNode.cancelicon:setVisible(false)
	self.m_csNode.huatong2:setVisible(true)
	self.m_csNode.huatong1:setVisible(true)
	self.m_csNode.quxiaofasong:setString(Serialize["chat_VoiceState_1"])
	self.m_csNode:runAction(cc.RepeatForever(cc.Sequence(
		cc.CallFunc(function()
			self.m_csNode.huatong1:setPercent(0,true)
			self.m_csNode.huatong1:runPercentAction(100,50,true)
		end),
		cc.DelayTime(2.5)
	)))
end

function This:showCannelRecordState()
	self.m_csNode.cancelicon:setVisible(true)
	self.m_csNode.huatong1:setVisible(false)
	self.m_csNode.huatong2:setVisible(false)
	self.m_csNode.quxiaofasong:setString(Serialize["chat_VoiceState_2"])
	self.m_csNode:stopAllActions()
	self.m_state = VoiceState.kCancel
end


--endregion
