-- @Author: Su
-- @Date:   2019-08-24 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-08-24 15:17:05
-- @File Name: CompetitionBattleInfoPanel.lua
-- @Description:
--g_scene:openDialog("PeakContest.PeakContestBattleInfoPanel",self.m_report.report_list)
local This, super = class(...,"Dialog")
local CompetitionBattleInfoItem = require("Competition.CompetitionBattleInfoItem")

function This:initNode(data)
	self.data = data.reportList
	self.m_type = data.type
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionBattleInfo.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_itemList = {}
	self:refresh()
	--self:initTouchEvent()
end

function This:refresh()
	local height = 180
	-- self.m_csNode.ScrollView:removeAllItems()
	for i , v in ipairs(self.data) do 
		local item = self.m_itemList[i]
		if not item then
			item = CompetitionBattleInfoItem:create(v,i,self.m_type)
			-- item:setPosition(0, height * (1 - i))
			self.m_csNode.ScrollView:pushBackCustomItem(item,934,180,0.5)
		else
			item:setData(v,i)
		end
		self.m_itemList[i] = item
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onTouchMask()

end