-- @Author: Su
-- @Date:   2019-08-13 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-08-13 15:17:05
-- @File Name: CompetitionNamelistPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local CompetitionManager = require("Competition.CompetitionManager")
local CompetitionNamelistItem = require("Competition.CompetitionNamelistItem")

function This:initNode()
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionNamelist.csb")
    self.m_csNode = csNode
    self:addChild(csNode)
    csNode:setToCenter()
    self:refresh()
end

function This:refresh()
    -- local rankList = CompetitionManager:getRankList()
    local rankList = {{name=Serialize[60649]},{name = Serialize[60650]}}
    local scrollView = self.m_csNode.ScrollView
    scrollView:removeAllItems()
    for _,rankInfo in pairs(rankList) do
        local item = CompetitionNamelistItem:create(rankInfo)
        local w,h = item:getSize()
        scrollView:pushNode(item,100,20,6)
    end

end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
    end)

end