-- @Author: Su
-- @Date:   2019-09-04 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-09-04 15:17:05
-- @File Name: CompetitionServerBtn.lua
-- @Description: 

local This, super = class(..., "Home.MenuButton")
local CompetitionManager = require("Competition.CompetitionManager")
local GamePlayer = require("Player.GamePlayer")

function This:init(config)
    super.init(self, config)
    self.m_isOpen = true
end

function This:initTouchEvent()
    self:setTouch({
		onEnded = function()
	        g_scene:openDialog("Competition.CompetitionMainPanel", {type = 2}) 
		end,
		isScale = false
	})
end

function This:addCustomListener()
    super.addCustomListener(self)
    CompetitionManager:addObserver(self)
end

function This:removeCustomListener()
	CompetitionManager:removeObserver(self)
    super.removeCustomListener(self)
end

function This:getDefaultVisible()
    return CompetitionManager:isOpen(2)
end