-- @Author: Su
-- @Date:   2019-09-16 11:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-09-16 11:30:53
-- @File Name: CrossServerBossListItem.lua
-- @Description: 

local This , super = class(...,"NodeUI")
This.fileName = "MenuScene/NodeUI/CrossServerBossList.csb"


function This:initNode(info)
    self.m_data = info
    self:refresh()
end

function This:refresh()
    -- self.top:setImage()
    self.top:setVisible(self.m_data.rank < 4)
    self.rank:setVisible(self.m_data.rank >= 4 )
    if self.m_data.rank <= 3 then
        self.top:setImage(string.format("MenuScene/top%d.png",self.m_data.rank))
    end
    self.rank:setString(self.m_data.rank)
    self.name:setString(self.m_data.role_name)
    self.hurt:setString(self.m_data.damege)
    self.qufu:setString(self.m_data.server_name)
end

function This:refreshData(info)
    self.m_data = info
    self:refresh()
end

function This:getSize()
    local w,h = self.xuanzhong:getContentSize()
    return w,h
end