-- @Author: superm
-- @Date:   2018-05-21 17:44:56
-- @Last Modified by:   superm
-- @Last Modified time: 2018-05-22 10:38:58
-- @File Name: DepotBoxEffect.lua
-- @Description: 

local This , super = class(...,"Dialog")
local MenuBtnHelper = require("Home.MenuBtnHelper")

This.maskOpacity = 0

function This:init( info )
    super.init(self, info)
	if info then
		self.m_maxLev = info.level or 0
	end
end

function This:onEnter()
	super.onEnter(self)
	if g_scene:getName() == "MenuScene" then
		if self.m_maxLev <= 0 then
			self:runAction(cc.Sequence(cc.DelayTime(0.5),cc.CallFunc(function()
				self:close()
			end)))
			return
		end

		local btn = MenuBtnHelper:getButtonByName("prop")
		if btn then
			btn:playAnimation2({name="MenuScene/boxLock" .. self.m_maxLev .. ".png"} , 0.5, function()
			    self:close()
	        end)
	    end
	end
end