-- @Author: Su
-- @Date:   2019-11-28 9:50:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-28 9:50:53
-- @File Name: BattleDrumRankColumnItem.lua
-- @Description: 
local This , super = class(...,"NodeUI")
local GamePlayer = require("Player.GamePlayer")
This.fileName = "MenuScene/NodeUI/BattleDrumRankColumn.csb"

function This:initNode(info)
    self.m_data = info
    self:refresh()
end

function This:refresh()
    -- -- self.outrank:setVisible(not self.m_data.rank)
    -- self.inrank:setVisible(self.m_data.rank)

    -- -- self.outrank.userid:setString(GamePlayer:getRoleName())
    -- if not self.m_data.rank then
    --     return
    -- end
    self.ranknum:setString(self.m_data.rank)
    if not self.m_data.name then
        self.userid:setString(Serialize[60736])

    else
        self.userid:setString(self.m_data.name)
    end

end

function This:initTouchEvent()
    self.reward:setTouch({
        isScale = false, 
        isDynamic = true, 
        isContainer  = true,
        onEnded = function()
            --
            g_scene:openDialog("Drum.BattleDrumRankRewardPanel",{rank = self.m_data.rank})
            
        end
    })


end

function This:updateInfo(info)
    self.m_data = info
    self:refresh()
end

function This:getSize()
    local w,h = self.kuang:getContentSize()
    return w,h
end