-- @Author: Su
-- @Date:   2019-11-27 10:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-27 10:30:53
-- @File Name: DrumAttributeTxt.lua
-- @Description: 

local This , super = class(...,"NodeView")

function This:initData(info)
    -- self.m_parent = node
    self.m_text = info.text
    self.m_num = info.num
    self.m_isGreen = info.isGreen
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BattleDrumText.csb")
    self:addChild(csNode)
    self.m_csNode = csNode
    self:refresh()
end

-- function This:getSize()
--     local w,h = self.Image_1:getContentSize()
--     return w,h
-- end

function This:refresh()
    self.m_csNode.num:setAnchorPoint(0, 0.5)
    if self.m_isGreen then
        self.m_csNode.tx:setStringWithColor("<New17>"..self.m_text)
        self.m_csNode.num:setStringWithColor("<New17>"..self.m_num)
    else
        self.m_csNode.tx:setStringWithColor("<New5>"..self.m_text)
        self.m_csNode.num:setStringWithColor("<New5>"..self.m_num)
    end
end

function This:refreshData(info)
    self.m_text = info.text
    self.m_num = info.num
    self.m_isGreen = info.isGreen
    self:refresh()
end
