-- @Author: ZYY
-- @Date:   2018-08-24 18:11:15
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-01 14:59:22
-- @File Name: EquipClearMasterInfoPanel.lua
-- @Desc: 洗炼大师
local This, super = class(...,"Dialog")
local AffinationMasterConfig = require("Metadatas.AffinationMasterConfig")
local EquipClearMasterValueListView = require("Equip.EquipClearMasterValueListView")
function This:initNode(info)
	self.m_level = info.level
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/EquipClearMasterInfo.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.itemList = {}
	self:refresh()
end

function This:refresh()
	local width ,height = 675,30
	for i , v in ipairs(AffinationMasterConfig) do 
		local item = self.itemList[i]
		if not item then 
			item = EquipClearMasterValueListView:create(v,self.m_level)
			item:setAnchorPoint(0.5,0.5)
			self.m_csNode.ScrollView:pushBackCustomItem(item,width,height,0)			
		else
			item:setData(v,self.m_level)
		end
		self.itemList[i] = item
	end
end

function This:initTouchEvent()
	self.m_csNode.closebutton:setTouchEnded(function()
		self:close()
	end)
end

function This:onTouchMask()

end
