-- @Author: ZYY
-- @Date:   2018-08-25 15:28:28
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-01 14:59:42
-- @File Name: EquipClearMasterValueListView.lua
-- @Desc: 洗炼大师Item
local This , super = class(...,"NodeUI")
local StarColorConfig = require("Metadatas.StarColorConfig")

This.fileName = "GameScene/NodeUI/EquipClearMasterValueList.csb"

function This:initNode(data,level)
	self:setData(data,level)
end

function This:refresh()
	self.level:setString(self.m_level)
	self.exp:setString(self.m_exp)
	self.min:setString(self.m_minStar)
	self.max:setString(self.m_maxStar)
    self.minStar:setImage(string.format("Common/star%d.png",self.m_minQuality + 1)) 
    self.maxStar:setImage(string.format("Common/star%d.png",self.m_maxQuality + 1)) 	
    self.xuanzhong:setVisible(self.m_level == self.m_masterLevel)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()

end

function This:setData(data,level)
	self.m_masterLevel = level
	self.m_level = data.level
	self.m_exp = data.exp
	self.m_minStar = data.min_star
	self.m_maxStar = data.max_star
	self.m_minQuality = StarColorConfig[self.m_minStar].star_color
    self.m_maxQuality = StarColorConfig[self.m_maxStar].star_color
	self:refresh()
end