-- @Author: ZYY
-- @Date:   2018-10-09 11:07:28
-- @Last Modified by:   superm
-- @Last Modified time: 2019-10-11 16:36:07
-- @File Name: FamilyPlanItemNode.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")

This.fileName = "MenuScene/NodeUI/FamilyPlanItem.csb"

function This:initNode(...)
	self:setData(...)
end

function This:refresh()
	local maxTime = self.m_junce:getUseMaxTime()
	if maxTime <= 0 then
		maxTime = nil
	end
	self.m_itemNode = ItemNode:create(self.m_tricksId, maxTime)
	self.m_itemNode:setScale(0.7)
	self.m_itemNode:setAnchorPoint(0.5,0.5)
	-- self.m_itemNode:setTouchEnable(false)
	self.bg:setAnchorPoint(0,0.5)
	self.bg.icon:addChild(self.m_itemNode)
	self.bg.name:setString(self.m_junce:getName())
    self.bg.num:setString(string.format(Serialize[60983],self.m_junce:getCost()))
end

-- function This:onEnter()
-- 	super.onEnter(self)
-- 	self.m_junce:addObserver(self)
-- end

-- function This:onExit()
-- 	self.m_junce:removeObserver(self)
-- 	super.onExit(self)
-- end

function This:setData(junce)
	if self.m_junce ~= junce then
		-- if self.m_junce then
		-- 	self:removeObserver(self)
		-- 	if junce then
		-- 		self:addObserver(self)
		-- 	end
		-- end
		self.m_junce = junce
	end
	self.m_tricksId = junce:getId()
	self:refresh()
end