
local This , super = class(...,"Stage.StageLoadingScene")
local GameEvent = require("Event.GameEvent")
local BattleDataManager = require("Battle.BattleDataManager")
local FamilyBossManager = require("FamilyBoss.FamilyBossManager")


function This:init(info)
	super.init(self,info)
	self:initTask()
end

function This:addBattlePrepareTask()
	local task10 = GameEvent:create(function()
		local chapter = FamilyBossManager:getChapter()
		local bgId = chapter:getConfigVal("bgId", 2)
		BattleDataManager:prepareBattle(true,PlayMode.kFamilyBoss,bgId)
	end)
	self:addTask(task10)
end
