local This,super = class(...,"Dialog")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")

local fileName = "LegionScene/NodeUI/LegionAdvancedTaskProblem.csb"

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(fileName)
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self.m_text = info.text
    self.m_id = info.id
    self:refresh()
end

function This:refresh()
    local m_text = string.format(Serialize["family_Warlord_2"],self.m_text)
    self.m_csNode.cishu.text:setString(m_text)
end

function This:initTouchEvent()
    self.m_csNode.Button1:setTouchEnded(function()
        self:close()
    end)
    self.m_csNode.Button2:setTouchEnded(function()
        FamilyRatingManager:onSetCastRequest(self.m_id)
        self:close()
    end)
end