--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local EventDispatcher = require("EventDispatcher")
local GuideAncView = require("Guide.GuideAncView")

local FgSG = 
{
	kEmbattleOneKey = 1, --一键布阵
	kTotoFight = 2, --出征
	kFinishGuide = 3,
}

local NodePath = 
{
	[FgSG.kEmbattleOneKey] = "WorldScene.TroopEmbattlePanel.m_csNode.automaticbutton",
	[FgSG.kTotoFight] = "WorldScene.TroopEmbattlePanel.m_csNode.Battlebutton"
}

function This:init(info)
	self.m_events = {"dialog_open","dialog_close"}
	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:addUpdateHandler(function()
		if self.m_state == FgSG.kEmbattleOneKey then
			local panel = g_scene:getTopDialog()
			if panel and panel:getName() == "TroopEmbattlePanel" then
				local heros = panel.m_heros
				for i , info in pairs(heros) do
					if info.heroId then
						self.m_state = FgSG.kTotoFight
						self:update()
						return
					end
				end
			end
		end
	end)
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end
	local panel = g_scene:getTopDialog()
	if panel and panel:getName() == "TroopEmbattlePanel" then
		local heros = panel.m_heros
		for i , info in pairs(heros) do
			if info.heroId then
				return FgSG.kTotoFight
			end
		end
		return FgSG.kEmbattleOneKey
	else
		return FgSG.kFinishGuide
	end
end

function This:update()
	local state = self:getState()
	if state then
		if state == FgSG.kFinishGuide then
			self:finish()
		else
			local node = self:getNodeByPath(NodePath[state])
			self.m_view:setNode(node)
		end
		self.m_state = state
	else
		self:cancel()
	end
end

--endregion
