-- @Author: Su
-- @Date:   2019-04-09 10:46:07
-- @Last Modified by:   Su
-- @Last Modified time: 2019-04-09 10:46:07
-- @File Name: HeroSetCollocationData.lua
-- @Description: 

local This , super = class(..., "Base.BaseModel")
local RecommendedValuesConfig = require("Metadatas.RecommendedValuesConfig")

function This:init(hero)
    super.init(self)
    self.m_hero = hero
    self.m_config = RecommendedValuesConfig
    local config = RecommendedValuesConfig[self.m_hero:getId()]
    self.m_addPoint={config.power,config.Intelligence,config.chief,config.resist}
end

function This:getAddPoint()
    return self.m_addPoint 
end

function This:getDefaultAddPoint()
    local config = self.m_config[self.m_hero:getId()]
    local addPoint={config.power,config.Intelligence,config.chief,config.resist}
    return addPoint
end

function This:setAddPoint(addPoint)
    self.m_addPoint = addPoint
end