--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")

function This:init(soilder)
	self.m_soilder = soilder
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroArmsItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.bg:getContentSize()
	local scale = self.m_csNode.bg:getScale()
	w = w * scale
	h = h * scale
	self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)
	self.m_csNode.bg:setVisible(true)
	self.m_csNode.select:setVisible(false)
end

function This:refresh()
	self.m_csNode.name:setString(self.m_soilder:getName())
	self.m_csNode.lock:setVisible(not self.m_soilder:isUnlock())
	self.m_csNode.yizhuangbei:setVisible(self.m_soilder:getHeroId() > 0)
	self.m_csNode.icon:setImage(SoilderIcon[self.m_soilder:getId()])
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:setSelect(isSelect)
	self.m_csNode.bg:setVisible(not isSelect)
	self.m_csNode.select:setVisible(isSelect)
	if isSelect and self.m_selectHandler then
		self.m_selectHandler()
	end
end

function This:setModel(soilder)
	self.m_soilder = soilder
	self:refresh()
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:onAttachSoilder(heroId,soilderId)
	self:refresh()
end 

function This:onUpPhaseSoilder(heroId,soilderId)
	self:refresh()
end

function This:onHeroReset() 
	self:refresh()
end
--endregion
