

local This , super = class(...,"NodeUI")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTacticsMainItem.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w, h)
end

function This:initTouchEvent()

end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local attrId = self.m_data[1]
    local attrVal = self.m_data[2]
    local desc = ""

    if AttrInfo[attrId].valueType == ValueType.kPercent then
        desc = string.format("%s +%.2f%%", AttrName[attrId], attrVal*100)
    else
        desc = string.format("%s +%d", AttrName[attrId], math.floor(attrVal))
    end
    self.m_csNode.text:setString(desc)
end

