--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("Common/NodeUI/SystemPopup.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	if os.isWin32 then
		local label = cc.Label:createNormalTTF("",20)
		label:setStringWithColor(info.text,480)
		self.m_csNode.webview:addChild(label)
	else
		local webview = cc.WebView:create()
		webview:setVisible(true)
		webview:setScalesPageToFit(true)
		webview:setBackgroundColor("#000000")
		webview:loadHTMLString("<body bgcolor=\"#00A600\">" .. info.text .. "</body>","http://www.baidu.com")
		webview:setContentSize(647,340)
		webview:reload()
		self.m_csNode.webview:addChild(webview)
	end
end

function This:initTouchEvent()
	self.m_csNode.confirmButton:setTouchEnded(function()
		self:close()
		local ccFileUtils = lib2d.ccFileUtils
    	local this = ccFileUtils.getInstance()
    	local writablePath = ccFileUtils.getWritablePath(this)
		local setting = ccFileUtils.loadLuaDataFromFile(this, writablePath .. "Data/GameSetting", false)
		if setting and setting.language then
			
		else
			g_scene:openDialog("Login.LoginSceneLanguagePanel",{})
		end
	end)
end

--endregion
