local This, super = class(..., "Dialog")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("LoginScene/NodeUI/TouristAccountTips.csb")
    self.m_csNode:setPosition(cc.visible.center.x, cc.visible.center.y)
    self:addChild(self.m_csNode)
    self.m_username = info.username
    self.m_csNode.account:setString(self.m_username)
    local w, h = self.m_csNode.account:getContentSize()
    self.m_csNode.copy:setPositionX(w * 0.5 + 40)
    self.m_csNode.fengexian:setScaleX(w / 38)
end

function This:initTouchEvent()
    self.m_csNode.button:setTouchEnded(function ()
        self:close()
    end)
    self.m_csNode.copy:setTouchEnded(function ()
        os.native_call("setTextToClipboard", self.m_username)
    end)
end