local CeilsConfig = 
{
    {
        ceilList={2006, 2007, 1007, 1006, 3007},
        color=2
    },
    {
        ceilList={1008, 2008, 1009, 8, 7},
        color=3
    },
    {
        ceilList={2009, 3010, 2010, 1010},
        color=10
    },
    {
        ceilList={3008, 4008, 4009, 3009},
        color=5
    },
    {
        ceilList={9, -992, -1992, -991, -1991, -990, 10},
        color=4
    },
    {
        ceilList={5010, 5009, 4010, 4011, 5011, 6011, 6010},
        color=6
    },
    {
        ceilList={11, -989, -988, 12},
        color=19
    },
    {
        ceilList={2013, 2014, 1014},
        color=13
    },
    {
        ceilList={2011, 3011, 2012, 1011},
        color=9
    },
    {
        ceilList={4012, 4013, 3013, 3012},
        color=8
    },
    {
        ceilList={6012, 6013, 5013, 5012},
        color=7
    },
    {
        ceilList={-1989, -1990, -2990, -2989, -3989},
        color=11
    },
    {
        ceilList={1013, 13, 1012},
        color=12
    },
    {
        ceilList={14, 1015, 15},
        color=11
    },
    {
        ceilList={3015, 2015, 2016, 3016},
        color=17
    },
    {
        ceilList={4014, 4015, 3014},
        color=16
    },
    {
        ceilList={4016, 4017, 5017, 5016},
        color=4
    },
    {
        ceilList={7016, 7017, 6017, 6016},
        color=3
    },
    {
        ceilList={6014, 6015, 5015, 5014},
        color=15
    },
    {
        ceilList={8014, 7014, 7015, 8015, 9015},
        color=14
    },
    {
        ceilList={7012, 7013, 8013, 8012},
        color=13
    },
    {
        ceilList={10016, 10017, 9017, 9016},
        color=2
    },
    {
        ceilList={8019, 8020, 9020},
        color=15
    },
    {
        ceilList={8017, 8016, 8018, 9018, 9019},
        color=14
    },
    {
        ceilList={6018, 5018, 6019, 7019, 7018},
        color=13
    },
    {
        ceilList={5020, 4020, 5019, 5021, 6021, 6020},
        color=12
    },
    {
        ceilList={3018, 4018, 3017, 4019},
        color=5
    },
    {
        ceilList={3019, 2019, 3020},
        color=6
    },
    {
        ceilList={1017, 1016, 2017, 2018},
        color=18
    },
    {
        ceilList={1018, 18, 17, -983},
        color=19
    },
    {
        ceilList={-985, -986, 16, -984},
        color=10
    },
    {
        ceilList={-2987, -2986, -1986, -3986, -2985},
        color=21
    },
    {
        ceilList={-1988, -987, -1987, -2988},
        color=20
    },
    {
        ceilList={-10980, -11981, -11980, -11979, -10979},
        color=16
    },
    {
        ceilList={-9978, -9979, -10978, -8979, -8978},
        color=17
    },
    {
        ceilList={-7980, -8980, -7979, -7981, -8981},
        color=4
    },
    {
        ceilList={-9981, -9982, -10981, -10982, -9980},
        color=15
    },
    {
        ceilList={-8983, -7983, -7982, -8982, -9983},
        color=14
    },
    {
        ceilList={-8977, -9977, -7978, -7977, -7976, -8976},
        color=18
    },
    {
        ceilList={-6977, -6976, -5976, -4976},
        color=13
    },
    {
        ceilList={-4978, -4977, -5977},
        color=12
    },
    {
        ceilList={-6979, -6978, -5978, -5979},
        color=5
    },
    {
        ceilList={-5980, -4980, -4979, -3980},
        color=6
    },
    {
        ceilList={-6982, -5981, -6981, -6980},
        color=3
    },
    {
        ceilList={-7984, -6985, -6984, -7985, -8985, -8984},
        color=13
    },
    {
        ceilList={-4983, -4982, -5982, -5983, -6983},
        color=2
    },
    {
        ceilList={-4981, -3981, -3982},
        color=7
    },
    {
        ceilList={-2982, -2981, -2980},
        color=21
    },
    {
        ceilList={-3983, -2983, -1983, -1982},
        color=8
    },
    {
        ceilList={-981, 19, -982, -1981},
        color=20
    },
    {
        ceilList={-1980, -980, 20, 21},
        color=1
    },
    {
        ceilList={-1979, -2979, -979},
        color=2
    },
    {
        ceilList={-3978, -3979, -3977},
        color=11
    },
    {
        ceilList={-1977, -1978, -2978, -2977},
        color=10
    },
    {
        ceilList={22, 23, -978, -977},
        color=9
    },
    {
        ceilList={1022, 2021, 2022, 1021},
        color=8
    },
    {
        ceilList={1023, 2023, 2024, 3024, 3023},
        color=10
    },
    {
        ceilList={1024, 1025, 25, 24},
        color=9
    },
    {
        ceilList={1026, 1027, 27, 26},
        color=8
    },
    {
        ceilList={-974, -973, -1974, -1973},
        color=18
    },
    {
        ceilList={-976, -975, -1975, -1976},
        color=17
    },
    {
        ceilList={-3976, -3975, -2975, -2976},
        color=16
    },
    {
        ceilList={-2974, -2973, -3973, -3974},
        color=15
    },
    {
        ceilList={-5974, -4975, -4974, -5975, -6975},
        color=14
    },
    {
        ceilList={-1972, -972, -971, -1971},
        color=19
    },
    {
        ceilList={-4985, -3985, -4986, -5986, -5985, -5984, -4984, -3984},
        color=1
    },
    {
        ceilList={9041, 10041, 10040, 9040},
        color=5
    },
    {
        ceilList={11040, 10039, 9039, 11039},
        color=6
    },
    {
        ceilList={9038, 10038, 10037, 9037, 8037},
        color=7
    },
    {
        ceilList={8039, 7039, 8038, 8040},
        color=4
    },
    {
        ceilList={7037, 6036, 6037, 6038, 7038},
        color=3
    },
    {
        ceilList={7035, 6035, 6034, 5034},
        color=9
    },
    {
        ceilList={4035, 5035, 5036, 5037, 4036},
        color=2
    },
    {
        ceilList={3032, 3033, 4034, 4033},
        color=1
    },
    {
        ceilList={1031, 1030, 30, 31, 2031},
        color=21
    },
    {
        ceilList={3028, 2028, 2029, 2027},
        color=7
    },
    {
        ceilList={3030, 3031, 2030, 3029},
        color=5
    },
    {
        ceilList={5031, 5030, 4030, 4031, 4032},
        color=5
    },
    {
        ceilList={5028, 5029, 4029, 4028, 4027},
        color=17
    },
    {
        ceilList={5033, 6033, 6032, 5032},
        color=4
    },
    {
        ceilList={7031, 7030, 6030, 6031, 7032},
        color=6
    },
    {
        ceilList={7028, 6028, 6029, 7029},
        color=4
    },
    {
        ceilList={6027, 5027, 5026, 4026},
        color=16
    },
    {
        ceilList={7027, 8027, 8026, 8028},
        color=3
    },
    {
        ceilList={10030, 9029, 9030, 8029},
        color=9
    },
    {
        ceilList={11030, 11029, 10029, 11031, 12030},
        color=21
    },
    {
        ceilList={12032, 12033, 11032, 11033},
        color=2
    },
    {
        ceilList={10033, 10031, 10032, 10034},
        color=3
    },
    {
        ceilList={8031, 9031, 9032, 8030},
        color=8
    },
    {
        ceilList={8033, 8032, 7033, 9033},
        color=7
    },
    {
        ceilList={10035, 9035, 9034},
        color=2
    },
    {
        ceilList={10036, 9036, 8036, 7036},
        color=8
    },
    {
        ceilList={8035, 8034, 7034},
        color=3
    },
    {
        ceilList={12037, 11037, 11036},
        color=20
    },
    {
        ceilList={11035, 11034, 12034},
        color=1
    },
    {
        ceilList={13037, 13038, 13036},
        color=21
    },
    {
        ceilList={13035, 12036, 12035},
        color=19
    },
    {
        ceilList={12039, 12038, 11038},
        color=7
    },
    {
        ceilList={14033, 14034, 13034, 13033},
        color=18
    },
    {
        ceilList={23028, 23027, 22027, 22028},
        color=10
    },
    {
        ceilList={21029, 22029, 21028},
        color=11
    },
    {
        ceilList={20026, 20027, 19027, 19026},
        color=13
    },
    {
        ceilList={21025, 22026, 21026, 21027},
        color=12
    },
    {
        ceilList={19024, 20024, 20025, 19025},
        color=11
    },
    {
        ceilList={18023, 18024, 17024, 18025},
        color=10
    },
    {
        ceilList={17022, 16022, 16023, 17023},
        color=8
    },
    {
        ceilList={15022, 14021, 15021, 16021},
        color=7
    },
    {
        ceilList={12019, 13019, 13020, 12020},
        color=17
    },
    {
        ceilList={10020, 10021, 11021},
        color=19
    },
    {
        ceilList={11022, 11023, 11024, 12023},
        color=21
    },
    {
        ceilList={13021, 13022, 12022, 12021},
        color=20
    },
    {
        ceilList={13023, 14023, 14024, 14022},
        color=6
    },
    {
        ceilList={13024, 12024, 13025, 14025, 14026},
        color=5
    },
    {
        ceilList={15026, 15027, 16027},
        color=16
    },
    {
        ceilList={17025, 17026, 16026, 16025},
        color=15
    },
    {
        ceilList={18027, 18028, 19028, 18026},
        color=14
    },
    {
        ceilList={17028, 17027, 16028, 17029},
        color=17
    },
    {
        ceilList={19029, 19030, 18030, 18029},
        color=13
    },
    {
        ceilList={20030, 21030, 20031, 20029, 20028},
        color=12
    },
    {
        ceilList={19031, 19032, 18032, 18031},
        color=14
    },
    {
        ceilList={17031, 17032, 16031, 17033},
        color=15
    },
    {
        ceilList={16029, 17030, 16030},
        color=18
    },
    {
        ceilList={15028, 15029, 14029, 14028},
        color=19
    },
    {
        ceilList={13026, 13027, 14027},
        color=4
    },
    {
        ceilList={10025, 11026, 11025, 12025, 12026, 10024},
        color=1
    },
    {
        ceilList={9023, 9022, 10022, 10023, 8023},
        color=19
    },
    {
        ceilList={9024, 9025, 8025, 8024, 9026, 10026},
        color=2
    },
    {
        ceilList={12027, 12028, 11028, 11027},
        color=3
    },
    {
        ceilList={15030, 15031, 14031, 14030},
        color=21
    },
    {
        ceilList={12029, 13029, 13028, 13030},
        color=20
    },
    {
        ceilList={16032, 16033, 15032},
        color=16
    },
    {
        ceilList={15024, 15023, 16024, 15025},
        color=9
    },
    {
        ceilList={12017, 11016, 11017, 11018, 12018},
        color=16
    },
    {
        ceilList={10018, 10019, 11019, 11020},
        color=18
    },
    {
        ceilList={9021, 8021, 8022, 7021, 7020},
        color=20
    },
    {
        ceilList={7022, 6022, 5022, 7023},
        color=13
    },
    {
        ceilList={7024, 7025, 6025, 6026, 7026},
        color=18
    },
    {
        ceilList={10027, 10028, 9028, 9027},
        color=10
    },
    {
        ceilList={13031, 13032, 14032, 12031},
        color=1
    },
    {
        ceilList={16034, 15034, 15033},
        color=17
    },
    {
        ceilList={4024, 4023, 4025, 5025},
        color=14
    },
    {
        ceilList={3026, 3025, 2025, 2026, 3027},
        color=15
    },
    {
        ceilList={1028, 1029, 29, 28},
        color=6
    },
    {
        ceilList={-970, -969, -1969, -1970},
        color=20
    },
    {
        ceilList={4022, 3022, 3021, 4021},
        color=11
    },
    {
        ceilList={1020, 2020, 1019},
        color=7
    },
    {
        ceilList={-2984, -1984, -1985},
        color=9
    },
    {
        ceilList={-4987, -4988, -3988, -3987, -5987, -5988},
        color=12
    },
    {
        ceilList={5023, 5024, 6023, 6024},
        color=12
    },
    {
        ceilList={-13981, -14981, -14980, -13980, -12980, -12981},
        color=2
    },
    {
        ceilList={9042, 10042, 10043, 9043},
        color=2
    },
    {
        ceilList={24027, 25027, 25028, 24028},
        color=2
    },
    {
        ceilList={2005, 1005, 3004, 2004, 1004, 4},
        color=2
    }

}

return CeilsConfig