-- @Author: Su
-- @Date:   2019-06-12 16:40:57
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-12 16:40:57
-- @File Name: HanXianDiSkillPanel.lua
local This , super = class(...,"Dialog")
local SkillConfig = require("Metadatas.SkillConfig")
local ArgConfig = require("Metadatas.ArgConfig")

function This:initNode()
    self.m_csNode=cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsSkill.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self:refresh()
end

function This:refresh()
    local node=self.m_csNode
    local item = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsSkillItem.csb")
    local x,y = item.bg:getContentSize()
    local skillId = ArgConfig["zb_hxd_skill_id"].arg[1]
    local config = SkillConfig[skillId]
    item.title:setString(config.name)
    item.text1:setStringWithColor(config.desp,290)
    item:setContentSize(x, y)
    node.scrollView:pushBackCustomItem(item,x,y,0.5)

end

function This:onTouchMask() -- 对话框之外区域的点击事件
    self:close()
end