--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ListLayer = require("UI.ListLayer")
local JunCeView = require("Map.JunCeView")

function This:initNode(info)
	self.m_city = info.city
	self.m_map = info.map

	self.m_csNode = cc.Node:createFromCSFile("WarScene/NodeUI/UesPlan.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_stgItemList = self.m_map:getJunCeList()

	self.m_listLayer = ListLayer:create({
		itemWidth = 168,
		itemHeight = 165,
		spaceX = 10,
		itemCount = #self.m_stgItemList,
		frameCount = #self.m_stgItemList,
		column = 3,
	})
	
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.scrollview:pushBackCustomItem(self.m_listLayer, w,h,0)
	self.m_listLayer:setCascadeOpacityEnabled(true)

	self.m_listLayer:starList(function (index)
		local view = JunCeView:create({
			city = self.m_city,
			map = self.m_map,
			junce = self.m_stgItemList[index]
		})
		return view
	end)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onTouchMask()
	self:close()
end

--endregion
