--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionReportList.csb")
	self:addChild(self.m_csNode)
	self:setModel(info)
end

function This:refresh()

	local csNode = self.m_csNode
	csNode.num:setString(self.m_index)
	GameUtil:setPlayerIconNodeImage(csNode.pic1.icon, self.m_troop.role_info.icon)
	csNode.name:setString(self.m_troop.role_info.name)
	csNode.juntuanname:setString(self.m_troop.group_name)

	local troop = self.m_troop.troop
	local maxHp , hp = 0, 0
	for i , card in ipairs(troop.card_list) do
		maxHp = maxHp + card.max_hp
		hp = hp + card.hp
	end
	csNode.jundutiao:setPercent(hp / maxHp*100)
	csNode.bingli:setString(string.format("%d/%d", hp, maxHp))

	local troopState = troop.state
	csNode.liezhenzhong:setVisible(troopState == LegionTroopState.kDefensive)
	csNode.jiaozhanzhong:setVisible(troopState == LegionTroopState.kBattle)
	if hp > 0 then
		csNode.jiaozhanzhong:setString(Serialize[61669])
	else
		csNode.jiaozhanzhong:setString(Serialize[61670])
	end
end

function This:setModel(info)
	self.m_index = info.index
	self.m_troop = info
	self:refresh()
end

function This:initTouchEvent()
	
end


--endregion
