--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local LegionChangeLevelConfig = require("Metadatas.LegionChangeLevelConfig")

function This:init(info)
	self.m_buildType = info.buildType
	self.m_level = info.level or 1

	self.m_config = LegionChangeLevelConfig[self.m_buildType * 100 + self.m_level]
	assert(self.m_config)

	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildItem.csb")
	self:addChild(self.m_csNode)

	self.m_csNode.build:setImage(self.m_config.picture1)
	self.m_csNode.title:setString(self.m_config.change_name)
	self:setIsSelected(false)
end

function This:initTouchEvent()
	self.m_csNode.build_bg:setTouchEnded(function()
		if self.m_touchHandler then
			self.m_touchHandler(self.m_buildType)
		end
	end)
end

function This:setTouchHandler(handler)
	self.m_touchHandler = handler
end

function This:getBuildType()
	return self.m_buildType
end

function This:setIsSelected(isSelect)
	self.m_csNode.choose:setVisible(isSelect)
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end


--endregion
