﻿--region *.lua
--Date
--姝ゆ枃浠剁敱[BabeLua]鎻掍欢鑷姩鐢熸垚

local This , super = class(...,"Base.BaseModel")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemUtil = require("Bag.ItemUtil")

function This:init(info)
	self.m_id = info.id or 1
	self.m_heroId = info.card_type 
	self.m_star = info.star or 1
	self.m_level = info.level or 1
	self.m_fightPower = info.fight_power or 0
	self.m_pos = info.pos or 1
	self.m_hp = info.hp or 0
	self.m_maxHp = info.max_hp or 0
	self.m_resType = info.res_type or 0
	self.m_resNum = info.res_num or 0
end

function This:getId()
	return self.m_id
end

function This:getHeroId()
	return self.m_heroId
end

function This:getStar()
	return self.m_star
end

function This:getName()
	return HeroConfig[self.m_heroId].name
end

function This:getLevel()
	return self.m_level
end

function This:getQuality()
    return ItemUtil.getQuality(self.m_heroId)
end

function This:getFightPower()
	return self.m_fightPower
end

function This:setHp(hp)
	self.m_hp = hp
end

function This:getHp()
	return self.m_hp
end

function This:getMaxHp()
	return self.m_maxHp
end

function This:getPos()
	return self.m_pos
end

function This:getIcon()
	return ItemUtil.getIconImage(self.m_heroId)
end

function This:getTransHp()
	if self.m_resType == LegionTransType.kHp then
		return self.m_resNum
	end
	return 0
end

function This:getTransMerinel()
	if self.m_resType == LegionTransType.kMineral then
		return self.m_resNum
	end
	return 0
end

function This:getTransType()
	return self.m_resType
end

function This:getTransNum()
	return self.m_resNum
end

function This:updateInfo(info)
	print_r(info)
	self.m_id = info.id
	self.m_heroId = info.card_type
	self.m_star = info.star
	self.m_level = info.level
	self.m_fightPower = info.fight_power
	self.m_pos = info.pos
	self.m_hp = info.hp
	self.m_maxHp = info.max_hp
	self.m_resType = info.res_type
	self.m_resNum = info.res_num
end

--endregion
