-- @Author: superm
-- @Date:   2019-09-28 16:50:28
-- @Last Modified by:   superm
-- @Last Modified time: 2019-10-11 15:24:50
-- @File Name: LegionIntegralBox.lua
-- @Description: 

local This , super = class(...,"Base.BaseModel")
local LegionWarLegionIntegralConfig = require("Metadatas.LegionWarLegionIntegralConfig")

function This:init(info)
	super.init(self, info)
	self.m_id = info.id
	self.m_config = LegionWarLegionIntegralConfig[self.m_id]
	self.m_state = info.state
end

function This:getConfig()
    return self.m_config
end

function This:getNextBoxId( param )
    return self.m_config.next_id
end

function This:setState(value)
    self.m_state = value
end

function This:getState()
    return self.m_state
end

function This:getId()
    return self.m_id
end

function This:getReward()
    return self.m_config.reward_list
end

