﻿--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local ArgConfig = require("Metadatas.ArgConfig")
local HeroManager = require("Hero.HeroManager")

kLegionIronOreItemId = 252

LegionCityType = 
{
	kNormal = 1,
	kProtected = 2, 
	kHideCity = 3
}

LegionBuildType = 
{
	kNone = 0,
	kMainCity = 1, --主城
	kBarracks = 2, --兵营
	kWarehouse = 3, --仓库
	kArrowTower = 4, --弓箭塔
	kBoltTower = 5, --弩箭塔
	kFarmland = 6, --良田
	kMarket = 7, --集市
	kMintage = 8, --铸币厂
}

LegionTechType =
{
	kMainCity = 0, 
	kWallDurability = 1, --城墙
	kWallDamage = 2, --城墙伤害
	kProductHpSpeed = 3, --提升兵力生产速度
	kSuppleHpSpeed = 4, --提升补兵速度
	kAddMaxHp = 5, --兵力上限
	kAddMaxMineral = 6, --矿产上限
	kReduceMineralPlunderRatio = 7, --矿产掠夺
	kReduceArrowDamageInterval = 8, --弓箭伤害间隔
	kAddArrowDamage = 9, --提升弓箭伤害
	kReduceBoltDamageInterval = 10 ,--弩箭伤害间隔
	kAddBoltDamage = 11, --提升弩箭伤害
	kAddProductFood = 12, --增加粮食产量
	kAddHarvestFoodFactor = 13, --提升粮食收割因子
	kAddProductCoin = 14, --提升银币产量
	kAddHarvestCoinFactor = 15, --提升银币收割因子
	kAddWallSoilderSolt = 16 , --增加城防军的槽位
}

LegionTechAttrType = 
{
	kWallDurabilityLimit = 1, --城墙耐久度上线
	kWallDurabilityRecover = 2, --城墙耐久度恢复值
	kWallPowerAddValue = 3, --城墙武力加成值
	kBarracksProductHpSpeed = 4, --兵营产兵速率提升值
	kBarracksSuppleHpSpeed = 5, --兵营补兵速度值
	kBarracksMaxHpLimit = 6, --兵营兵力存储上限
	kWarehouseMaxMineralLimit = 7, --厂库存储上限
	kReduceMineralPlunderRadio = 8, --减少矿产资源掠夺百分比
	kReduceArrowAttackInterval = 9, --弓箭塔攻击间隔
	kAddArrowBaseDamage = 10, --增加弓箭塔基础伤害
	kAddArrowPercentDamage = 11, --增加弓箭塔百分比伤害
	kReduceBoltAttackInterval = 12, --弩箭塔攻击间隔
	kAddBoltBaseDamage = 13,--增加弩箭塔基础伤害
	kAddBoltPercentDamage = 14, --增加弩箭塔百分比伤害
	kFarmlandResAddProduct = 15, --农田资源产量增加
	kFarmlandResAddHarvestTime = 16, --增加农田收割次数
	kFarmlandResAddHarvestFactor = 17, --增加农田收割因子
	kMarketResAddProduct = 18, --集市资源产量增加
	kMarketResAddHarvestTime = 19,--集市资源收割次数增加
	kMarketResAddHarvestFactor = 20, --增加集市资源收割因子
	kChengFangSoltMaxLimit = 21, --城防军槽位最大数
}

LegionTechAttrText = 
{
	[LegionTechAttrType.kWallDurabilityLimit] = Serialize[61731],
	[LegionTechAttrType.kWallDurabilityRecover] = Serialize[61732],
	[LegionTechAttrType.kWallPowerAddValue] = Serialize[61733],
	[LegionTechAttrType.kBarracksProductHpSpeed] = Serialize[61734],
	[LegionTechAttrType.kBarracksSuppleHpSpeed] = Serialize[61735],
	[LegionTechAttrType.kBarracksMaxHpLimit] = Serialize[61736],
	[LegionTechAttrType.kWarehouseMaxMineralLimit] = Serialize[61737],
	[LegionTechAttrType.kReduceMineralPlunderRadio] = Serialize[61738],
	[LegionTechAttrType.kReduceArrowAttackInterval] = Serialize[61739],
	[LegionTechAttrType.kAddArrowBaseDamage] = Serialize[61740],
	[LegionTechAttrType.kAddArrowPercentDamage] = Serialize[61741],
	[LegionTechAttrType.kReduceBoltAttackInterval] = Serialize[61742],
	[LegionTechAttrType.kAddBoltBaseDamage] = Serialize[61743],
	[LegionTechAttrType.kAddBoltPercentDamage] = Serialize[61744],
	[LegionTechAttrType.kFarmlandResAddProduct] = Serialize[61745],
	[LegionTechAttrType.kFarmlandResAddHarvestTime] = Serialize[61746],
	[LegionTechAttrType.kFarmlandResAddHarvestFactor] = Serialize[61747],
	[LegionTechAttrType.kMarketResAddProduct] = Serialize[61748],
	[LegionTechAttrType.kMarketResAddHarvestTime] = Serialize[61749],
	[LegionTechAttrType.kMarketResAddHarvestFactor] = Serialize[61750],
	[LegionTechAttrType.kChengFangSoltMaxLimit] = Serialize[61751]
}


LegionTechAttrNewText = 
{
	[LegionTechAttrType.kWallDurabilityLimit] = {1, Serialize[61752]},
	[LegionTechAttrType.kWallDurabilityRecover] = {1, Serialize[61753]},
	[LegionTechAttrType.kWallPowerAddValue] = {2, Serialize[61754]},
	[LegionTechAttrType.kBarracksProductHpSpeed] = {3, Serialize[61755]},
	[LegionTechAttrType.kBarracksSuppleHpSpeed] =  {4, Serialize[61755]},
	[LegionTechAttrType.kBarracksMaxHpLimit] = {5, "%d"},
	[LegionTechAttrType.kWarehouseMaxMineralLimit] = {6, "%d"},
	[LegionTechAttrType.kReduceMineralPlunderRadio] = {7, Serialize[61756], 100},
	[LegionTechAttrType.kReduceArrowAttackInterval] = {8, "%d"},
	[LegionTechAttrType.kAddArrowBaseDamage] = {9, Serialize[61754]},
	[LegionTechAttrType.kAddArrowPercentDamage] = {9, Serialize[61756], 100},
	[LegionTechAttrType.kReduceBoltAttackInterval] = {10,"%d"},
	[LegionTechAttrType.kAddBoltBaseDamage] = {11,Serialize[61754]},
	[LegionTechAttrType.kAddBoltPercentDamage] = {11,Serialize[61756], 100},
	[LegionTechAttrType.kFarmlandResAddProduct] = {12, "%d"},
	[LegionTechAttrType.kFarmlandResAddHarvestTime] = {13,Serialize[61757]},
	[LegionTechAttrType.kFarmlandResAddHarvestFactor] = {13,Serialize[61758]},
	[LegionTechAttrType.kMarketResAddProduct] = {14, "%d"},
	[LegionTechAttrType.kMarketResAddHarvestTime] = {15,Serialize[61757]},
	[LegionTechAttrType.kMarketResAddHarvestFactor] = {15,Serialize[61758]},
	[LegionTechAttrType.kChengFangSoltMaxLimit] = {16, "%d"},
}

LegionTechAttrTarget = {
	[1] = Serialize[61759],
	[2] = Serialize[61760],
	[3] = Serialize[61761],
	[4] = Serialize[61762],
	[5] = Serialize[61763],
	[6] = Serialize[61764],
	[7] = Serialize[61765],
	[8] = Serialize[61739],
	[9] = Serialize[61766],
	[10] = Serialize[61742],
	[11] = Serialize[61767],
	[12] = Serialize[61768],
	[13] = Serialize[61769],
	[14] = Serialize[61770],
	[15] = Serialize[61771],
	[16] = Serialize[61772],
}

LegionBuildState = 
{
	kNormal = 1, --未升级
	kUpgrading = 2, --升级中
}

LegionTroopType = 
{
	kRoleTroop = 1, --玩家部队
	kChengFang = 2, --城防军
	kNpc = 3, --NPC部队
}

LegionTroopState = 
{
	kIdle = 1, --空闲中
	kDefensive = 2, --防守中
	kMarch = 3, --行军中
	kBattle = 4, --战斗中
	kTechAddSpeed = 5, --科技加速
	kTransport = 6, --运输中
	kAddHp = 7, --补兵中
	kReadyBattle = 8, --准备战斗中
}

LegionTroopStateText = 
{
	[LegionTroopState.kAddHp] = Serialize[61773],
	[LegionTroopState.kBattle] = Serialize[61310],
	[LegionTroopState.kDefensive] = Serialize[61774],
	[LegionTroopState.kIdle] = Serialize[61307],
	[LegionTroopState.kMarch] = Serialize[61308],
	[LegionTroopState.kTechAddSpeed] = Serialize[61775],
	[LegionTroopState.kTransport] = Serialize[61776],
	[LegionTroopState.kReadyBattle] = Serialize[61777],
}

RescueTroopStateText = 
{
	[LegionTroopState.kAddHp] = Serialize[61778],
	[LegionTroopState.kBattle] = Serialize[61310],
	[LegionTroopState.kDefensive] = Serialize[61774],
	[LegionTroopState.kIdle] = Serialize[61307],
	[LegionTroopState.kMarch] = Serialize[61308],
	[LegionTroopState.kTechAddSpeed] = Serialize[61775],
	[LegionTroopState.kTransport] = Serialize[61776],
	[LegionTroopState.kReadyBattle] = Serialize[61777],
}

LegionTransType = 
{
	kHp = 1 , --兵力
	kMineral = 2, --矿产
}


LegionCityState = 
{
	kNormal = 0, --正常状态
	kFighting = 1, --战斗状态
	kProtected = 2, --保护状态
}

LegionStrategyType = 
{
	kTuCheng = 3001, --屠城[天火屠城]
	kQiangXi = 3002, --强袭[暗度陈仓]

	-- change 20190910 begin
	-- kFengShou = 3003, --丰收
	-- kQiangZheng = 3004, --强征
	-- kJianSheLing = 3005, --建设令
	kHuanBing = 3003, -- 缓兵之计
	-- change 20190910 end

	kKongChengJi = 3006, --空城计

	-- new 20190910 begin
	kFuBing = 3007, --伏兵之计
	kQuanJunChuJi = 3008, -- 全军出击
	kPoFu = 3009, -- 破釜沉舟
	kBaGua = 3010, -- 奇門八卦
	kPoZhen = 3011, -- 破阵
	kYiGuZuoQi = 3012, -- 一鼓作气
	-- new 20190910 end
}

LegionIntegralType ={
	kLegionTransport = 1,
	kLegionBuild = 2,
	kLegionKill = 3,
	kLegionDamage = 7,
}

--endregion
