--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local LegionWarRewardConfig = require("Metadatas.LegionWarRewardConfig")

function This:initNode(info)
	self.m_msg = info.msg
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionSettlementReward.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	for i , rank in ipairs(self.m_msg.my_rank_list) do
		if rank <= 0 or rank > 3 then rank = 4 end
		local configId = self.m_map:getType() * 10000 + self.m_map:getLevel() * 100 + i * 10 + rank
		local config = LegionWarRewardConfig[configId].reward_list
		if i <=  3 then
			for i , info in ipairs(config) do
				local item = ItemNode:create(info)
				self.m_csNode["item"..i]:addChild(item)
				item:setAnchorPoint(0.5,0.5)
				item:setPosition(0,(i - 1) * 40)
			end
		else
			for i , info in ipairs(config) do
				local item = ItemNode:create(info)
				self.m_csNode.item:addChild(item)
				item:setAnchorPoint(0.5,0.5)
				item:setPosition(0,(i - 1) * 40)
			end
		end
	end
end

function This:onTouchMask()
	self:close()
end

--endregion
