--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")

function This:init(info)
	self.m_tech = info.tech
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildMakeitem.csb")
	self:addChild(self.m_csNode)
	self:refresh()
	self:setIsSelected(false)
end

function This:refresh()
	self.m_csNode.build:setImage(self.m_tech:getImage())
	self.m_csNode.text:setString(string.format("%sLv.%d",self.m_tech:getName(),self.m_tech:getLevel()))
	self.m_csNode.text2:setVisible(self.m_tech:isInBuilding())
end

function This:setIsSelected(isSelect)
	self.m_csNode.bg:setVisible(isSelect)
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:initTouchEvent()
	self:setTouch({
		onEnded = function()
			if self.m_touchHandler then
				self.m_touchHandler(self.m_tech)
			end
		end,
		sizeNode = self.m_csNode.bg,
		isContainer = true,
		isSwallow = true
	})
end

function This:setTouchHandler(handler)
	self.m_touchHandler = handler
end

-------------------------------------------------------
function This:onUpgradeTech(tech)
	if self.m_tech == tech then
		self:refresh()
	end
end

function This:onChangeTechState(tech)
	if self.m_tech == tech then
		self:refresh()
	end 
end

function This:onTechAddSpeedChange(tech)
	if self.m_tech == tech then
		self:refresh()
	end
end



--endregion
