--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.MarchArmyPathView")
local LegionMapUtil = require("Map.LegionMapUtil")

function This:init(info)
	self.m_march = info.march
	self.m_map = info.map
	self.m_spriteList = {}
	self.m_scene = g_scene

	self.m_resType = march:getResType()
	self.m_startCity = self.m_map:getCity(self.m_march:getFromCity())
	self.m_toCity = self.m_map:getCity(self.m_map:getToCity())

	local sview = self.m_scene:getCityNode(self.m_march:getFromCity())
	local sx , sy = sview:getPosition()
	local eview = self.m_scene:getCityNode(self.m_march:getToCity())
	local ex , ey = eview:getPosition()

	self.m_file = self:getPathImage()
	self:initMarchPath(self.m_file,sx,sy,ex,ey)
end

function This:getPathImage()
	local resType = self.m_march:getResType()
	if resType == LegionTransType.kMineral then
		return "Common/yunshu.png"
	else
		if self.m_toCity:isOur() then
			return "Common/zhiyuan.png"
		else
			return "Common/gongji.png"
		end
	end
end

function This:getModel()
	return self.m_march
end

function This:refresh()
	local file = self:getPathImage()
	if self.m_file ~= file then
		for i , sprite in ipairs(self.m_spriteList) do
			sprite:setImage(file)
		end
		self.m_file = file
	end
end

--endregion
