return {
    [1]={id=1, name="主界面任务红点", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.task", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"menu_scene_enter",
"world_scene_enter","CrusadeAchieveRed"
}, check_func={func = function() 
return g_redDot:isWeeklyTaskReward() or 
g_redDot:isDailyTaskReward() or 
g_redDot:isMainTaskReward() or
g_redDot:isGongXunTaskReward() or 
g_redDot:isGongXunBoxCanReward() or 
g_redDot:isCrusadeReward() 
end
}, father=0},
    [2]={id=2, name="活跃任务红点", type=1, node_path="MenuScene.AchieveMainPanel.m_csNode.weekly", node_events={
"dialog_open"
}, events={
"weekly_achieve_refresh",
"weekly_achieve_changed",
"weekly_box_reward"
}, check_func={
func = function()
return g_redDot:isWeeklyTaskReward()
end
}, father=1},
    [3]={id=3, name="日常任务红点", type=1, node_path="MenuScene.AchieveMainPanel.m_csNode.daily", node_events={
"dialog_open"
}, events={
"dialy_achieve_changed",
"daily_achieve_refresh"
}, check_func={
func = function()
return g_redDot:isDailyTaskReward()
end
}, father=1},
    [4]={id=4, name="主界面招募红点", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.recruit", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"menu_scene_enter",
"world_scene_enter"
}, check_func={

}, father=0},
    [5]={id=5, name="普通招募红点", type=1, node_path="MenuScene.RecruitPanel.m_csNode.recruit1", node_events={"dialog_open"}, events={
"item_zml_changed"
}, check_func={
func = function()
return g_redDot:isHasItemZML()
end
}, father=4},
    [6]={id=6, name="重金招募红点", type=1, node_path="MenuScene.RecruitPanel.m_csNode.free", node_events={"dialog_open"}, events={
"recruit_zhongjin_cd_changed"
}, check_func={
func = function()
return g_redDot:isRecruitZhongJinCDEnd()
end
}, father=4},
    [7]={id=7, name="主界面计策", type=1, node_path="WorldScene.sceneUI.m_csNode.panel_btns.jice", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"menu_scene_enter",
"world_scene_enter",
"plan_shop_cd_changed"
}, check_func={
func = function()
return g_redDot:isPlanShopCDEnd()
end
}, father=0},
    [8]={id=8, name="主界面关卡红点", type=2, node_path="MenuScene.sceneUI.m_csNode.panel_btns.stage", node_events={
"menu_scene_enter"
}, events={
"menu_scene_enter",
"stage_star_changed",
"stage_box_changed",
"stage_visit_hero_changed"
}, check_func={
func = function()
return g_redDot:isFreeVisitHero()
end
}, father=0},
    [9]={id=9, name="主界面好友红点", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.friend", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"friend_recv_request",
"friend_remove_request"
}, check_func={

}, father=0},
    [10]={id=10, name="好友界面最近标签红点", type=1, node_path="WorldScene.FriendPanel.m_csNode.tab1", node_events={
"dialog_open"
}, events={
"friend_recv_request",
"friend_remove_request",
"friend_chat_changed"
}, check_func={
func = function()
return g_redDot:isHaveFriendRequest() or 
g_redDot:isHaveNoReadChatMessage()
end
}, father=9},
    [11]={id=11, name="好友界面好友标签红点", type=1, node_path="MenuScene.FriendPanel.m_csNode.tab2", node_events={
"dialog_open"
}, events={
"friend_chat_changed"
}, check_func={
func = function()
return g_redDot:isHaveFriendNoReadChatMessage()
end
}, father=9},
    [12]={id=12, name="活动开关", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong_button", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={["huodong_switch_changed"]=function(reddot, value)

reddot.m_skipState = value

reddot.m_isShow = nil

reddot:refresh()

return reddot.m_isShow

end}, check_func={skip_func = function(reddot)

return reddot.m_skipState

end}, father=0},
    [13]={id=13, name="投资计划红点", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.invest", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"activity_invest_state_changed"
}, check_func={
func = function()
return g_redDot:isActivityTZJHNormal()
end
}, father=12},
    [14]={id=14, name="元宝投资红点", type=1, node_path="WorldScene.ActivitySeparatedPanel.m_csNode.tab1", node_events={
"dialog_open"
}, events={
"activity_invest_state_changed"
}, check_func={
func = function()
return g_redDot:isYuanBaoTZJHCanReward()
end
}, father=13},
    [15]={id=15, name="金币投资红点", type=1, node_path="WorldScene.ActivitySeparatedPanel.m_csNode.tab2", node_events={
"dialog_open"
}, events={
"activity_invest_state_changed"
}, check_func={
func = function()
return g_redDot:isGoldTXJHCanReward()
end
}, father=13},
    [16]={id=16, name="每日首胜", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.firstwin", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"gongxun_achieve_refresh",
"gongxun_achieve_changed"
}, check_func={
func = function()
return g_redDot:isMRSSCanReward()
end
}, father=12},
    [17]={id=17, name="官职活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.office", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"rank_level_history_change","match_rank_reward_changed",
"match_daily_reward_changed"
}, check_func={
func = function()
return g_redDot:isMatchRankCanReward()
end
}, father=12},
    [18]={id=18, name="外交红点", type=2, node_path="WorldScene.sceneUI.m_csNode.panel_btns.diplomatic", node_events={
"world_scene_enter"
}, events={
"world_map_relation_changed"
}, check_func={
func = function()
return g_redDot:isHasRecvRelationRequest()
end
}, father=0},
    [19]={id=19, name="活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.activity", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_activity_state_changed","prize_draw_item_changed","daily_sign_reward",
"daily_sign_refresh","continuous_pay_refresh",
"continuous_pay_reward"}, check_func={
func = function()
return g_redDot:isActivityListReward()
 or g_redDot:isCanDailySignReward() or g_redDot:isActivityPrizeDrawReward(43) or g_redDot:isActivityPrizeDrawReward(52) or g_redDot:isCanContinuePayReward(38) or g_redDot:hasPhoneCardReward()
end
}, father=12},
    [20]={id=20, name="加官进爵", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.addoffice", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_addoffice_state_changed"}, check_func={

func = function()

return g_redDot:isActivityJSXZReward()

end

}, father=12},
    [21]={id=21, name="首次充值", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.firstpay", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_firstpay_state_changed"}, check_func={

func = function()

return g_redDot:isActivitySCReward()

end

}, father=12},
    [22]={id=22, name="七日活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.sevendays", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_sevendays_state_changed"}, check_func={

func = function()

return g_redDot:isActivitySevenDayReward()

end

}, father=12},
    [23]={id=23, name="新年活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.newyear", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={
"activity_newyear_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(53) or  g_redDot:hasActReward(54)
end
}, father=12},
    [24]={id=24, name="新年任务", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot19_1", node_events={
"dialog_open"
}, events={
"activity_newyear_state_changed"
}, check_func={
func = function()
return g_redDot:isNewyearTaskCanTask(true, 1)
end
}, father=23},
    [25]={id=25, name="字帖兑换", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot19_2", node_events={
"dialog_open"
}, events={
"activity_newyear_state_changed"
}, check_func={
func = function()
return g_redDot:isNewyearTaskCanTask(true, 2)
end
}, father=23},
    [26]={id=26, name="VIP", type=1, node_path="WorldScene.sceneUI.m_csNode.player_info.vip.hongdian", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={
"vip_reward_state_changed"
}, check_func={
func = function()
return g_redDot:isVipReward()
end
}, father=0},
    [27]={id=27, name="主界面商店红点", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.shop", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={
"store_state_changed"
}, check_func={

}, father=0},
    [28]={id=28, name="战功商店标签红点", type=1, node_path="MenuScene.StoreMainPanel.m_csNode.zhangong", node_events={

"dialog_open"

}, events={
"store_state_changed"
}, check_func={
func = function()
return g_redDot:isZGSDCanFreeRefresh()
end
}, father=27},
    [29]={id=29, name="将魂商店红点", type=1, node_path="MenuScene.StoreMainPanel.m_csNode.jianghun", node_events={

"dialog_open"

}, events={
"store_state_changed"
}, check_func={
func = function()
return g_redDot:isJHSDCanFreeRefresh()
end
}, father=27},
    [30]={id=30, name="限制充值", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act20", node_events={
"dialog_open"
}, events={
"activity_limit_recharge_changed"
}, check_func={
func = function()
return g_redDot:isLimitRechargeCanReward(20)
end
}, father=0},
    [31]={id=31, name="铜雀台活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.tongquetai", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_tongquetai_state_changed"}, check_func={

func = function()

return g_redDot:isActivityTQTReward()

end

}, father=12},
    [32]={id=32, name="元宵活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.yuanxiao", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={
"activity_yunxiao_state_changed"
}, check_func={
func = function()
return g_redDot:isLanternTaskCanTask() or g_redDot:isLanternTYDHCanReward() or g_redDot:isActivityPrizeDrawReward()
end
}, father=12},
    [33]={id=33, name="元宵任务", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot21_1", node_events={
"dialog_open"
}, events={
"activity_yuanxiao_state_changed"
}, check_func={
func = function()
return g_redDot:isLanternTaskCanTask()
end
}, father=32},
    [34]={id=34, name="汤圆兑换", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot21_2", node_events={
"dialog_open"
}, events={
"activity_yuanxiao_state_changed"
}, check_func={
func = function()
return g_redDot:isLanternTYDHCanReward()
end
}, father=32},
    [35]={id=35, name="汤圆抽奖", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot22", node_events={
"dialog_open"
}, events={
"prize_draw_item_changed","activity_yuanxiao_state_changed"
}, check_func={
func = function()
return g_redDot:isActivityPrizeDrawReward()
end
}, father=32},
    [36]={id=36, name="七天活动第1天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120081", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(1)
end
}, father=22},
    [37]={id=37, name="七天活动第2天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120082", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(2)
end
}, father=22},
    [38]={id=38, name="七天活动第3天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120083", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(3)
end
}, father=22},
    [39]={id=39, name="七天活动第4天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120084", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(4)
end
}, father=22},
    [40]={id=40, name="七天活动第5天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120085", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(5)
end
}, father=22},
    [41]={id=41, name="七天活动第6天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120086", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(6)
end
}, father=22},
    [42]={id=42, name="七天活动第7天", type=1, node_path="MenuScene.ActivitySeparatedPanel.m_csNode.typeBg.tab120087", node_events={
"dialog_open"
}, events={"activity_sevendays_state_changed"}, check_func={
func = function()
return g_redDot:isActSevenDayHasDayReward(7)
end
}, father=22},
    [43]={id=43, name="签到活动", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act29", node_events={
"dialog_open"
}, events={
"daily_sign_reward",
"daily_sign_refresh"
}, check_func={
func = function()
return g_redDot:isCanDailySignReward()
end
}, father=0},
    [44]={id=44, name="开服活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.kaifuhuodong", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_kaifuhuodong_state_changed"}, check_func={

func = function()

return g_redDot:isActivityLimitTimeListReward()

end

}, father=12},
    [45]={id=45, name="团购活动第1页", type=1, node_path="MenuScene.ActivityPanel.m_csNode.ActivityBaseTabsUI.m_csNode.hongdian1", node_events={
"activity_tabs_ui_open"
}, events={"activity_kaifuhuodong_state_changed"}, check_func={
func = function()
return g_redDot:isActGroupRechargeReward(1)
end
}, father=0},
    [46]={id=46, name="团购活动第2页", type=1, node_path="MenuScene.ActivityPanel.m_csNode.ActivityBaseTabsUI.m_csNode.hongdian2", node_events={
"activity_tabs_ui_open"
}, events={"activity_kaifuhuodong_state_changed"}, check_func={
func = function()
return g_redDot:isActGroupRechargeReward(2)
end
}, father=0},
    [47]={id=47, name="团购活动第3页", type=1, node_path="MenuScene.ActivityPanel.m_csNode.ActivityBaseTabsUI.m_csNode.hongdian3", node_events={
"activity_tabs_ui_open"
}, events={"activity_kaifuhuodong_state_changed"}, check_func={
func = function()
return g_redDot:isActGroupRechargeReward(3)
end
}, father=0},
    [48]={id=48, name="团购活动第4页", type=1, node_path="MenuScene.ActivityPanel.m_csNode.ActivityBaseTabsUI.m_csNode.hongdian4", node_events={
"activity_tabs_ui_open"
}, events={"activity_kaifuhuodong_state_changed"}, check_func={
func = function()
return g_redDot:isActGroupRechargeReward(4)
end
}, father=0},
    [49]={id=49, name="跨服活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.kuafuhuodong", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_kuafuhuodong_state_changed","continuous_pay_refresh",
"continuous_pay_reward"}, check_func={

func = function()

return g_redDot:isActivityCrossZoomeListReward() or g_redDot:isCanContinuePayReward()

end

}, father=12},
    [50]={id=50, name="连续充值活动", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act31", node_events={
"dialog_open"
}, events={
"continuous_pay_refresh",
"continuous_pay_reward"
}, check_func={
func = function()
return g_redDot:isCanContinuePayReward(31)
end
}, father=0},
    [51]={id=51, name="连续充值活动1", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act38", node_events={
"dialog_open"
}, events={
"continuous_pay_refresh",
"continuous_pay_reward"
}, check_func={
func = function()
return g_redDot:isCanContinuePayReward(38)
end
}, father=0},
    [52]={id=52, name="全服消费活动", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot36", node_events={
"dialog_open"
}, events={
"entire_consume_refresh","entire_consume_reward"
}, check_func={
func = function()
return g_redDot:isCanEntireCostReward()
end
}, father=23},
    [53]={id=53, name="累计充值4", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot35", node_events={

}, events={

}, check_func={
func = function()
return false and g_redDot:isWuyiTotalPayReward()
end
}, father=0},
    [55]={id=55, name="在线奖励", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.online", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={
"activity_online_state_changed"
}, check_func={
func = function()
return g_redDot:isActivityOnlineReward()
end
}, father=12},
    [56]={id=56, name="事件簿", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.eventbook", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={
"activity_trailer_state_changed"
}, check_func={
func = function()
return g_redDot:isTrailerExist() or g_redDot:isOpenInOneDay() > 0
end
}, father=12},
    [57]={id=57, name="节日活动充值部分", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot19_3", node_events={

}, events={

}, check_func={
func = function()
return false and g_redDot:isNewyearTaskCanTask(true, 3)
end
}, father=23},
    [58]={id=58, name="节日活动其他部分", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot19_4", node_events={

}, events={

}, check_func={
func = function()
return false and g_redDot:isNewyearTaskCanTask(true, 4)
end
}, father=0},
    [59]={id=59, name="背包", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.prop", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={}, check_func={
func = function()
return false
end
}, father=0},
    [60]={id=60, name="政绩宝箱标签红点", type=1, node_path="MenuScene.AchieveMainPanel.m_csNode.box", node_events={
"dialog_open"
}, events={
"match_boxes_changed","zhengji_achieve_refresh","gongxun_achieve_changed"
}, check_func={
func = function()
return g_redDot:hasDepotBoxReward()
end
}, father=1},
    [61]={id=61, name="欢乐活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.activityhappy", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"activity_happyturn_state_changed","activity_activityhappy_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(44) or g_redDot:isCanHappyPlayReward()
end
}, father=0},
    [62]={id=62, name="欢乐活动转盘", type=1, node_path="MenuScene.ActivityPanel.m_csNode.act46", node_events={
"dialog_open"
}, events={
"activity_happyturn_state_changed"
}, check_func={
func = function()
return g_redDot:isCanHappyPlayReward()
end
}, father=0},
    [63]={id=63, name="幸运抽奖", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act43", node_events={
"dialog_open"
}, events={
"prize_draw_item_changed","activity_activity_state_changed"
}, check_func={
func = function()
return g_redDot:isActivityPrizeDrawReward(43)
end
}, father=0},
    [64]={id=64, name="节日活动其他部分", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot19_5", node_events={

}, events={

}, check_func={
func = function()
return false and g_redDot:isNewyearTaskCanTask(true, 5)
end
}, father=0},
    [65]={id=65, name="幸运抽奖", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act37", node_events={
"dialog_open"
}, events={
"prize_draw_item_changed","activity_activity_state_changed"
}, check_func={
func = function()
return g_redDot:isActivityPrizeDrawReward(37)
end
}, father=0},
    [66]={id=66, name="国家阵法", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.zhenfa", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"array_change",
}, check_func={
func = function()
return g_redDot:hasArrayActivation()
end
}, father=0},
    [67]={id=67, name="国家阵法青龙阵", type=1, node_path="MenuScene.CountryArrayPanel.m_csNode.troop1", node_events={
"dialog_open"
}, events={
"array_change",
}, check_func={
func = function()
return g_redDot:hasArrayActivation(1)
end
}, father=66},
    [68]={id=68, name="国家阵法白虎阵", type=1, node_path="MenuScene.CountryArrayPanel.m_csNode.troop2", node_events={
"dialog_open"
}, events={
"array_change",
}, check_func={
func = function()
return g_redDot:hasArrayActivation(2)
end
}, father=66},
    [69]={id=69, name="国家阵法朱雀阵", type=1, node_path="MenuScene.CountryArrayPanel.m_csNode.troop3", node_events={
"dialog_open"
}, events={
"array_change",
}, check_func={
func = function()
return g_redDot:hasArrayActivation(3)
end
}, father=66},
    [70]={id=70, name="国家阵法玄武阵", type=1, node_path="MenuScene.CountryArrayPanel.m_csNode.troop4", node_events={
"dialog_open"
}, events={
"array_change",
}, check_func={
func = function()
return g_redDot:hasArrayActivation(4)
end
}, father=66},
    [71]={id=71, name="主公", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.empero", node_events={"menu_scene_enter", "world_scene_enter"
}, events={
"kingway_refresh", "menu_scene_enter", "world_scene_enter",
"onPlayerLevelChanged",
"nobility_refresh"
}, check_func={
        func = function()
            local show = g_redDot:kingWayCanUp() or g_redDot:mingWangIsCanUp() or  g_redDot:checkNobility()
            return show
        end
    }, father=0},
    [72]={id=72, name="皇宫", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.huanggong", node_events={"menu_scene_enter", "world_scene_enter"
}, events={
"official_change",
}, check_func={
func = function()
return g_redDot:hasOfficialRed()
end
}, father=0},
    [73]={id=73, name="军团", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.family", node_events={"menu_scene_enter", "world_scene_enter"
}, events={
"science_change","rating_change","menu_scene_enter","family_change","family_build_change","family_boss_change","achieve_change","family_strategy_red_dot","family_bonus_change","legion_aboss_change"
}, check_func={
func = function()
return g_redDot:hasFamilyRed()
end
}, father=0},
    [74]={id=74, name="每日讨伐", type=1, node_path="MenuScene.AchieveMainPanel.m_csNode.crusade", node_events={
"dialog_open"
}, events={
"crusade_info_refresh","daily_achieve_changed"
}, check_func={
func = function()
return g_redDot:isCrusadeReward()
end
}, father=1},
    [75]={id=75, name="新春宝箱", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot53", node_events={
"dialog_open"
}, events={
"activity_newyear_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(53)
end
}, father=23},
    [76]={id=76, name="新春祝福", type=1, node_path="MenuScene.ActivityFestivalPanel.m_csNode.reddot54", node_events={
"dialog_open"
}, events={
"activity_newyear_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(54)
end
}, father=23},
    [77]={id=77, name="限时优惠", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.preferential", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"activity_pushgift_state_changed"
}, check_func={
func = function()
return g_redDot:hasNewActReward(55)
end
}, father=0},
    [78]={id=78, name="次周活动", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.cizhouhuodong", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"activity_cizhouhuodong_state_changed"
}, check_func={
func = function()
return g_redDot:hasActTabReward(57) or  g_redDot:hasActTabReward(58) or g_redDot:hasActTabReward(58, true)
end
}, father=12},
    [79]={id=79, name="次周任务", type=1, node_path="MenuScene.ActivitySecondWeekPanel.m_csNode.reddot57", node_events={
"dialog_open"
}, events={
"activity_cizhouhuodong_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(57)
end
}, father=78},
    [80]={id=80, name="次周充值", type=1, node_path="MenuScene.ActivitySecondWeekPanel.m_csNode.reddot58_1", node_events={
"dialog_open"
}, events={
"activity_cizhouhuodong_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(58)
end
}, father=78},
    [81]={id=81, name="次周兑换", type=1, node_path="MenuScene.ActivitySecondWeekPanel.m_csNode.reddot58_2", node_events={
"dialog_open"
}, events={
"activity_cizhouhuodong_state_changed"
}, check_func={
func = function()
return g_redDot:hasActReward(58, true)
end
}, father=78},
    [82]={id=82, name="功能预告1", type=1, node_path="MenuScene.sceneUI.m_csNode.player_info.zhanli.bg_zhanlidi", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"system_open_reward_success",
"new_system_open",
"init_role_info",
"terr_build_info"
}, check_func={
func = function()
return g_redDot:checkFunctionNotice()
end
}, father=0},
    [83]={id=83, name="功能预告2", type=1, node_path="MenuScene.FunctionMainPanel.m_csNode.tep1", node_events={
"dialog_open"
}, events={
"system_open_reward_success",
"new_system_open",
"init_role_info",
"terr_build_info"
}, check_func={
func = function()
return g_redDot:checkFunctionNotice()
end
}, father=82},
    [84]={id=84, name="七日庆典", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.qitianqingdian", node_events={
"menu_scene_enter",
"world_scene_enter"
}, events={
"prize_draw_item_changed",
"activity_activity_state_changed",
"activity_activitysevenday_state_changed",
}, check_func={
func = function()
return g_redDot:isActivityPrizeDrawReward(72)or g_redDot:isCanSevenDayReward()
end
}, father=0},
    [85]={id=85, name="累计消费", type=1, node_path="MenuScene.ActivitySevenDayCelebrationPanel.m_csNode.tep2", node_events={
"dialog_open"
}, events={
"prize_draw_item_changed",
"activity_activity_state_changed",
"activity_activitysevenday_state_changed",
}, check_func={
func = function()
return g_redDot:isCanSevenDayReward(70)
end
}, father=84},
    [86]={id=86, name="每日充值", type=1, node_path="MenuScene.ActivitySevenDayCelebrationPanel.m_csNode.tep4", node_events={
"dialog_open"
}, events={
"activity_activitysevenday_state_changed",
}, check_func={
func = function()
return g_redDot:isCanSevenDayReward(71)
end
}, father=84},
    [87]={id=87, name="庆典转盘", type=1, node_path="MenuScene.ActivitySevenDayCelebrationPanel.m_csNode.tep5", node_events={
"dialog_open"
}, events={
"prize_draw_item_changed",
"activity_activity_state_changed",
"activity_activitysevenday_state_changed",
}, check_func={
func = function()
return g_redDot:isActivityPrizeDrawReward(72)
end
}, father=84},
    [88]={id=88, name="礼包", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.gift", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_gift_state_changed"}, check_func={

func = function()

return g_redDot:acheveTypeHasReward(15,45) or g_redDot:acheveTypeHasReward(16,45) or g_redDot:isHaveGiftDayBox()

end

}, father=12},
    [89]={id=89, name="神兽转盘", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.shenshouzhuanpan", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"prize_draw_item_changed",
"activity_activity_state_changed",
"activity_activityanimal_state_changed",}, check_func={
func = function()
return g_redDot:isAnimalPrizeDrawReward()
end
}, father=0},
    [90]={id=90, name="乱世政令", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.luanshizhengling", node_events={

"menu_scene_enter",

"world_scene_enter"

}, events={"activity_DecreeRefresh"}, check_func={
func = function()
return g_redDot:isDecreeReward()
end
}, father=0},
    [91]={id=91, name="政令任务", type=1, node_path="MenuScene.ActivityDecreeMainPanel.m_csNode.renwu", node_events={
"dialog_open"
}, events={"activity_DecreeRefresh"}, check_func={
func = function()
return g_redDot:isDecreeTaskReward()
end
}, father=90},
    [92]={id=92, name="政令大赏", type=1, node_path="MenuScene.ActivityDecreeMainPanel.m_csNode.dashang", node_events={
"dialog_open"
}, events={"activity_DecreeRefresh"}, check_func={
func = function()
return g_redDot:isDecreeStageReward()
end
}, father=90},
    [93]={id=93, name="勤王殿", type=1, node_path="MenuScene.PalacePanel.m_csNode.tep2", node_events={
"dialog_open"
}, events={"rescue_palace_refresh"}, check_func={
func = function()
return g_redDot:isRescuePalaceRedDot()
end
}, father=0},
    [94]={id=94, name="主公装备", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.lordequip", node_events={"menu_scene_enter", "world_scene_enter","dialog_open"
}, events={"lord_quip_change"}, check_func={
        func = function()
            local show = g_redDot:lordEquipHaveRedDot()
            return show
        end
    }, father=0},
    [95]={id=95, name="神兽", type=1, node_path="MenuScene.sceneUI.m_csNode.panel_btns.mythicalanimals", node_events={"menu_scene_enter", "world_scene_enter","dialog_open"
}, events={"god_beast_change","equip_changed"}, check_func={
        func = function()
            local show = g_redDot:godBeastHaveRedDot()
            return show
        end
    }, father=0},
    [96]={id=96, name="法宝转盘", type=1, node_path="MenuScene.ActivityPanel.m_csNode.buttonList.act52", node_events={
"dialog_open"
}, events={"prize_draw_item_changed","activity_activity_state_changed"}, check_func={
        func = function()
        return g_redDot:isActivityPrizeDrawReward(52)
        end
}, father=0},
    [97]={id=97, name="军团战", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.juntuanzhan", node_events={"menu_scene_enter", "world_scene_enter","dialog_open"
}, events={"science_change"}, check_func={
        func = function()
        return g_redDot:EntrantHasCastRedDot()
        end
}, father=0},
    [98]={id=98, name="皇帝战", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.huangdizhan", node_events={"menu_scene_enter", "world_scene_enter","dialog_open"
}, events={"king_war_change"}, check_func={
        func = function()
        return g_redDot:KingHasCastRedDot()
        end
}, father=0},
    [99]={id=99, name="魔将召唤", type=1, node_path="MenuScene.sceneUI.m_csNode.huodong.redheroturntable", node_events={"menu_scene_enter", "world_scene_enter","dialog_open"
}, events={"activity_activityRed_state_changed"}, check_func={
        func = function()
        return g_redDot:RedHeroRedDot()
        end
}, father=0},
    [100]={id=100, name="武演殿", type=1, node_path="MenuScene.PalacePanel.m_csNode.tep3", node_events={
"dialog_open"
}, events={"competition_honor_refresh"}, check_func={
func = function()
return require("Competition.CompetitionManager"):isHaveHonorRed()
end
}, father=0},
    [101]={id=101, name="官职俸禄", type=1, node_path="MenuScene.MatchOfficePanel.m_csNode.tep1", node_events={
"dialog_open"
}, events={"rank_level_history_change","match_rank_reward_changed",
"match_daily_reward_changed"}, check_func={
func = function()
return g_redDot:isMatchCanReward()
end
}, father=17},
    [102]={id=102, name="赛季累充", type=1, node_path="MenuScene.MatchOfficePanel.m_csNode.tep3", node_events={
"dialog_open"
}, events={"rank_level_history_change","match_rank_reward_changed",
"match_daily_reward_changed"}, check_func={
func = function()
return g_redDot:isMatchSeasonReward()
end
}, father=17},
}
