-- @Author: Su
-- @Date:   2019-06-21 15:44:14
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-21 15:44:14
-- @File Name: ActivityDecreeTaskLvPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local DecreeRewardConfig = require("Metadatas.DecreeRewardConfig")
local ActivityDecreeTaskLvInfo = require("NewActivity.ActivityDecreeTaskLvInfo")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/DecreeTaskLv.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self:refreshList()
end


function This:refreshList()
    local scrollView = self.m_csNode.scrollView
    -- scrollView:setDirection("vertical")
    scrollView.m_direction ="down"
    scrollView:removeAllItems()
    for stage = 1,table.count(DecreeRewardConfig)/2 do
        local item = ActivityDecreeTaskLvInfo:create(DecreeRewardConfig[stage + 1000])
        item:setAnchorPoint(0.5,1)
        -- local w,h = item.bg:getContentSize()
        scrollView:pushBackCustomItem(item,290,30,0.5)
    end

end

function This:onTouchMask()
    self:close()
end