-- @Author: Su
-- @Date:   2019-03-26 18:15:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-03-26 18:15:05
-- @File Name: SevenDayCelebrationRankItem.lua
-- @Description: 

local This, super = class(..., "NodeUI")

function This:initData(info)
    self.m_data = info
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/SevenDayCelebrationRankItem.csb")
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    local node = self.m_csNode
    node.rank:setString(tostring(self.m_data.rank))
    node.familyname:setString(self.m_data.name)
    node.time:setString(string.format( Serialize[62136],self.m_data.value))
end