-- @Author: Su
-- @Date:   2019-03-26 11:15:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-03-26 11:15:05
-- @File Name: SevenDayCelebrationRankPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local SevenDayCelebrationRankItem = require("NewActivity.SevenDayCelebrationRankItem")

function This:initData(info)
    self.m_activity = info.activity
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/SevenDayCelebrationRank.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    local roleInfoList = self.m_activity:getRoleList()
    local scrollView = self.m_csNode.scrollView
    scrollView:setDirection("vertical")
    scrollView.m_direction = "down"
    scrollView:removeAllItems()
    for _,roleInfo in pairs(roleInfoList) do
        local item = SevenDayCelebrationRankItem:create(roleInfo)
        local w,h = item:getContentSize()
        scrollView:pushBackCustomItem(item,404,55,0.5)
    end
    
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end