--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local Vec = require("Vec")
local Parabolic = require("Action.Parabolic")

function This:init(info)
	info.arrowNode = self
	self.m_parabolic = Parabolic:create(info)
	self.m_node = info.node or cc.Sprite:create("WarScene/jian.png")
	self:addChild(self.m_node)
	self:setPosition(info.bx,info.by)	
	self.m_delay = info.delay or 0
	self.m_node:setVisible(false)
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
end

function This:onExit()
	self:unscheduleUpdate()
	super.onExit(self)
end

function This:setEndHandler(handler)
	self.m_endHandler = handler
end

function This:update(dt)
	if self.m_delay > 0 then
		self.m_delay = self.m_delay - dt
		return
	end
	self.m_node:setVisible(true)
	self.m_parabolic:update(dt)
	if self.m_parabolic:isFinish() then
		if self.m_endHandler then
			self.m_endHandler()
		end
		self:removeFromParent()
	end
end

--endregion
