-- @Author: ZYY
-- @Date:   2018-09-26 21:06:56
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 20:14:51
-- @File Name: PeakContestEndPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	self.m_reward = info.reward_list

    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestEnd.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_rewardItemList = {}
	cc.Audio:playEffect("TopArenaLose.mp3")
	self:refresh()
end

function This:refresh()
	for i = 1, 3 do 
		local item = self.m_rewardItemList[i] 
		if not item then 
			item = ItemNode:create(self.m_reward[i].id,self.m_reward[i].num)
			item:setAnchorPoint(0.5,0.5)
			item:setScale(0.8)
			self.m_csNode["item"..i]:addChild(item)
		else
			item:initItem(self.m_reward[i].id,self.m_reward[i].num)
		end
		self.m_rewardItemList[i] = item
	end
end

function This:initTouchEvent()

end

function This:onTouchMask()
	self:close()
end
