--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")

function This:init(info)
	super.init(self)
	self.m_id = info.role_id or info.id
	self.m_rankIndex = info.rank_id
	self.m_rankLv = info.rank or info.rank_level
	self.m_name = info.name
	self.m_icon = info.icon
	self.m_title = info.title
	self.m_effect = info.effect
	self.m_level = info.level
	self.m_power = info.power
	self.m_groupId = info.group_id
	self.m_groupName = info.group_name
	self:setCardList(info.card_list)
end

function This:getId()
	return self.m_id
end

function This:getName()
	return AppText:getServerText(self.m_name)
end

function This:getLevel()
	return self.m_level
end

function This:getIcon()
	return self.m_icon
end

function This:getTitle()
	return self.m_title
end

function This:getEffect()
	return self.m_effect
end

function This:getRankIndex()
	return self.m_rankIndex
end

function This:getRank()
	return self.m_rankLv
end

function This:getPower()
	return self.m_power
end

function This:getGroupId()
	return self.m_groupId
end

function This:getGroupName()
	return self.m_groupName
end

function This:setCardList(cardList)
	self.m_cardList = {}
	for i , info in ipairs(cardList) do
		local t = {}
		t.id = info.card_id
		t.heroId = info.card_type
		t.star = info.star
		t.level = info.level
		t.awake = info.awake
		table.insert(self.m_cardList,t)
	end
end

function This:getCardList()
	return self.m_cardList
end

function This:updateInfo(info)
	self.m_id = info.role_id
	self.m_rankIndex = info.rank_id
	self.m_rankLv = info.rank_level
	self.m_name = info.name
	self.m_icon = info.icon
	self.m_title = info.title
	self.m_effect = info.effect
	self.m_level = info.level
	self.m_power = info.power
	self.m_groupId = info.group_id
	self.m_groupName = info.group_name
	self:setCardList(info.card_list)
end
--endregion
