-- @Author: zheng
-- @Date:   2019-03-16 11:06:52
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-28 20:09:01
-- @File Name: PlayerMarchArmyPathView.lua

local This , super = class(...,"World.MarchArmyPathView")
-- local Vec = require("Vec")
local GamePlayer = require("Player.GamePlayer")
local MarchPaoTuView = require("World.MarchPaoTuView")

function This:init(info)

    self.m_scene = info.effectParent

    local serverTime = GamePlayer:getServerTime()
    self.m_spriteList = {}
    self.m_file = info.file or "Common/yunshu.png"
    -- self.m_marchName = info.marchName or "PaoTu"
    local startTime = info.startTime or serverTime
    local endTime = info.endTime or (serverTime+84000)
    self.m_escape = 0

    local fromView = info.fromNode
    local x1 , y1 = fromView:getPosition()
    local toView = info.toNode
    local x2 , y2 = toView:getPosition()
    -- self.m_sv = cc.Vec(x1,y1)
    -- self.m_ev = cc.Vec(x2,y2)

    local info2 = {startTime = startTime,endTime = endTime,
        toNode = toView,fromNode = fromView,runAnim = info.runAnim,
        configId = info.configId }
    if info.runAnim then
        self:paoMaAction(x1,y1,x2,y2)
    end
    self.m_paoma = MarchPaoTuView:create(info2)
    self.m_scene:addChild(self.m_paoma)
    self.m_paoma:setPosition(0,0)

    self:initMarchPath(self.m_file,x1,y1,x2,y2,nil)
end

function This:getPathImage()
    return self.m_file
end

function This:getMarchName()
    return self.m_marchName
end