-- @Author: zheng
-- @Date:   2019-06-17 20:25:31
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-18 14:03:12
-- @File Name: RoleChangePlayerItemChoiceItemView.lua
-- 10603
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/RoleChangePlayerItemChoiceInfo.csb"
function This:initNode(info)
    self.m_config = info

    -- self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    -- -- self.m_csNode:setToCenter()
    -- self:addChild(self.m_csNode)
    self:refresh()
    local w, h = self.bg:getContentSize()
    self:setContentSize(80,h)
end

function This:refresh()
    local data = self.m_config
    local itemId = data[1]
    local dayNum = data[2] or -1
    self.item1:setScale(0.8)
    GameUtil:creatItemNode(self.item1,{itemId,1},true)
    local dayStr = dayNum.."天"
    if not AppText:isChinese() then
        dayStr = dayNum.."days"
    end
    if dayNum== -1 then
        dayStr = "永久"
        if not AppText:isChinese() then
            dayStr = "Permanent" 
        end
    end

    self:setSelect(false)
    self.day1:setString(dayStr)
end

function This:initTouchEvent()
	
	-- self.bg:setTouch({
 --        onEnded = function()
 --            -- print("buy")
--            if self.m_btnHandle then
--                self.m_btnHandle(self)
--            end
 --        end,
 --        isDynamic = true,
 --        isScale = false,
 --        isSwallow = true
 --    })
 self.bg:setTouch({
        onEnded = function()
            if self.m_btnHandle then
                self.m_btnHandle(self)
            end
        end,
        isSwallow = false,
        isDynamic = true,
        -- name = "city"..self.m_city:getCityId(),
        isScale = false,
        isAlpha = false
    })
end

function This:onEnter()
    super.onEnter(self)
    -- FamilyManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    -- FamilyManager:removeObserver(self)
end

function This:setBtnHandle(btnclick)
    self.m_btnHandle = btnclick
end

function This:setSelect(info)
    self.xuanzhong1:setVisible(info)
end

function This:getId()
    return self.m_config[1]
end
-- function This:getData()
	
-- end