--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

Protocal = setmetatable({}, {
    __index = function (s, k)
        require("Proto." .. k)
        s[k] = package.loaded[k]
        return s[k]
    end
})
package.loaded["protobuf"] = require("Protobuf.protobuf")
assert(Protocal["type_pb"])
assert(Protocal["type2_pb"])
assert(Protocal["legiontype_pb"])

local moduleNames = {
    [100] = "Login_pb",
    [101] = "Scene_pb",
    [102] = "Player_pb",
    [103] = "Fight_pb",
    [104] = "Hero_pb",
    [105] = "Quest_pb",
    [106] = "Bag_pb",
	[107] = "Copy_pb",
	[108] = "Chat_pb",
	[109] = "Friend_pb",
	[110] = "Mail_pb",
	[111] = "Map_pb",
	[112] = "Match_pb",
    [113] = "Shop_pb",
	[114] = "Guide_pb",
    [115] = "Building_pb",
	[116] = "Rank_pb",
	[117] = "Vip_pb",
    [118] = "Recruit_pb",
    [119] = "Achievement_pb",
    [120] = "Activity_pb",
    [121] = "Group_pb",
	[122] = "Competitive_pb",
	[123] = "Awake_pb",
	[124] = "wroldboss_pb",
	[125] = "DailyCopy_pb",
	[126] = "Challenge_pb",
	[127] = "Kingly_pb",
	[128] = "Wash_pb",
	[129] = "SingleDailyCopy_pb",
	--[130] = "LegionMap_pb",
	[131] = "Fatalism_pb",
	[132] = "SuperCompete_pb",
	[133] = "OfficialPosition_pb",
	[135] = "KingWarSignUp_pb",
	[136] = "CampsHalo_pb",
	[137] = "TeamFight_pb",
	[138] = "Towermaster_pb",
	[139] = "Tower_pb",
	[140] = "RescueMap_pb",
	[141] = "Nobilitytitle_pb",
	[142] = "Refinemen_pb",
	[143] = "Monster_pb",
	[144] = "Armytactical_pb",
	[145] = "BetsHonor_pb",
	[146] =	"CrossServerBattle_pb",
	[147] =	"Drum_pb",
	[148] =	"Tactics_pb",
	[149] =	"expedition_pb",
}

function Protocal.getModuleName(protoID)
    local typeID = math.floor(protoID / 100)
	if typeID == 111 then
		if protoID < 11133 then
			return "Map_pb"
		else
			return "Map1_pb"
		end
	elseif typeID == 120 then
		if protoID < 12030 then
			return "Activity_pb"
		elseif protoID < 12064 then
			return "Activity1_pb"
		else
			return "Activity2_pb"
		end
	elseif typeID == 121 then 
		if protoID < 12134 then 
			return "Group_pb"
		else
			return "Group1_pb"
		end
	elseif typeID == 130 then
        if protoID < 13060 then
            return "LegionMap_pb"
        else
            return "LegionMap1_pb"
        end
	elseif typeID == 104 then
		if protoID <10439 then
			return "Hero_pb"
		elseif protoID <10442 then
			return "Fabao_pb"
		elseif protoID <10446 then
			return "hero2_pb"
		elseif protoID <10461 then
			return "Fuwen_pb"
		else
			return "runestone_pb"
		end
	else
		return moduleNames[typeID]
	end
end
--endregion
