--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(..., "Report.ArenaReportView")
local ReportManager = require("Report.ReportManager")
local CityConfig = require("Metadatas.LegionCityConfig")

function This:initCityInfo()
	local cityId = self.m_report:getCityId()
	if cityId > 0 then
		print( cityId )
		self.m_csNode.actionaddress:setString(string.format(Serialize[61798], CityConfig[cityId].city_name))
	end
	self.m_csNode.actionaddress:setVisible(cityId > 0)
end

function This:initTouchEvent()
	self.m_csNode.videotape:setTouch({
		onEnded = function()
			ReportManager:onGetLegionDetailReportRequest(self.m_report:getId())
		end,
		isContainer = true
	})

	self.m_csNode.share:setTouch({
		onEnded = function()
			self:onShareReport()
		end,
		isContainer = true
	})
end


--endregion
