--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.WorldLoadingScene")
local GameEvent = require("Event.GameEvent")
local Socket = require("Net.Socket")
local BattleDataManager = require("Battle.BattleDataManager")

function This:init(msg)
	self.m_battleReport = msg.report
	self.m_playMode = msg.playerMode or PlayMode.kReport
	self.m_attackerHeroAttrList = msg.attack_list or {}
	self.m_defenderHeroAttrList = msg.defence_list or {}
	super.init(self)
end

function This:initTask()
	self:addParseBattleDataTask()
	self:addBattlePrepareTask()
end

function This:addBattlePrepareTask()
	local task10 = GameEvent:create(function()
		BattleDataManager:setBattleId(self.m_battleReport.id)
		BattleDataManager:prepareBattle(false,self.m_playMode)
	end)
	self:addTask(task10)
end


--endregion
