-- @Author: zheng
-- @Date:   2019-03-19 10:41:16
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-04-01 19:00:42
-- @File Name: RescuRewardItemView.lua

local This , super = class(...,"NewActivity.ActivityHappyTurnDayItemView")


function This:initData(info)
    self.m_map = info.map
    super.initData(self,info)
end

function This:onPickUpBtnClick()
    if self:isOpening() then
        self.m_map:onGetBoxRewardRequest(self.m_config.id)
    end
end

function This:refresh(data)
    if data then
        self.m_config = data
    end
    self.numbercishu:setString(self.m_config.prestige_num)
    self:setItemEnable(self:isOpening())
    self.beijing.zhuandong:setImage("RescueKing/wordbingli.png")
end

function This:isOpening()
    return self.m_config and self.m_config.state == RecruitManagerBoxState.kOpen
end

function This:isLocked()
    return self.m_config and self.m_config.state == RecruitManagerBoxState.kLock
end