-- @Author: Su
-- @Date:   2019-03-22 16:25:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-29 15:28:44
-- @File Name: RescueReportItemView.lua
-- @Description: 

local ReportManager = require("Report.ReportManager")
local This, super = class(...,"NodeUI")
This.fileName ="RescueEmperor/RescueEmperorReportDetails.csb"

function This:initData(info)
    self.m_data = info.itemData
    self.m_map = info.map
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local node = self.attacker
    node.actionname:setString(data.name1)
    node.name:setString(data.group1)

    node = self.defence
    node.name:setString(data.name2)
    node.tongmengname:setString(data.group2)

    self.zuigao:setVisible(data.isOther)
    self.andme:setVisible(data.isOur)
end

function This:initTouchEvent()
    self.videotape:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            -- self.m_map:
            ReportManager:onGetRescueDetailReportRequest(self.m_data.attackid)
        end
    })
end

