

--勤王战初始界面

local This, super = class(..., "NodeView")
local GameUtil = require("Util.GameUtil")


function This:initData(info)
	self.m_mainUI = info.mainUI
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorBeforeMain.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.qinwangdian:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRulePanel")
	end)

	-- 勤王殿
	csNode.qinwangdian:setTouchEnded(function()
        g_scene:openDialog("Palace.PalacePanel", {tab = "tep2"})
	end)
end

function This:refresh()

end



