---
---
--- Created by aid.
--- DateTime: 2018/4/18 16:41
---
local M = {}
package.loaded[...] = M

-- Hero.HeroPanel对话框，宿命标签显隐信号
M.HeroPanelFateTabRedDot = {
    id="HeroPanelFateTabRedDot",
    convert=function(data)
        return data
    end,
    handlerList = nil,
    data = nil,
}

-- Family.FamilyPanel对话框，建筑标签页
M.FamilyPanelBuildTabRedDot = {
    id="FamilyPanelBuildTabRedDot",
    convert=function(data)
        return data
    end,
    handlerList = nil,
    data = nil,
}

-- Family.FamilyPanel对话框，活跃标签页
M.FamilyPanelVitalityTabRedDot = {
    id="FamilyPanelVitalityTabRedDot",
    convert=function(data)
        return data
    end,
    handlerList = nil,
    data = nil,
}

-- Family.FamilyPanel对话框，军策标签页
M.FamilyPanelStrategyTabRedDot = {
    id="FamilyPanelStrategyTabRedDot",
    convert=function(data)
        return data.id, data.show
    end,
    handlerList = nil,
    data = nil,
}

M.NetworkResponse12135 = {
    id="NetworkResponse12135",
    convert=function(msg)

        local tick_info = msg.tick_info or msg.tricks_list

        return tick_info.tricks_id, tick_info.soul_num, msg.donation_time, tick_info.state
    end,
    handlerList = nil,
    data = nil,
}

M.NetworkResponse12136 = {
    id="NetworkResponse12136",
    convert=function(msg)
        return msg.tricks_id, msg.add_soul_num, msg.donation_time
    end,
    handlerList = nil,
    data = nil,
}

M.NetworkResponse12139 = {
    id="NetworkResponse12139",
    convert=function(msg)
        return msg.tricks_id, msg.donation_time
    end,
    handlerList = nil,
    data = nil,
}

-- Family.FamilyPanel对话框，内务标签页
M.FamilyPanelAffairsTabRedDot = {
    id="FamilyPanelAffairsTabRedDot",
    convert=function(data)
        return data
    end,
    handlerList = nil,
    data = nil,
}

-- Family.FamilyPanel对话框，内务标签页
M.FamilyPanelSacrifice = {
    id="FamilyPanelSacrifice",
    convert=function(data)
        return data
    end,
    handlerList = nil,
    data = nil,
}

-- TODO 其它信号的定义添加在此



local map = {}
for _, signal in pairs(M) do
    map[signal.id] = signal
end
M.map = map