-- @Author: zheng
-- @Date:   2019-03-19 10:41:16
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-25 10:33:14
-- @File Name: WarRewardItemView.lua

local WarTowerManager = require("SingleDaily.WarTowerManager")

local This , super = class(...,"NewActivity.ActivityHappyTurnDayItemView")


function This:onPickUpBtnClick()
    if self:isOpening() then
        WarTowerManager:onGetBoxRewardRequest(self.m_config.id)
    end
end

function This:refresh(data)
    if data then
        self.m_config = data
    end
    self.numbercishu:setString(self.m_config.integral)
    self:setItemEnable(self:isOpening())
    self.beijing.zhuandong:setImage("MenuScene/wordcishu.png")
end

function This:isOpening()
    return self.m_config and self.m_config.state == RecruitManagerBoxState.kOpen
end

function This:isLocked()
    return self.m_config and self.m_config.state == RecruitManagerBoxState.kLock
end