-- @Author: zheng
-- @Date:   2019-03-19 10:40:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-14 14:41:42
-- @File Name: WarRewardPanel.lua

local strList ={
    title =Serialize[64199],
}

local WarTowerManager = require("SingleDaily.WarTowerManager")
local WarRewardItemView = require("SingleDaily.WarRewardItemView")
-- local RecruitRewardItemView = require("Recruit.RecruitRewardItemView")

local This , super = class(...,"NewActivity.ActivityHappyTurnDayPanel")

function This:initNode(info)
    --基础类尽量不要修改 FamilyRatingRewardPanel,ChallengeTimesRewardPanel,ChallengeTurnDayPanel,RecruitRewardPanel,RescuRewardPanel,WarWeekRewardPanel
    --新的类似界面参考 RecruitRewardPanel
    if info and info.activityType then
        self.m_activityType = info.activityType
    end
    self.m_itemViews = {}
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/DrumTowerTaskTable.csb")
    self:addChild(self.m_csNode)
    self:initCustomUi()
    self.m_csNode:setToCenter()
    self:onGetTurnBox()

end

function This:addManager(  )
    WarTowerManager:addObserver(self)
end

function This:removeManager(  )
    WarTowerManager:removeObserver(self)
end

function This:createItemView( data )
    return WarRewardItemView:create(data)
end

function This:onGetTurnBox()
    self.m_csNode.title:setString(strList.title)
    self.m_itemDataList = WarTowerManager:getRewardList()
    self:refreshRewardList()
end

function This:onGetBoxReward(  )--领取奖励
    self:onGetTurnBox()
end
This.onGetInfo = This.onGetBoxReward