-- @Author: zheng
-- @Date:   2019-11-27 14:33:00
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 17:31:11
-- @File Name: WarTowerRankItemView.lua

local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/DrumFastRankingItem.csb"
function This:initNode(info)
    self.m_data = info
    self:setContentSize(548, 48)
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local name =Serialize[60736]
    local cengNum =""
    local rankData = data.rankData
    if rankData then
        name = rankData.name
        cengNum = rankData.value
    end
    self.rank:setString(data.index)
    self.playername:setString(name)
    self.ceng:setString(cengNum)
    local csNode = self.m_csNode
end

function This:initTouchEvent()
    -- local csNode = self.m_csNode
 --    item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
    self.reward:setTouch({
            isScale = false,
            isDynamic = true,
            isContainer = true,
            onEnded = function()
                 local rewards =self.m_data.config.gift 
                 g_scene:openDialog("SingleDaily.WarTowerRankBoxPanel",rewards)
            end
        })
    -- csNode.close:setTouchEnded(function()
 --        self:close()
 --    end)
end