-- @Author: zheng
-- @Date:   2019-11-28 15:16:13
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-06 16:03:42
-- @File Name: WarTowerSaoDangRewardPanel.lua

local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")
local WarTowerManager = require("SingleDaily.WarTowerManager")
This.fileName = "MenuScene/NodeUI/DrumTowerSweepSettlement.csb"
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_closeFun = info.closeFun
    self.m_lv = info.lv
    --self:getData()
    self:refresh(info.reward)
end

function This:refresh(reward)
    -- local data = self.m_data
    local csNode = self.m_csNode
    local temReward = reward[1]
    if temReward then        

        GameUtil:creatItemNode(csNode.item1,{temReward.id,temReward.num})
    end
    csNode.item1:setVisible(temReward)
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.confirmButton:setTouchEnded(function()
        if self.m_closeFun then
            self.m_closeFun()
        end
        self:close()
    end)
    csNode.reset:setTouchEnded(function()
        WarTowerManager:checkSaoDangBuy(1,self.m_lv)
        self:close()
    end)
    csNode.sweep:setTouchEnded(function()
        WarTowerManager:checkSaoDangBuy(5,self.m_lv)
        self:close()
    end)
end

-- function This:getData()
    
-- end