--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

------------------------------回合伤害型BUFF---------------------------

local This , spuer = class(...,"Skill.BuffState")

local Templates = 
{
	--灼烧
	[BuffKind.kCalcination] = function (config,attackInfo)
		local receiver = attackInfo.receiver
		if attackInfo.damageType == DamageType.kPhyDamage then
			local value = receiver:getAttr(AttrType.kPhyAttack) * config.percent
			local curValue = receiver:reduceAttr(AttrType.kHp,value)
			print(string.format("灼烧：%d->%d",value,curValue))
		elseif attackInfo.damageType == DamageType.kMagicDamage then
			local value = receiver:getAttr(AttrType.kMagicAttack) * config.percent
			local curValue = receiver:reduceAttr(AttrType.kHp,value)
			print(string.format("灼烧：%d->%d",value,curValue))
		end
	end
}

function This:work()
	local config = self:getConfig()
	local attackInfo = self:getAttackInfo()
	local receiver = attackInfo.receiver

	local buff = receiver:getBuff(self:getId())
	if buff == nil then
		local view = receiver:getView()
		if view then
			view:addBuffEffect(self,config.effect,true)
			self:playSound()
		end
		receiver:addBuff(self)
		self.m_state = BuffState.Running
	else
		buff:addRoundCount(self:getRoundCount())
	end
end

function This:stop()
	if self.m_state ~= BuffState.Stop then
		self.m_state = BuffState.Stop
		print(string.format("%s 停止...",BuffClass[self:getType()].name))
		local attackInfo = self:getAttackInfo()
		local receiver = attackInfo.receiver

		local view = receiver:getView()
		if view then
			view:removeBuffEffect(self)
		end

		receiver:removeBuff(self)
	end
end

function This:receiverEnterAttack(receiver)
	local attackInfo = self:getAttackInfo()
	if attackInfo.receiver ~= receiver then
		return
	end

	local config = self:getConfig()
	local func = Templates[config.type]

	if func then
		func(config,attackInfo)
	end

	self.m_roundCount = self.m_roundCount - 1
	if self.m_roundCount <= 0 then
		self:stop()
	end
end

--endregion
