--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

-----------------------------瞬时型buff-------------------------
local This , super = class(...,"Skill.BuffBase")
local Tempaltes = {
 [BuffKind.kRecoverAnger] = function (config,attackInfo)
	local receiver = attackInfo.receiver
	local anger = config.percent
	receiver:addAttr(AttrType.kAngerValue,anger)
 end,
 [BuffKind.kPurificate] = function (config,attackInfo)
	local receiver = attackInfo.receiver
	local buffs = receiver:getBuff()
	for i , buff in pairs(buffs) do
		if buff:isDebuff() then
			buff:stop()
		end
	end
 end,
 --治疗
 [BuffKind.kTreatment] = function (config,attackInfo)
	local attacker = attackInfo.attacker
	local receiver = attackInfo.receiver
	local attribute = attacker:getAttribute()
	if attackInfo.damageType == DamageType.kPhyDamage then
		local hpAddRatio = attribute:getAttr(AttrType.kHpAddRatio)
		local hp = attribute:getAttr(AttrType.kPhyAttack) * config.percent * (1 + hpAddRatio)
		receiver:addAttr(AttrType.kHp,hp)
	elseif attackInfo.damageType == DamageType.kMagicDamage then
		local hpAddRatio = attribute:getAttr(AttrType.kHpAddRatio)
		local hp = attribute:getAttr(AttrType.kMagicAttack) * config.percent * (1 + hpAddRatio)
		receiver:addAttr(AttrType.kHp,hp)
	end
 end,
 [BuffKind.kWeakenAnger] = function (config,attackInfo)
	local receiver = attackInfo.receiver
	local anger = config.percent * attackInfo.totalDamage
	receiver:addAttr(AttrType.kAngerValue,anger)
 end,
 [BuffKind.kToDisperse] = function (config,attackInfo)
	local receiver = attackInfo.receiver
	local buffs = receiver:getBuff()
	for i , buff in pairs(buffs) do
		if buff:isBuff() then
			buffs:stop()
		end
	end
 end
}

function This:work()
	local config = self:getConfig()
	local attackInfo = self:getAttackInfo()
	local func = Tempaltes[config.type]
	if func then
		func(config,attackInfo)
	else
		assert(false,"can not find the func")
	end
	local receiver = self:getReceiver()
	local view = receiver:getView()
	if view then
		view:addBuffEffect(self,config.effect,false)
		self:playSound()
	end
end

--endregion
