--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

---------------------------------------持续状态型buff----------------------------------

local This , super = class(...,"Skill.BuffBase")

local Templates = 
{
	[BuffKind.kBardArmor] = 
	{
		attach = function (config,attackInfo)
			local value = config.percent
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kPhyDamageReduceRatio,value)
		end,
		disattach = function (config,attackInfo)
			local value = config.percent
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kPhyDamageReduceRatio,value)
		end,
	},
	[BuffKind.kAcePack] = 
	{
		attach = function (config,attackInfo)
			local value = config.percent
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kMagicDamageReduceRatio,value)
		end,
		disattach = function (config,attackInfo)
			local value = config.percent
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kMagicDamageReduceRatio,value)
		end,
	},
	[BuffKind.kFlyGeneral]=
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kIsImmuneDebuff,1)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kIsImmuneDebuff,1)
		end
	},
	[BuffKind.kInvincible] =
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kIsImmuneDamage,1)
			receiver:addAttr(AttrType.kIsImmuneDebuff,1)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kIsImmuneDamage,1)
			receiver:reduceAttr(AttrType.kIsImmuneDebuff,1)
		end,	
	},
	[BuffKind.kDevilSeeks] = 
	{
		attach = function (config, attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:addAttr(AttrType.kMagicDamageAddRatio,value)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:reduceAttr(AttrType.kMagicDamageAddRatio,value)
		end
	},
	[BuffKind.kHappeneth] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:addAttr(AttrType.kPhyDamageAddRatio,value)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:reduceAttr(AttrType.kPhyDamageAddRatio,value)
		end
	},
	[BuffKind.kEncouraging] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:addAttr(AttrType.kBothDamageAddRatio,value)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:reduceAttr(AttrType.kBothDamageAddRatio,value)
		end
	},
	[BuffKind.kResistEnemy] =
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:addAttr(AttrType.kCritRatio,value)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:reduceAttr(AttrType.kCritRatio,value)
		end
	},
	[BuffKind.kEaseFatigue] =
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:addAttr(AttrType.kDodge,value)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:reduceAttr(AttrType.kDodge,value)
		end
	},
	[BuffKind.kSeeThrough] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:addAttr(AttrType.kPenetrate,value)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local value = config.percent
			receiver:reduceAttr(AttrType.kPenetrate,value)
		end
	},
	[BuffKind.kDizziness] = 
	{
		attach = function (config, attackInfo)
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kIsCanCastSkill,1)
			receiver:addAttr(AttrType.kIsCanCommonAttack,1)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kIsCanCastSkill,1)
			receiver:reduceAttr(AttrType.kIsCanCommonAttack,1)
		end
	},
	[BuffKind.kConstraint] =
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kIsCanCommonAttack,1)
		end	,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kIsCanCommonAttack,1)			
		end
	},
	[BuffKind.kSilence] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kIsCanCastSkill,1)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kIsCanCastSkill,1)	
		end
	},
	[BuffKind.kBlockAnger] =
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:addAttr(AttrType.kIsCanRecoverAnger,1)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			receiver:reduceAttr(AttrType.kIsCanRecoverAnger,1)
		end
	},
	[BuffKind.kSeriouslyInjured] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kHpAddRatio,percent)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kHpAddRatio,percent)
		end
	},
	[BuffKind.kSunderArmor] = 
	{
		attach = function (config, attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kPhyDamageReduceRatio,percent)
		end,
		disattach = function (config, attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kPhyDamageReduceRatio,percent)
		end
	},
	[BuffKind.kBreakStratagem] = 
	{
		attach = function (config, attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kMagicDamageReduceRatio,percent)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kMagicDamageReduceRatio,percent)
		end
	},
	[BuffKind.kWeaken] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kBothDamageReduceRatio,percent)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kBothDamageReduceRatio,percent)
		end
	},
	[BuffKind.kTurnCripple] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kPhyDamageAddRatio,percent)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kPhyDamageAddRatio,percent)
		end
	},
	[BuffKind.kFoolCrossbow] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kMagicDamageAddRatio,percent)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kMagicDamageAddRatio,percent)
		end
	},
	[BuffKind.kBluntness] = 
	{
		attach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:reduceAttr(AttrType.kBothDamageAddRatio,percent)
		end,
		disattach = function (config,attackInfo)
			local receiver = attackInfo.receiver
			local percent = config.percent
			receiver:addAttr(AttrType.kBothDamageAddRatio,percent)
		end
	}
}

function This:work()
	local config = self:getConfig()
	local attackInfo = self:getAttackInfo()
	local receiver = attackInfo.receiver

	local buff = receiver:getBuff(self:getId())
	if buff == nil then
		local view = receiver:getView()
		if view then
			view:addBuffEffect(self,config.effect,true)
			self:playSound()
		end
		if Templates[config.type] then
			local func = Templates[config.type].attach
			func(config,attackInfo)
		end
		receiver:addBuff(self)
		self.m_state = BuffState.Running
	else
		buff:addRoundCount(self:getRoundCount())
	end
end

function This:stop()
	if self.m_state ~= BuffState.Stop then
		print(string.format("%s停止...",BuffClass[self:getType()].name))
		self.m_state = BuffState.Stop
		local config = self:getConfig()
		local attackInfo = self:getAttackInfo()
		local receiver = attackInfo.receiver
		local view = receiver:getView()
		if view then
			view:removeBuffEffect(self)
		end

		if Templates[config.type] then
			local func = Templates[config.type].disattach
			if func == nil then
				assert(false)
			end
			func(config,attackInfo)
		end
		receiver:removeBuff(self)
		self.m_state = BuffState.Stop
	end
end

function This:receiverEnterAttack(receiver)
	local attackInfo = self:getAttackInfo()
	if attackInfo.receiver ~= receiver then
		return
	end
	self.m_roundCount = self.m_roundCount - 1
	if self.m_roundCount <= 0 then
		self:stop()
	end
end

--endregion
