--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...,"Skill.SkillSpecial")
local BuffConfig = require("Metadatas.BuffConfig")
local BattleDataManager = require("Battle.BattleDataManager")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")

function This:active(endHandler)
	self.m_state = SkillState.ACTIVE
	local view = self.m_troops:getView()
	if view then
		view:skillActived(self,endHandler)
	else
		endHandler()
	end
end

function This:attack(target,effect,hitHandler,hitEndHandler)
	local view = target:getView()
	local effectFile = EffectTimeConfig[effect.effectId].effect
	if view and effectFile and effectFile ~= ""  then
		view:addSkillEffect(self,effect.effectId,hitHandler,hitEndHandler)
	else 
		hitHandler()
		hitEndHandler()
	end
end

--endregion
