--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Skill.SkillCommon")
local BattlePlayer = require("Battle.BattlePlayer")

function This:work(effectList)
	local function hitEndHandler()
		self.m_troops:back(isNeedBack)
	end
	if #effectList <= 0 then
		hitEndHandler()
		return
	end

	local index = 1
	local function applyEffect()
		if index <= #effectList then
			local effect = effectList[index]
			index = index + 1
			if effect.effectResult == 0 then
				local callbackCount , callbackTotal = 0 , 0
				local function handler()
					callbackCount = callbackCount + 1
					if callbackCount == callbackTotal then
						applyEffect()
					end
				end
				for i , hitInfo in ipairs(effect.target) do
					callbackTotal = callbackTotal + 1
					local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
					if target and target:getState() ~= TroopsState.kDead then
						target:hitted(hitInfo,self.m_troops,handler)
					else
						handler()
					end
				end
			else
				self.m_troops:lostEffect(effect)
				applyEffect()
			end
		else
			hitEndHandler()
		end
	end

	local targetList = {}
	for i , effect in ipairs(effectList) do
		if effect.effectResult == 0 then
			for i , hitInfo in ipairs(effect.target) do
				local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
				if target and target:getState() ~= TroopsState.kDead then
					table.insert(targetList,target)
				end
			end
		end
	end

	self.m_troops:attack(targetList,applyEffect)
end

--endregion
