-- @Author: zheng
-- @Date:   2018-08-14 17:04:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-08-21 20:09:46
-- @File Name: ChallengeItemPanel.lua


local This , super = class(...,"Dialog")
local ChallengeStageManager = require("Stage.ChallengeStageManager")

local ChallengeChapterItemView = require("Stage.ChallengeChapterItemView")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarMapItem.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
end

function This:onEnter()
	super.onEnter(self)
	ChallengeStageManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ChallengeStageManager:removeObserver(self)
end

function This:initTouchEvent()
	self.m_closeBtn:setTouchEnded(function ()
		self:close()
	end)
	self.m_rightBtn:setTouchEnded(function()
		self:onNextChapter()
	end)
	self.m_leftBtn:setTouchEnded(function()
		self:onPreChaper()
	end)
	self.m_pageView:addEventListener(function (eventType)
		local index = self.m_pageView:getCurrentPageIndex()
		self:focusePageOnIndex(index)
	end)

	self.m_csNode.buyvigorbutton:setTouchEnded(function()
		g_scene:handleErrorCode("powerLack", {notips=true})
	end)

	self.m_csNode.visitNode.touxiangbg:setTouchEnded(function()
        g_scene:openDialog("Stage.StageVisitHeroPanel", self.m_chapter)
	end)
end
