-- @Author: superm
-- @Date:   2018-04-08 15:11:20
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-05 15:07:23
-- @File Name: StoreArenaModel.lua
-- @Description: 

local This , super = class(...,"Store.StoreBaseModel")
local StoreSlotArenaModel = require("Store.StoreSlotArenaModel")

function This:create(...)
    local ret = {}
    setmetatable(ret,self)
    ret:init(...)
    return ret
end

function This:beforeEndUpdate()
end

function This:initConfigData()
end

function This:initBaseData( info )
    super.initBaseData(self, info)
    self.m_endTime = 0
end

function This:getUITypeName()
end

function This:updateSlot(slotInfo)
    if slotInfo and slotInfo.index then 
        local index = slotInfo.index
        local slot = self.m_objects[index]
        if not slot then
            slot = StoreSlotArenaModel:create(slotInfo)
            slot:setStore(self)
            self.m_objects[index] = slot
        else
            slot:updateInfo(slotInfo)
        end
    end
end

function This:clearAllSlotView()
    for _, slot  in pairs(self.m_objects) do
        slot:setView()
    end
end