-- @Author: superm
-- @Date:   2018-12-03 10:39:41
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-10 17:44:56
-- @File Name: StoreSlotLegionModel.lua
-- @Description: 

local This , super = class(...,"Store.StoreSlotBaseModel")

function This:initSelf( info )
    self.m_storeType = info.shop_type
    self.m_buyTime = info.buy_times or 0
    if info.config then
        self.m_config = info.config 
    end
    self.m_ID = self.m_config.id
end

function This:setBuyTime(value)
	if value then
    	self.m_buyTime = value
    end
end

function This:getItemNum()
    if self.m_config then
        return self.m_config.item_num
    end
    return 0
end


function This:getItemId()
    if self.m_config then
        return self.m_config.item_id
    end
    return 0
end

function This:getCondition()
	return TerrConditionType.kNone, 0
end

function This:getPriceType()
    if self.m_config then
        return self.m_config.cost_type
    end
    return 0
end

function This:getPrice()
    if self.m_config then
        return self.m_config.price
    end
    return 0
end


function This:getMaxBuyTime()
    if self.m_config and self.m_config.limit_time then
        return self.m_config.limit_time
    end
    return 1
end