--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")

function This:init()
	self:setPercent(0)
	self.m_prePoint = nil
end

function This:initTouchEvent()
	self.btn:setTouch({
		onBegan = function(_,touch)
			local boundBox = self.btn:getBoundingBox()
			if boundBox:isContainsXY(touch.x,touch.y) then
				self.m_prePoint = {x = touch.x, y = touch.y}
				return true
			end
			return false
		end,
		onMoved = function(_,touch)
			local dx = touch.x - self.m_prePoint.x
			local x = self.btn:getPositionX()
			local w = self.bar:getContentWidth() * self.bar:getScaleX()
			local bx = self.bar:getPositionX()
			self:setPercent((x + dx - bx) / w)
			self.m_prePoint = {x = touch.x, y = touch.y}
		end,
		onEnded = function(_,touch)
			self.m_prePoint = nil
		end,
		isDynamic = true,
		isScale = false,
	})
end

function This:setSilderHandler(handler)
	self.m_silderHandler = handler
end

function This:setPercent(percent , ifDoHandler)
	percent = math.min(math.max(0,percent),1)
	if self.m_silderHandler then
		if ifDoHandler == nil or not ifDoHandler then
			percent = self.m_silderHandler(percent)
		end
		local w = self.bar:getContentWidth() * self.bar:getScaleX()
		local x = self.bar:getPositionX()
		self.btn:setPositionX(x + w * percent)
		self.bar:setPercent(percent * 100)
		print("percent:", percent)
	end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end


--endregion
