--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...)

function This:init()
	self.m_templete = {}
    self.m_panels = {}
end

function This:addTemplete(templete)
	local name = templete._NAME
	self.m_templete[name] = templete
end

function This:addPanel(panel)
   table.insert(self.m_panels,panel)
end

function This:removePanel(panel)
   for i , pnl in pairs(self.m_panels) do
      if panel == pnl then
         table.remove(self.m_panels,i)
         break
      end
   end
end

function This:getPanel(name)
	for i , panel in pairs(name) do
		if panel._NAME == name then
			return panel
		end
	end
end

function This:isPanelOpen(name)
	for i , panel in pairs(self.m_panels) do
		if panel._NAME == name then
			return true
		end
	end
end

function This:closePanel(name)
	for i = #self.m_panels , 1 , -1 do
		local panel = self.m_panels[i]
		if panel._NAME == name then
			panel:close()
			table.remove(self.m_panels,i)
		end
	end
end

function This:showPanel(name,...)
	local isFind = false
	for i = #self.m_panels , 1 , -1 do
		local panel = self.m_panels[i]
		if panel._NAME == name then
			if isFind == false then
				panel:refresh(...)
				isFind = true
			else
				panel:close()
				table.remove(self.m_panels,i)
			end
		end
	end
	if isFind == false then
		local templete = self.m_templete[name]
		if templete then
			local panel = templete:create(...)
			panel:show()
		end
	end
end

--endregion
