--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local GameUtil = require("Util.GameUtil")

local effectName = {
"QingLong","Huoshao","Zhiliao","Jinghua","HuXiao","LongQiang","Chongfeng","SiFangZhan"
				,"Nuhou","DaoGuang","XiangTa","WanJian","LiPi","BingCi","YunShi","ShuiZhen","Lei","LiaoYuan","XingYunJi"
				,"AnSha","Huo","Hua","Bagua","HeiDong","BingCi","GuiShou","JiuXingZhu","YueLuo","XingLuo","FuBao"
}


function This:test()
	local index = 1
	local time = 0
	local writePath = cc.FileUtils:getWritablePath() .. "Data/time.txt"
	local file = io.open(writePath,"w+")

	local function showEffect()
		if index <= #effectName then
			local name = effectName[index]
			local eff 
			eff = GameUtil:createEffect(name,false,nil,{
				onAnimationComplete = function(_,animation)
					local et = os.clock()
					file:write( string.format("%s:%f\n",name,(et - time)))
					index = index + 1
					eff:removeFromParent()
					showEffect()
				end
			})
			eff:setPosition(cc.visible.center.x,cc.visible.center.y)
			g_scene:addChild(eff)
			time = os.clock()
		else
			file:close()
		end
	end
	showEffect()
end

--endregion
