-- @Author: superm
-- @Date:   2018-12-25 16:53:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-30 17:47:02
-- @File Name: WarTowerBattleInfo.lua
-- @Description: 

local This = class(..., "Warfare.TowerBattleInfo")
local GameUtil = require("Util.GameUtil")
local TowerManager = require("SingleDaily.WarTowerManager")
local BattleDataManager = require("Battle.BattleDataManager")

function This:onShowBattleResult(victory)
    if self.m_reportList then
        BattleDataManager:removeObserver(self)
        if self.m_isWin then
        	TowerManager:onBattleVictory(self.m_team)
        else
			TowerManager:onBattleFailed(self.m_team)
        end
        self:clear()
    end
end