-- @Author: superm
-- @Date:   2018-08-21 09:54:03
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-21 10:50:55
-- @File Name: WarfareHeroItemView.lua
-- @Description: 

local This , super = class(...,"Stage.StageHeroItemView")

function This:init(heroId, info)
	super.init(self, heroId, info)
	self.m_maskHandler = info.mask
	self:initMaskLayer()
end

function This:initMaskLayer()
	if self.m_maskHandler then
		self.m_hasMask = not self.m_maskHandler(self.m_heroId)
	    self.m_maskLayer = cc.LayerColor:create(cc.Color(0, 0, 0, 180))
    	self.m_maskLayer:setVisible(self.m_hasMask)
	    self:addChild(self.m_maskLayer)
	    
	    self.m_maskLayer:setContentSize(125, 186)
	    self.m_maskLayer:setPosition(-1, -21)
	end
end

function This:refreshAttr()
	super.refreshAttr(self)
	if self.m_maskHandler then 
		self.m_hasMask = not self.m_maskHandler(self.m_heroId)
	    self.m_maskLayer:setVisible(self.m_hasMask)
	end
end