--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ResourceConfig = require("Metadatas.ResourceConfig")
local GameUtil = require("Util.GameUtil")

function This:initNode(city)
	self.m_city = city
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BulidIList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	local cost = ResourceConfig[1].cost
	local time = ResourceConfig[1].time

	self.m_csNode.homecost:setString(cost)
	self.m_csNode.hometime:setString(GameUtil:formatTime(Serialize["H_M_S"],time))

	self.m_csNode.shopcost:setString(cost)
	self.m_csNode.shoptime:setString(GameUtil:formatTime(Serialize["H_M_S"],time))

	self.m_csNode.croplandcost:setString(cost)
	self.m_csNode.croplandtime:setString(GameUtil:formatTime(Serialize["H_M_S"],time))
end

function This:setCreateHandle(handler)
	self.m_createHandler = handler
end

function This:initTouchEvent()
	self.m_csNode.homebutton:setTouchEnded(function()
		self.m_createHandler(BuildType.kDwelling,false)
		self:close()
	end)
	self.m_csNode.dessss:setTouchEnded(function()
		self.m_createHandler(BuildType.kDwelling,true)
		self:close()
	end)
	self.m_csNode.shopbutton:setTouchEnded(function()
		self.m_createHandler(BuildType.kMarket,false)
		self:close()
	end)
	self.m_csNode.shopmostbutton:setTouchEnded(function()
		self.m_createHandler(BuildType.kMarket,true)
		self:close()
	end)
	self.m_csNode.croplandbutton:setTouchEnded(function()
		self.m_createHandler(BuildType.kFarmland,false)
		self:close()
	end)
	self.m_csNode.croplandmostbutton:setTouchEnded(function()
		self.m_createHandler(BuildType.kFarmland,true)
		self:close()
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

--endregion
