--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local WorldMapManager = require("World.WorldMapManager")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
	self.m_coin = info.coin or 0
	self.m_food = info.food or 0
	self.m_cityNum = info.city_num or 0
	if not info.chicken_dinner then
		self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ForceLose.csb")
	else
		self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Forcewin.csb")
	end
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	if info.isGuide then
		info.name = Serialize["Guide-Hero-Name"]
		info.city_name = Serialize["Guide-City-Name"]
	end
	self.m_loserName = info.name
	self.m_winerName = info.kill_name
	self.m_cityName = info.city_name

	self.m_csNode.losename:setString(self.m_loserName)
	self.m_csNode.maincity:setString(string.format(Serialize[64916],self.m_cityName))
	self.m_csNode.winname:setString(self.m_winerName)
	self.m_csNode.citynum:setString(self.m_cityNum)
	self.m_csNode.moneynum:setString(self.m_coin)
	self.m_csNode.foodmun:setString(self.m_food)
end

function This:onEnter()
    super.onEnter(self)
    self.m_csNode:playCSAnimation("Start",false)
end


function This:onTouchMask()
	self:close()
end

--endregion
