--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.WorldStratagem")
local WorldMapManager = require("World.WorldMapManager")
local GamePlayer = require("Player.GamePlayer")

function This:init()
	super.init(self,{id = JiCeType.kQianDuLing})
end

function This:isCanUseWithoutCD(city)
	local result , season = super.isCanUseWithoutCD(self,city)
	if not result then
		return result, season
	end
	if not city:isMy() then
		return false, Serialize["world_StgCM_1"]
	end
	if WorldMapManager:isInProtected() then
		return false, Serialize["world_StgCM_2"]
	end
	if city:isFighting() then
		return false, Serialize["world_StgCM_3"]
	end
	if city:isMainCity() then
		return false, Serialize["world_StgCM_4"]
	end
	
	local role = WorldMapManager:getRole(GamePlayer:getPlayerID())
	local mainCity = WorldMapManager:getCity(role:getMainCity())
	if mainCity:isFighting() then
		return false, Serialize["world_StgCM_5"]
	end

	if self.m_useCount >= self.m_config.limit then
		return false, Serialize["world_StgCM_6"]
	end
	return true
end

function This:isCanUse(city)
	local result , season = self:isCanUseWithoutCD(city)
	if not result then
		return result, season
	end
	if self:getLeftUseCD() > 0 then
		return false, Serialize["world_StgCM_7_c"]
	end
	return true
end

function This:use(city)
	super.use(self,city)
	local role = WorldMapManager:getMainRole()
	self.m_oldMainCityId = role:getMainCity()
end

--[[function This:addCity(cityId,startTime,endTime)
	super.addCity(self,cityId,startTime,endTime)
	local oldView = g_scene:getCityView(self.m_oldMainCityId)
	oldView:refreshMainCityEffect()
	self.m_oldMainCityId = nil
	local newView = g_scene:getCityView(cityId)
	newView:refreshMainCityEffect()
end]]

function This:onUseJiceReply(msg)
	if msg.err_code == 0 then

	end
end

--endregion
