--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.WorldStratagem")
local WorldMapManager = require("World.WorldMapManager")


function This:init()
	super.init(self,{id = JiCeType.kDongRuoGuanHuo})
end

function This:isCanUseWithoutCD(city)
	local result , season = super.isCanUseWithoutCD(self,city)
	if not result then
		return result, season
	end
	if city:isFighting() then
		return false, Serialize["world_StgDRGH_1"]
	end
	if city:isOur() then
		return false, Serialize["world_StgDRGH_2"]
	end
	return true
end

function This:isCanUse(city)
	local result , season = self:isCanUseWithoutCD(city)
	if not result then
		return result, season
	end
	if self:getLeftUseCD() > 0 then
		return false, Serialize["world_StgCM_7_c"]
	end
	return true
end

function This:addCity(cityId,startTime,endTime)
	super.addCity(self,cityId,startTime,endTime)
	local city = WorldMapManager:getCity(cityId)
	city:setIsAdvanceInvestigated(true)
end

function This:removeCity(cityId)
	super.removeCity(self,cityId)
	local city = WorldMapManager:getCity(cityId)
	city:setIsAdvanceInvestigated(true)
end

--endregion
