--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.WorldStratagem")
local WorldMapManager = require("World.WorldMapManager")

function This:init()
	super.init(self,{id = JiCeType.kQiMenBaGua})
end

function This:isCanUseWithoutCD(city)
	local result , season = super.isCanUseWithoutCD(self,city)
	if not result then
		return result, season
	end
	if not city:isOur() then
		return true
	elseif city:isImprisoned() then
		return true
	end
	return false, Serialize["world_StgQMBG_1"]
end

function This:isCanUse(city)
	local result , season = self:isCanUseWithoutCD(city)
	if not result then
		return result, season
	end
	if self:getLeftUseCD() > 0 then
		return false, Serialize["world_StgCM_7_c"]
	end
	return true
end

function This:addCity(cityId,startTime,endTime)
	super.addCity(self,cityId,startTime,endTime)
	local city = WorldMapManager:getCity(cityId)
	city:setIsImprisoned(true) 
	if g_scene:getName() == "WorldScene" then
		local view = g_scene:getCityView(cityId)
		if view then
			view:refreshImprisonedEffect()
		end
	end
end

function This:removeCity(cityId)
	super.removeCity(self,cityId)
	local city = WorldMapManager:getCity(cityId)
	city:setIsImprisoned(false)
	if g_scene:getName() == "WorldScene" then
		local view = g_scene:getCityView(cityId)
		if view then
			view:refreshImprisonedEffect()
		end
	end
end




--endregion
