-- @Author: superm
-- @Date:   2018-07-25 15:44:07
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-16 16:37:48
-- @File Name: WorldBossUtil.lua
-- @Description: 

local This = class(...)

WorldBossState = {
	kNone		= 1,	--不存在
	kPrepare 	= 2,	--非活动, 无敌
	kActive 	= 3,	--活动，非战斗
	kFighting	= 4,	--活动，战斗
	kDeath 		= -1,	--死亡
	kInvisible	= 0,	--非活动，没死亡
}

WorldBossRewardType = {
	kRank	= 1,
	kSlain 	= 2,
}

-- 购买一次技能消耗的元宝
kWorldBossBuySkillCost = 200
