local This = class(...)
local lib_audio = lib2d.ccAndroidAudio
function This:init()

end

function This:playBackground(name)
    return lib_audio.playMusic(name, true, 1)
end

function This:stopBackground()
    lib_audio.stopMusic()
end

function This:pauseBackground(id)
    lib_audio.pauseMusic(id)
end

function This:resumeBackground(id)
    lib_audio.resumeMusic(id)
end

function This:preloadBackground(name)
    -- lib_audio.loadMusic("Sounds/" .. name)
end

function This:pauseAllEffect()
    lib_audio.pauseAllSound()
end

function This:resumeAllEffect()
    lib_audio.resumeAllSound()
end

function This:preloadEffect(name)
    lib_audio.loadSound(name, 0)
end

function This:playEffect(name, isLoop, rate)
	print("android播放音效:%s",name)
    return lib_audio.playSound(name, 0, isLoop and -1 or 0, rate or 1)
end

function This:stopEffect(id)
    lib_audio.stopSound(id)
end
-- function This:stopAllLoopEffect()
-- function This:pauseAll()
-- function This:resumeAll()
-- function This:playEffectLimit(name, volume)