local This = class(...)

local lib2d = lib2d
function This:init()
    self[0] = lib2d.ccSimpleAudioEngine.getInstance()
end

function This:playBackground(name)
    lib2d.ccSimpleAudioEngine.playBackgroundMusic(self[0], "Sounds/" .. name, true)
    return name
end

function This:stopBackground(id)
    lib2d.ccSimpleAudioEngine.stopBackgroundMusic(self[0])
end

function This:pauseBackground(id)
    lib2d.ccSimpleAudioEngine.pauseBackgroundMusic(self[0])
end

function This:resumeBackground(id)
    lib2d.ccSimpleAudioEngine.resumeBackgroundMusic(self[0])
end

function This:preloadBackground(name)
    lib2d.ccSimpleAudioEngine.preloadBackgroundMusic(self[0], "Sounds/" .. name)
end

-- function This:playEffect(name)
function This:playEffect(name, isLoop, rate)
    return lib2d.ccSimpleAudioEngine.playEffect(self[0], "Sounds/" .. name, isLoop or false, 1, 0, rate or 1)
end

function This:pauseAllEffect()
    lib2d.ccSimpleAudioEngine.pauseAllEffects(self[0])
end

function This:resumeAllEffect()
    lib2d.ccSimpleAudioEngine.resumeAllEffects(self[0])
end

function This:preloadEffect(name)
    lib2d.ccSimpleAudioEngine.preloadEffect(self[0], "Sounds/" .. name)
end

function This:stopEffect(id)
    lib2d.ccSimpleAudioEngine.stopEffect(self[0], id)
end

-- function This:stopAllLoopEffect()
-- function This:pauseAll()
-- function This:resumeAll()
-- function This:playEffectLimit(name, volume)